/* book-view.c generated by valac 0.42.6, the Vala compiler
 * generated from book-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/* FIXME: When scrolling, copy existing render sideways?*/
/* FIXME: Only render pages that change and only the part that changed*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_BOOK_VIEW (book_view_get_type ())
#define BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK_VIEW, BookView))
#define BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK_VIEW, BookViewClass))
#define IS_BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK_VIEW))
#define IS_BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK_VIEW))
#define BOOK_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK_VIEW, BookViewClass))

typedef struct _BookView BookView;
typedef struct _BookViewClass BookViewClass;
typedef struct _BookViewPrivate BookViewPrivate;

#define TYPE_BOOK (book_get_type ())
#define BOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK, Book))
#define BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK, BookClass))
#define IS_BOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK))
#define IS_BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK))
#define BOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK, BookClass))

typedef struct _Book Book;
typedef struct _BookClass BookClass;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
enum  {
	BOOK_VIEW_0_PROPERTY,
	BOOK_VIEW_BOOK_PROPERTY,
	BOOK_VIEW_SELECTED_PAGE_PROPERTY,
	BOOK_VIEW_X_OFFSET_PROPERTY,
	BOOK_VIEW_NUM_PROPERTIES
};
static GParamSpec* book_view_properties[BOOK_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	BOOK_VIEW_PAGE_SELECTED_SIGNAL,
	BOOK_VIEW_SHOW_PAGE_SIGNAL,
	BOOK_VIEW_SHOW_MENU_SIGNAL,
	BOOK_VIEW_NUM_SIGNALS
};
static guint book_view_signals[BOOK_VIEW_NUM_SIGNALS] = {0};

struct _BookView {
	GtkBox parent_instance;
	BookViewPrivate * priv;
};

struct _BookViewClass {
	GtkBoxClass parent_class;
};

struct _BookViewPrivate {
	Book* _book;
	GHashTable* page_data;
	gboolean need_layout;
	gboolean laying_out;
	gboolean show_selected_page;
	PageView* selected_page_view;
	GtkWidget* drawing_area;
	GtkScrollbar* scroll;
	GtkAdjustment* adjustment;
	GdkCursorType cursor;
};


static gint BookView_private_offset;
static gpointer book_view_parent_class = NULL;

GType book_view_get_type (void) G_GNUC_CONST;
GType book_get_type (void) G_GNUC_CONST;
GType page_get_type (void) G_GNUC_CONST;
GType page_view_get_type (void) G_GNUC_CONST;
Book* book_view_get_book (BookView* self);
static void book_view_add_cb (BookView* self,
                       Book* book,
                       Page* page);
static void _book_view_add_cb_book_page_added (Book* _sender,
                                        Page* page,
                                        gpointer self);
static void book_view_remove_cb (BookView* self,
                          Book* book,
                          Page* page);
static void _book_view_remove_cb_book_page_removed (Book* _sender,
                                             Page* page,
                                             gpointer self);
static void book_view_reorder_cb (BookView* self,
                           Book* book);
static void _book_view_reorder_cb_book_reordered (Book* _sender,
                                           gpointer self);
static void book_view_clear_cb (BookView* self,
                         Book* book);
static void _book_view_clear_cb_book_cleared (Book* _sender,
                                       gpointer self);
static gboolean book_view_configure_cb (BookView* self,
                                 GtkWidget* widget,
                                 GdkEventConfigure* event);
static gboolean _book_view_configure_cb_gtk_widget_configure_event (GtkWidget* _sender,
                                                             GdkEventConfigure* event,
                                                             gpointer self);
static gboolean book_view_draw_cb (BookView* self,
                            GtkWidget* widget,
                            cairo_t* context);
static gboolean _book_view_draw_cb_gtk_widget_draw (GtkWidget* _sender,
                                             cairo_t* cr,
                                             gpointer self);
static gboolean book_view_motion_cb (BookView* self,
                              GtkWidget* widget,
                              GdkEventMotion* event);
static gboolean _book_view_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                              GdkEventMotion* event,
                                                              gpointer self);
static gboolean book_view_key_cb (BookView* self,
                           GtkWidget* widget,
                           GdkEventKey* event);
static gboolean _book_view_key_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                       GdkEventKey* event,
                                                       gpointer self);
static gboolean book_view_button_cb (BookView* self,
                              GtkWidget* widget,
                              GdkEventButton* event);
static gboolean _book_view_button_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                             GdkEventButton* event,
                                                             gpointer self);
static gboolean _book_view_button_cb_gtk_widget_button_release_event (GtkWidget* _sender,
                                                               GdkEventButton* event,
                                                               gpointer self);
static gboolean book_view_focus_cb (BookView* self,
                             GtkWidget* widget,
                             GdkEventFocus* event);
static gboolean _book_view_focus_cb_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                        GdkEventFocus* event,
                                                        gpointer self);
static gboolean _book_view_focus_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                         GdkEventFocus* event,
                                                         gpointer self);
static void book_view_scroll_cb (BookView* self,
                          GtkAdjustment* adjustment);
static void _book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                        gpointer self);
BookView* book_view_new (Book* book);
BookView* book_view_construct (GType object_type,
                               Book* book);
static void book_view_set_book (BookView* self,
                         Book* value);
guint book_get_n_pages (Book* self);
Page* book_get_page (Book* self,
                     gint page_number);
void book_view_set_selected_page (BookView* self,
                                  Page* value);
static void _g_object_unref0_ (gpointer var);
static PageView* book_view_get_nth_page (BookView* self,
                                  gint n);
static PageView* book_view_get_next_page (BookView* self,
                                   PageView* page);
Page* page_view_get_page (PageView* self);
static PageView* book_view_get_prev_page (BookView* self,
                                   PageView* page);
static void book_view_page_view_changed_cb (BookView* self,
                                     PageView* page);
void book_view_redraw (BookView* self);
static void book_view_page_view_size_changed_cb (BookView* self,
                                          PageView* page);
PageView* page_view_new (Page* page);
PageView* page_view_construct (GType object_type,
                               Page* page);
static void _book_view_page_view_changed_cb_page_view_changed (PageView* _sender,
                                                        gpointer self);
static void _book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender,
                                                                  gpointer self);
static void book_view_set_selected_page_view (BookView* self,
                                       PageView* page);
void page_view_set_selected (PageView* self,
                             gboolean value);
static void book_view_show_page_view (BookView* self,
                               PageView* page);
gint page_view_get_x_offset (PageView* self);
gint page_view_get_width (PageView* self);
gint book_view_get_x_offset (BookView* self);
void book_view_set_x_offset (BookView* self,
                             gint value);
static void book_view_select_page_view (BookView* self,
                                 PageView* page);
Page* book_view_get_selected_page (BookView* self);
static void book_view_layout_into (BookView* self,
                            gint width,
                            gint height,
                            gint* book_width,
                            gint* book_height);
gint page_get_dpi (Page* self);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
void page_view_set_width (PageView* self,
                          gint value);
void page_view_set_height (PageView* self,
                           gint value);
gint page_view_get_height (PageView* self);
void page_view_set_x_offset (PageView* self,
                             gint value);
void page_view_set_y_offset (PageView* self,
                             gint value);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void book_view_layout (BookView* self);
void page_view_render (PageView* self,
                       cairo_t* context);
gboolean page_view_get_selected (PageView* self);
gint page_view_get_y_offset (PageView* self);
static PageView* book_view_get_page_at (BookView* self,
                                 gint x,
                                 gint y,
                                 gint* x_,
                                 gint* y_);
void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static void book_view_set_cursor (BookView* self,
                           GdkCursorType cursor);
void page_view_motion (PageView* self,
                       gint x,
                       gint y);
GdkCursorType page_view_get_cursor (PageView* self);
void book_view_select_next_page (BookView* self);
void book_view_select_prev_page (BookView* self);
static void book_view_finalize (GObject * obj);
static void _vala_book_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_book_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);


static inline gpointer
book_view_get_instance_private (BookView* self)
{
	return G_STRUCT_MEMBER_P (self, BookView_private_offset);
}


static void
_book_view_add_cb_book_page_added (Book* _sender,
                                   Page* page,
                                   gpointer self)
{
#line 124 "../src/book-view.vala"
	book_view_add_cb ((BookView*) self, _sender, page);
#line 294 "book-view.c"
}


static void
_book_view_remove_cb_book_page_removed (Book* _sender,
                                        Page* page,
                                        gpointer self)
{
#line 125 "../src/book-view.vala"
	book_view_remove_cb ((BookView*) self, _sender, page);
#line 305 "book-view.c"
}


static void
_book_view_reorder_cb_book_reordered (Book* _sender,
                                      gpointer self)
{
#line 126 "../src/book-view.vala"
	book_view_reorder_cb ((BookView*) self, _sender);
#line 315 "book-view.c"
}


static void
_book_view_clear_cb_book_cleared (Book* _sender,
                                  gpointer self)
{
#line 127 "../src/book-view.vala"
	book_view_clear_cb ((BookView*) self, _sender);
#line 325 "book-view.c"
}


static gboolean
_book_view_configure_cb_gtk_widget_configure_event (GtkWidget* _sender,
                                                    GdkEventConfigure* event,
                                                    gpointer self)
{
	gboolean result;
	result = book_view_configure_cb ((BookView*) self, _sender, event);
#line 128 "../src/book-view.vala"
	return result;
#line 338 "book-view.c"
}


static gboolean
_book_view_draw_cb_gtk_widget_draw (GtkWidget* _sender,
                                    cairo_t* cr,
                                    gpointer self)
{
	gboolean result;
	result = book_view_draw_cb ((BookView*) self, _sender, cr);
#line 129 "../src/book-view.vala"
	return result;
#line 351 "book-view.c"
}


static gboolean
_book_view_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                     GdkEventMotion* event,
                                                     gpointer self)
{
	gboolean result;
	result = book_view_motion_cb ((BookView*) self, _sender, event);
#line 130 "../src/book-view.vala"
	return result;
#line 364 "book-view.c"
}


static gboolean
_book_view_key_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                              GdkEventKey* event,
                                              gpointer self)
{
	gboolean result;
	result = book_view_key_cb ((BookView*) self, _sender, event);
#line 131 "../src/book-view.vala"
	return result;
#line 377 "book-view.c"
}


static gboolean
_book_view_button_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                    GdkEventButton* event,
                                                    gpointer self)
{
	gboolean result;
	result = book_view_button_cb ((BookView*) self, _sender, event);
#line 132 "../src/book-view.vala"
	return result;
#line 390 "book-view.c"
}


static gboolean
_book_view_button_cb_gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self)
{
	gboolean result;
	result = book_view_button_cb ((BookView*) self, _sender, event);
#line 133 "../src/book-view.vala"
	return result;
#line 403 "book-view.c"
}


static gboolean
_book_view_focus_cb_gtk_widget_focus_in_event (GtkWidget* _sender,
                                               GdkEventFocus* event,
                                               gpointer self)
{
	gboolean result;
	result = book_view_focus_cb ((BookView*) self, _sender, event);
#line 134 "../src/book-view.vala"
	return result;
#line 416 "book-view.c"
}


static gboolean
_book_view_focus_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                GdkEventFocus* event,
                                                gpointer self)
{
	gboolean result;
	result = book_view_focus_cb ((BookView*) self, _sender, event);
#line 135 "../src/book-view.vala"
	return result;
#line 429 "book-view.c"
}


static void
_book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                   gpointer self)
{
#line 136 "../src/book-view.vala"
	book_view_scroll_cb ((BookView*) self, _sender);
#line 439 "book-view.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 95 "../src/book-view.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 448 "book-view.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 106 "../src/book-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 457 "book-view.c"
}


BookView*
book_view_construct (GType object_type,
                     Book* book)
{
	BookView * self = NULL;
	Page* _tmp8_;
	Page* _tmp9_;
	GHashFunc _tmp10_;
	GEqualFunc _tmp11_;
	GHashTable* _tmp12_;
	GtkDrawingArea* _tmp13_;
	GtkWidget* _tmp14_;
	GtkWidget* _tmp15_;
	GtkWidget* _tmp16_;
	GtkWidget* _tmp17_;
	GtkWidget* _tmp18_;
	GtkScrollbar* _tmp19_;
	GtkScrollbar* _tmp20_;
	GtkAdjustment* _tmp21_;
	GtkAdjustment* _tmp22_;
	GtkAdjustment* _tmp23_;
	GtkScrollbar* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	GtkWidget* _tmp27_;
	GtkWidget* _tmp28_;
	GtkWidget* _tmp29_;
	GtkWidget* _tmp30_;
	GtkWidget* _tmp31_;
	GtkWidget* _tmp32_;
	GtkAdjustment* _tmp33_;
	GtkWidget* _tmp34_;
#line 74 "../src/book-view.vala"
	g_return_val_if_fail (book != NULL, NULL);
#line 76 "../src/book-view.vala"
	self = (BookView*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, NULL);
#line 77 "../src/book-view.vala"
	book_view_set_book (self, book);
#line 499 "book-view.c"
	{
		gint i = 0;
#line 80 "../src/book-view.vala"
		i = 0;
#line 504 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 80 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 80 "../src/book-view.vala"
			while (TRUE) {
#line 511 "book-view.c"
				gint _tmp2_;
				guint _tmp3_;
				guint _tmp4_;
				Page* page = NULL;
				gint _tmp5_;
				Page* _tmp6_;
				Page* _tmp7_;
#line 80 "../src/book-view.vala"
				if (!_tmp0_) {
#line 521 "book-view.c"
					gint _tmp1_;
#line 80 "../src/book-view.vala"
					_tmp1_ = i;
#line 80 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 527 "book-view.c"
				}
#line 80 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 80 "../src/book-view.vala"
				_tmp2_ = i;
#line 80 "../src/book-view.vala"
				_tmp3_ = book_get_n_pages (book);
#line 80 "../src/book-view.vala"
				_tmp4_ = _tmp3_;
#line 80 "../src/book-view.vala"
				if (!(((guint) _tmp2_) < _tmp4_)) {
#line 80 "../src/book-view.vala"
					break;
#line 541 "book-view.c"
				}
#line 82 "../src/book-view.vala"
				_tmp5_ = i;
#line 82 "../src/book-view.vala"
				_tmp6_ = book_get_page (book, _tmp5_);
#line 82 "../src/book-view.vala"
				page = _tmp6_;
#line 83 "../src/book-view.vala"
				_tmp7_ = page;
#line 83 "../src/book-view.vala"
				book_view_add_cb (self, book, _tmp7_);
#line 80 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 555 "book-view.c"
			}
		}
	}
#line 86 "../src/book-view.vala"
	_tmp8_ = book_get_page (book, 0);
#line 86 "../src/book-view.vala"
	_tmp9_ = _tmp8_;
#line 86 "../src/book-view.vala"
	book_view_set_selected_page (self, _tmp9_);
#line 86 "../src/book-view.vala"
	_g_object_unref0 (_tmp9_);
#line 89 "../src/book-view.vala"
	g_signal_connect_object (book, "page-added", (GCallback) _book_view_add_cb_book_page_added, self, 0);
#line 90 "../src/book-view.vala"
	g_signal_connect_object (book, "page-removed", (GCallback) _book_view_remove_cb_book_page_removed, self, 0);
#line 91 "../src/book-view.vala"
	g_signal_connect_object (book, "reordered", (GCallback) _book_view_reorder_cb_book_reordered, self, 0);
#line 92 "../src/book-view.vala"
	g_signal_connect_object (book, "cleared", (GCallback) _book_view_clear_cb_book_cleared, self, 0);
#line 94 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 95 "../src/book-view.vala"
	_tmp10_ = g_direct_hash;
#line 95 "../src/book-view.vala"
	_tmp11_ = g_direct_equal;
#line 95 "../src/book-view.vala"
	_tmp12_ = g_hash_table_new_full (_tmp10_, _tmp11_, _g_object_unref0_, _g_object_unref0_);
#line 95 "../src/book-view.vala"
	_g_hash_table_unref0 (self->priv->page_data);
#line 95 "../src/book-view.vala"
	self->priv->page_data = _tmp12_;
#line 96 "../src/book-view.vala"
	self->priv->cursor = GDK_ARROW;
#line 98 "../src/book-view.vala"
	_tmp13_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 98 "../src/book-view.vala"
	g_object_ref_sink (_tmp13_);
#line 98 "../src/book-view.vala"
	_g_object_unref0 (self->priv->drawing_area);
#line 98 "../src/book-view.vala"
	self->priv->drawing_area = (GtkWidget*) _tmp13_;
#line 99 "../src/book-view.vala"
	_tmp14_ = self->priv->drawing_area;
#line 99 "../src/book-view.vala"
	gtk_widget_set_size_request (_tmp14_, 200, 100);
#line 100 "../src/book-view.vala"
	_tmp15_ = self->priv->drawing_area;
#line 100 "../src/book-view.vala"
	gtk_widget_set_can_focus (_tmp15_, TRUE);
#line 101 "../src/book-view.vala"
	_tmp16_ = self->priv->drawing_area;
#line 101 "../src/book-view.vala"
	gtk_widget_set_events (_tmp16_, ((((GDK_POINTER_MOTION_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_FOCUS_CHANGE_MASK) | GDK_STRUCTURE_MASK) | GDK_SCROLL_MASK);
#line 102 "../src/book-view.vala"
	_tmp17_ = self->priv->drawing_area;
#line 102 "../src/book-view.vala"
	gtk_widget_set_vexpand (_tmp17_, TRUE);
#line 103 "../src/book-view.vala"
	_tmp18_ = self->priv->drawing_area;
#line 103 "../src/book-view.vala"
	gtk_container_add ((GtkContainer*) self, _tmp18_);
#line 105 "../src/book-view.vala"
	_tmp19_ = (GtkScrollbar*) gtk_scrollbar_new (GTK_ORIENTATION_HORIZONTAL, NULL);
#line 105 "../src/book-view.vala"
	g_object_ref_sink (_tmp19_);
#line 105 "../src/book-view.vala"
	_g_object_unref0 (self->priv->scroll);
#line 105 "../src/book-view.vala"
	self->priv->scroll = _tmp19_;
#line 106 "../src/book-view.vala"
	_tmp20_ = self->priv->scroll;
#line 106 "../src/book-view.vala"
	_tmp21_ = gtk_range_get_adjustment ((GtkRange*) _tmp20_);
#line 106 "../src/book-view.vala"
	_tmp22_ = _tmp21_;
#line 106 "../src/book-view.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 106 "../src/book-view.vala"
	_g_object_unref0 (self->priv->adjustment);
#line 106 "../src/book-view.vala"
	self->priv->adjustment = _tmp23_;
#line 107 "../src/book-view.vala"
	_tmp24_ = self->priv->scroll;
#line 107 "../src/book-view.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
#line 109 "../src/book-view.vala"
	_tmp25_ = self->priv->drawing_area;
#line 109 "../src/book-view.vala"
	g_signal_connect_object (_tmp25_, "configure-event", (GCallback) _book_view_configure_cb_gtk_widget_configure_event, self, 0);
#line 110 "../src/book-view.vala"
	_tmp26_ = self->priv->drawing_area;
#line 110 "../src/book-view.vala"
	g_signal_connect_object (_tmp26_, "draw", (GCallback) _book_view_draw_cb_gtk_widget_draw, self, 0);
#line 111 "../src/book-view.vala"
	_tmp27_ = self->priv->drawing_area;
#line 111 "../src/book-view.vala"
	g_signal_connect_object (_tmp27_, "motion-notify-event", (GCallback) _book_view_motion_cb_gtk_widget_motion_notify_event, self, 0);
#line 112 "../src/book-view.vala"
	_tmp28_ = self->priv->drawing_area;
#line 112 "../src/book-view.vala"
	g_signal_connect_object (_tmp28_, "key-press-event", (GCallback) _book_view_key_cb_gtk_widget_key_press_event, self, 0);
#line 113 "../src/book-view.vala"
	_tmp29_ = self->priv->drawing_area;
#line 113 "../src/book-view.vala"
	g_signal_connect_object (_tmp29_, "button-press-event", (GCallback) _book_view_button_cb_gtk_widget_button_press_event, self, 0);
#line 114 "../src/book-view.vala"
	_tmp30_ = self->priv->drawing_area;
#line 114 "../src/book-view.vala"
	g_signal_connect_object (_tmp30_, "button-release-event", (GCallback) _book_view_button_cb_gtk_widget_button_release_event, self, 0);
#line 115 "../src/book-view.vala"
	_tmp31_ = self->priv->drawing_area;
#line 115 "../src/book-view.vala"
	g_signal_connect_object (_tmp31_, "focus-in-event", (GCallback) _book_view_focus_cb_gtk_widget_focus_in_event, self, G_CONNECT_AFTER);
#line 116 "../src/book-view.vala"
	_tmp32_ = self->priv->drawing_area;
#line 116 "../src/book-view.vala"
	g_signal_connect_object (_tmp32_, "focus-out-event", (GCallback) _book_view_focus_cb_gtk_widget_focus_out_event, self, G_CONNECT_AFTER);
#line 117 "../src/book-view.vala"
	_tmp33_ = self->priv->adjustment;
#line 117 "../src/book-view.vala"
	g_signal_connect_object (_tmp33_, "value-changed", (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self, 0);
#line 119 "../src/book-view.vala"
	_tmp34_ = self->priv->drawing_area;
#line 119 "../src/book-view.vala"
	gtk_widget_set_visible (_tmp34_, TRUE);
#line 74 "../src/book-view.vala"
	return self;
#line 683 "book-view.c"
}


BookView*
book_view_new (Book* book)
{
#line 74 "../src/book-view.vala"
	return book_view_construct (TYPE_BOOK_VIEW, book);
#line 692 "book-view.c"
}


static PageView*
book_view_get_nth_page (BookView* self,
                        gint n)
{
	PageView* result = NULL;
	Page* page = NULL;
	Book* _tmp0_;
	Page* _tmp1_;
	GHashTable* _tmp2_;
	gconstpointer _tmp3_;
	PageView* _tmp4_;
#line 139 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 141 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 141 "../src/book-view.vala"
	_tmp1_ = book_get_page (_tmp0_, n);
#line 141 "../src/book-view.vala"
	page = _tmp1_;
#line 142 "../src/book-view.vala"
	_tmp2_ = self->priv->page_data;
#line 142 "../src/book-view.vala"
	_tmp3_ = g_hash_table_lookup (_tmp2_, page);
#line 142 "../src/book-view.vala"
	_tmp4_ = _g_object_ref0 ((PageView*) _tmp3_);
#line 142 "../src/book-view.vala"
	result = _tmp4_;
#line 142 "../src/book-view.vala"
	_g_object_unref0 (page);
#line 142 "../src/book-view.vala"
	return result;
#line 727 "book-view.c"
}


static PageView*
book_view_get_next_page (BookView* self,
                         PageView* page)
{
	PageView* result = NULL;
	PageView* _tmp17_;
#line 145 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../src/book-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 741 "book-view.c"
	{
		gint i = 0;
#line 147 "../src/book-view.vala"
		i = 0;
#line 746 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 147 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 147 "../src/book-view.vala"
			while (TRUE) {
#line 753 "book-view.c"
				Page* p = NULL;
				Book* _tmp2_;
				gint _tmp3_;
				Page* _tmp4_;
				Page* _tmp5_;
				Page* _tmp6_;
				Page* _tmp7_;
				Page* _tmp8_;
#line 147 "../src/book-view.vala"
				if (!_tmp0_) {
#line 764 "book-view.c"
					gint _tmp1_;
#line 147 "../src/book-view.vala"
					_tmp1_ = i;
#line 147 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 770 "book-view.c"
				}
#line 147 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 149 "../src/book-view.vala"
				_tmp2_ = self->priv->_book;
#line 149 "../src/book-view.vala"
				_tmp3_ = i;
#line 149 "../src/book-view.vala"
				_tmp4_ = book_get_page (_tmp2_, _tmp3_);
#line 149 "../src/book-view.vala"
				p = _tmp4_;
#line 150 "../src/book-view.vala"
				_tmp5_ = p;
#line 150 "../src/book-view.vala"
				if (_tmp5_ == NULL) {
#line 151 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 151 "../src/book-view.vala"
					break;
#line 790 "book-view.c"
				}
#line 152 "../src/book-view.vala"
				_tmp6_ = p;
#line 152 "../src/book-view.vala"
				_tmp7_ = page_view_get_page (page);
#line 152 "../src/book-view.vala"
				_tmp8_ = _tmp7_;
#line 152 "../src/book-view.vala"
				if (_tmp6_ == _tmp8_) {
#line 800 "book-view.c"
					Book* _tmp9_;
					gint _tmp10_;
					Page* _tmp11_;
					Page* _tmp12_;
#line 154 "../src/book-view.vala"
					_tmp9_ = self->priv->_book;
#line 154 "../src/book-view.vala"
					_tmp10_ = i;
#line 154 "../src/book-view.vala"
					_tmp11_ = book_get_page (_tmp9_, _tmp10_ + 1);
#line 154 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 154 "../src/book-view.vala"
					p = _tmp11_;
#line 155 "../src/book-view.vala"
					_tmp12_ = p;
#line 155 "../src/book-view.vala"
					if (_tmp12_ != NULL) {
#line 819 "book-view.c"
						GHashTable* _tmp13_;
						Page* _tmp14_;
						gconstpointer _tmp15_;
						PageView* _tmp16_;
#line 156 "../src/book-view.vala"
						_tmp13_ = self->priv->page_data;
#line 156 "../src/book-view.vala"
						_tmp14_ = p;
#line 156 "../src/book-view.vala"
						_tmp15_ = g_hash_table_lookup (_tmp13_, _tmp14_);
#line 156 "../src/book-view.vala"
						_tmp16_ = _g_object_ref0 ((PageView*) _tmp15_);
#line 156 "../src/book-view.vala"
						result = _tmp16_;
#line 156 "../src/book-view.vala"
						_g_object_unref0 (p);
#line 156 "../src/book-view.vala"
						return result;
#line 838 "book-view.c"
					}
				}
#line 147 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 843 "book-view.c"
			}
		}
	}
#line 160 "../src/book-view.vala"
	_tmp17_ = _g_object_ref0 (page);
#line 160 "../src/book-view.vala"
	result = _tmp17_;
#line 160 "../src/book-view.vala"
	return result;
#line 853 "book-view.c"
}


static PageView*
book_view_get_prev_page (BookView* self,
                         PageView* page)
{
	PageView* result = NULL;
	PageView* prev_page = NULL;
	PageView* _tmp0_;
	PageView* _tmp14_;
#line 163 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 163 "../src/book-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 165 "../src/book-view.vala"
	_tmp0_ = _g_object_ref0 (page);
#line 165 "../src/book-view.vala"
	prev_page = _tmp0_;
#line 873 "book-view.c"
	{
		gint i = 0;
#line 166 "../src/book-view.vala"
		i = 0;
#line 878 "book-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 166 "../src/book-view.vala"
			_tmp1_ = TRUE;
#line 166 "../src/book-view.vala"
			while (TRUE) {
#line 885 "book-view.c"
				Page* p = NULL;
				Book* _tmp3_;
				gint _tmp4_;
				Page* _tmp5_;
				Page* _tmp6_;
				Page* _tmp7_;
				Page* _tmp8_;
				Page* _tmp9_;
				GHashTable* _tmp10_;
				Page* _tmp11_;
				gconstpointer _tmp12_;
				PageView* _tmp13_;
#line 166 "../src/book-view.vala"
				if (!_tmp1_) {
#line 900 "book-view.c"
					gint _tmp2_;
#line 166 "../src/book-view.vala"
					_tmp2_ = i;
#line 166 "../src/book-view.vala"
					i = _tmp2_ + 1;
#line 906 "book-view.c"
				}
#line 166 "../src/book-view.vala"
				_tmp1_ = FALSE;
#line 168 "../src/book-view.vala"
				_tmp3_ = self->priv->_book;
#line 168 "../src/book-view.vala"
				_tmp4_ = i;
#line 168 "../src/book-view.vala"
				_tmp5_ = book_get_page (_tmp3_, _tmp4_);
#line 168 "../src/book-view.vala"
				p = _tmp5_;
#line 169 "../src/book-view.vala"
				_tmp6_ = p;
#line 169 "../src/book-view.vala"
				if (_tmp6_ == NULL) {
#line 170 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 170 "../src/book-view.vala"
					break;
#line 926 "book-view.c"
				}
#line 171 "../src/book-view.vala"
				_tmp7_ = p;
#line 171 "../src/book-view.vala"
				_tmp8_ = page_view_get_page (page);
#line 171 "../src/book-view.vala"
				_tmp9_ = _tmp8_;
#line 171 "../src/book-view.vala"
				if (_tmp7_ == _tmp9_) {
#line 172 "../src/book-view.vala"
					result = prev_page;
#line 172 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 172 "../src/book-view.vala"
					return result;
#line 942 "book-view.c"
				}
#line 173 "../src/book-view.vala"
				_tmp10_ = self->priv->page_data;
#line 173 "../src/book-view.vala"
				_tmp11_ = p;
#line 173 "../src/book-view.vala"
				_tmp12_ = g_hash_table_lookup (_tmp10_, _tmp11_);
#line 173 "../src/book-view.vala"
				_tmp13_ = _g_object_ref0 ((PageView*) _tmp12_);
#line 173 "../src/book-view.vala"
				_g_object_unref0 (prev_page);
#line 173 "../src/book-view.vala"
				prev_page = _tmp13_;
#line 166 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 958 "book-view.c"
			}
		}
	}
#line 176 "../src/book-view.vala"
	_tmp14_ = _g_object_ref0 (page);
#line 176 "../src/book-view.vala"
	result = _tmp14_;
#line 176 "../src/book-view.vala"
	_g_object_unref0 (prev_page);
#line 176 "../src/book-view.vala"
	return result;
#line 970 "book-view.c"
}


static void
book_view_page_view_changed_cb (BookView* self,
                                PageView* page)
{
#line 179 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 181 "../src/book-view.vala"
	book_view_redraw (self);
#line 984 "book-view.c"
}


static void
book_view_page_view_size_changed_cb (BookView* self,
                                     PageView* page)
{
#line 184 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 186 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 187 "../src/book-view.vala"
	book_view_redraw (self);
#line 1000 "book-view.c"
}


static void
_book_view_page_view_changed_cb_page_view_changed (PageView* _sender,
                                                   gpointer self)
{
#line 193 "../src/book-view.vala"
	book_view_page_view_changed_cb ((BookView*) self, _sender);
#line 1010 "book-view.c"
}


static void
_book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender,
                                                             gpointer self)
{
#line 194 "../src/book-view.vala"
	book_view_page_view_size_changed_cb ((BookView*) self, _sender);
#line 1020 "book-view.c"
}


static void
book_view_add_cb (BookView* self,
                  Book* book,
                  Page* page)
{
	PageView* page_view = NULL;
	PageView* _tmp0_;
	GHashTable* _tmp1_;
	Page* _tmp2_;
	PageView* _tmp3_;
#line 190 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 190 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 192 "../src/book-view.vala"
	_tmp0_ = page_view_new (page);
#line 192 "../src/book-view.vala"
	page_view = _tmp0_;
#line 193 "../src/book-view.vala"
	g_signal_connect_object (page_view, "changed", (GCallback) _book_view_page_view_changed_cb_page_view_changed, self, 0);
#line 194 "../src/book-view.vala"
	g_signal_connect_object (page_view, "size-changed", (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self, 0);
#line 195 "../src/book-view.vala"
	_tmp1_ = self->priv->page_data;
#line 195 "../src/book-view.vala"
	_tmp2_ = _g_object_ref0 (page);
#line 195 "../src/book-view.vala"
	_tmp3_ = _g_object_ref0 (page_view);
#line 195 "../src/book-view.vala"
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp3_);
#line 196 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 197 "../src/book-view.vala"
	book_view_redraw (self);
#line 190 "../src/book-view.vala"
	_g_object_unref0 (page_view);
#line 1062 "book-view.c"
}


static void
book_view_set_selected_page_view (BookView* self,
                                  PageView* page)
{
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_;
	PageView* _tmp4_;
	PageView* _tmp5_;
	GtkWidget* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 200 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/book-view.vala"
	_tmp1_ = self->priv->selected_page_view;
#line 203 "../src/book-view.vala"
	if (_tmp1_ != NULL) {
#line 1083 "book-view.c"
		PageView* _tmp2_;
#line 203 "../src/book-view.vala"
		_tmp2_ = self->priv->selected_page_view;
#line 203 "../src/book-view.vala"
		_tmp0_ = page != _tmp2_;
#line 1089 "book-view.c"
	} else {
#line 203 "../src/book-view.vala"
		_tmp0_ = FALSE;
#line 1093 "book-view.c"
	}
#line 203 "../src/book-view.vala"
	if (_tmp0_) {
#line 1097 "book-view.c"
		PageView* _tmp3_;
#line 204 "../src/book-view.vala"
		_tmp3_ = self->priv->selected_page_view;
#line 204 "../src/book-view.vala"
		page_view_set_selected (_tmp3_, TRUE);
#line 1103 "book-view.c"
	}
#line 206 "../src/book-view.vala"
	_tmp4_ = _g_object_ref0 (page);
#line 206 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 206 "../src/book-view.vala"
	self->priv->selected_page_view = _tmp4_;
#line 207 "../src/book-view.vala"
	_tmp5_ = self->priv->selected_page_view;
#line 207 "../src/book-view.vala"
	if (_tmp5_ == NULL) {
#line 208 "../src/book-view.vala"
		return;
#line 1117 "book-view.c"
	}
#line 211 "../src/book-view.vala"
	_tmp6_ = self->priv->drawing_area;
#line 211 "../src/book-view.vala"
	g_object_get (_tmp6_, "has-focus", &_tmp7_, NULL);
#line 211 "../src/book-view.vala"
	_tmp8_ = _tmp7_;
#line 211 "../src/book-view.vala"
	if (!_tmp8_) {
#line 1127 "book-view.c"
		PageView* _tmp9_;
#line 212 "../src/book-view.vala"
		_tmp9_ = self->priv->selected_page_view;
#line 212 "../src/book-view.vala"
		page_view_set_selected (_tmp9_, FALSE);
#line 1133 "book-view.c"
	} else {
		PageView* _tmp10_;
#line 214 "../src/book-view.vala"
		_tmp10_ = self->priv->selected_page_view;
#line 214 "../src/book-view.vala"
		page_view_set_selected (_tmp10_, TRUE);
#line 1140 "book-view.c"
	}
}


static void
book_view_show_page_view (BookView* self,
                          PageView* page)
{
	gboolean _tmp0_ = FALSE;
	GtkAllocation allocation = {0};
	GtkWidget* _tmp2_;
	GtkAllocation _tmp3_ = {0};
	gint left_edge = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint right_edge = 0;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 217 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/book-view.vala"
	if (page == NULL) {
#line 219 "../src/book-view.vala"
		_tmp0_ = TRUE;
#line 1170 "book-view.c"
	} else {
		GtkScrollbar* _tmp1_;
#line 219 "../src/book-view.vala"
		_tmp1_ = self->priv->scroll;
#line 219 "../src/book-view.vala"
		_tmp0_ = !gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 1177 "book-view.c"
	}
#line 219 "../src/book-view.vala"
	if (_tmp0_) {
#line 220 "../src/book-view.vala"
		return;
#line 1183 "book-view.c"
	}
#line 223 "../src/book-view.vala"
	_tmp2_ = self->priv->drawing_area;
#line 223 "../src/book-view.vala"
	gtk_widget_get_allocation (_tmp2_, &_tmp3_);
#line 223 "../src/book-view.vala"
	allocation = _tmp3_;
#line 224 "../src/book-view.vala"
	_tmp4_ = page_view_get_x_offset (page);
#line 224 "../src/book-view.vala"
	_tmp5_ = _tmp4_;
#line 224 "../src/book-view.vala"
	left_edge = _tmp5_;
#line 225 "../src/book-view.vala"
	_tmp6_ = page_view_get_x_offset (page);
#line 225 "../src/book-view.vala"
	_tmp7_ = _tmp6_;
#line 225 "../src/book-view.vala"
	_tmp8_ = page_view_get_width (page);
#line 225 "../src/book-view.vala"
	_tmp9_ = _tmp8_;
#line 225 "../src/book-view.vala"
	right_edge = _tmp7_ + _tmp9_;
#line 227 "../src/book-view.vala"
	_tmp10_ = left_edge;
#line 227 "../src/book-view.vala"
	_tmp11_ = book_view_get_x_offset (self);
#line 227 "../src/book-view.vala"
	_tmp12_ = _tmp11_;
#line 227 "../src/book-view.vala"
	if ((_tmp10_ - _tmp12_) < 0) {
#line 1215 "book-view.c"
		gint _tmp13_;
#line 228 "../src/book-view.vala"
		_tmp13_ = left_edge;
#line 228 "../src/book-view.vala"
		book_view_set_x_offset (self, _tmp13_);
#line 1221 "book-view.c"
	} else {
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		GtkAllocation _tmp17_;
		gint _tmp18_;
#line 229 "../src/book-view.vala"
		_tmp14_ = right_edge;
#line 229 "../src/book-view.vala"
		_tmp15_ = book_view_get_x_offset (self);
#line 229 "../src/book-view.vala"
		_tmp16_ = _tmp15_;
#line 229 "../src/book-view.vala"
		_tmp17_ = allocation;
#line 229 "../src/book-view.vala"
		_tmp18_ = _tmp17_.width;
#line 229 "../src/book-view.vala"
		if ((_tmp14_ - _tmp16_) > _tmp18_) {
#line 1240 "book-view.c"
			gint _tmp19_;
			GtkAllocation _tmp20_;
			gint _tmp21_;
#line 230 "../src/book-view.vala"
			_tmp19_ = right_edge;
#line 230 "../src/book-view.vala"
			_tmp20_ = allocation;
#line 230 "../src/book-view.vala"
			_tmp21_ = _tmp20_.width;
#line 230 "../src/book-view.vala"
			book_view_set_x_offset (self, _tmp19_ - _tmp21_);
#line 1252 "book-view.c"
		}
	}
}


static void
book_view_select_page_view (BookView* self,
                            PageView* page)
{
	Page* p = NULL;
	PageView* _tmp0_;
	gboolean _tmp1_;
	Page* _tmp5_;
#line 233 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/book-view.vala"
	p = NULL;
#line 237 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 237 "../src/book-view.vala"
	if (_tmp0_ == page) {
#line 238 "../src/book-view.vala"
		_g_object_unref0 (p);
#line 238 "../src/book-view.vala"
		return;
#line 1278 "book-view.c"
	}
#line 240 "../src/book-view.vala"
	book_view_set_selected_page_view (self, page);
#line 242 "../src/book-view.vala"
	_tmp1_ = self->priv->need_layout;
#line 242 "../src/book-view.vala"
	if (_tmp1_) {
#line 243 "../src/book-view.vala"
		self->priv->show_selected_page = TRUE;
#line 1288 "book-view.c"
	} else {
#line 245 "../src/book-view.vala"
		book_view_show_page_view (self, page);
#line 1292 "book-view.c"
	}
#line 247 "../src/book-view.vala"
	if (page != NULL) {
#line 1296 "book-view.c"
		Page* _tmp2_;
		Page* _tmp3_;
		Page* _tmp4_;
#line 248 "../src/book-view.vala"
		_tmp2_ = page_view_get_page (page);
#line 248 "../src/book-view.vala"
		_tmp3_ = _tmp2_;
#line 248 "../src/book-view.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 248 "../src/book-view.vala"
		_g_object_unref0 (p);
#line 248 "../src/book-view.vala"
		p = _tmp4_;
#line 1310 "book-view.c"
	}
#line 249 "../src/book-view.vala"
	_tmp5_ = p;
#line 249 "../src/book-view.vala"
	g_signal_emit (self, book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL], 0, _tmp5_);
#line 233 "../src/book-view.vala"
	_g_object_unref0 (p);
#line 1318 "book-view.c"
}


static void
book_view_remove_cb (BookView* self,
                     Book* book,
                     Page* page)
{
	PageView* new_selection = NULL;
	PageView* _tmp0_;
	PageView* _tmp1_;
	Page* _tmp2_;
	Page* _tmp3_;
	PageView* page_view = NULL;
	GHashTable* _tmp10_;
	gconstpointer _tmp11_;
	PageView* _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	GHashTable* _tmp15_;
	PageView* _tmp16_;
#line 252 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 252 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 254 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 254 "../src/book-view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 254 "../src/book-view.vala"
	new_selection = _tmp1_;
#line 257 "../src/book-view.vala"
	_tmp2_ = book_view_get_selected_page (self);
#line 257 "../src/book-view.vala"
	_tmp3_ = _tmp2_;
#line 257 "../src/book-view.vala"
	if (page == _tmp3_) {
#line 1358 "book-view.c"
		PageView* _tmp4_;
		PageView* _tmp5_;
		PageView* _tmp6_;
		PageView* _tmp7_;
#line 259 "../src/book-view.vala"
		_tmp4_ = self->priv->selected_page_view;
#line 259 "../src/book-view.vala"
		_tmp5_ = book_view_get_prev_page (self, _tmp4_);
#line 259 "../src/book-view.vala"
		_g_object_unref0 (new_selection);
#line 259 "../src/book-view.vala"
		new_selection = _tmp5_;
#line 260 "../src/book-view.vala"
		_tmp6_ = new_selection;
#line 260 "../src/book-view.vala"
		_tmp7_ = self->priv->selected_page_view;
#line 260 "../src/book-view.vala"
		if (_tmp6_ == _tmp7_) {
#line 1377 "book-view.c"
			PageView* _tmp8_;
			PageView* _tmp9_;
#line 261 "../src/book-view.vala"
			_tmp8_ = self->priv->selected_page_view;
#line 261 "../src/book-view.vala"
			_tmp9_ = book_view_get_next_page (self, _tmp8_);
#line 261 "../src/book-view.vala"
			_g_object_unref0 (new_selection);
#line 261 "../src/book-view.vala"
			new_selection = _tmp9_;
#line 1388 "book-view.c"
		}
#line 262 "../src/book-view.vala"
		_g_object_unref0 (self->priv->selected_page_view);
#line 262 "../src/book-view.vala"
		self->priv->selected_page_view = NULL;
#line 1394 "book-view.c"
	}
#line 265 "../src/book-view.vala"
	_tmp10_ = self->priv->page_data;
#line 265 "../src/book-view.vala"
	_tmp11_ = g_hash_table_lookup (_tmp10_, page);
#line 265 "../src/book-view.vala"
	_tmp12_ = _g_object_ref0 ((PageView*) _tmp11_);
#line 265 "../src/book-view.vala"
	page_view = _tmp12_;
#line 266 "../src/book-view.vala"
	g_signal_parse_name ("changed", TYPE_PAGE_VIEW, &_tmp13_, NULL, FALSE);
#line 266 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _book_view_page_view_changed_cb_page_view_changed, self);
#line 267 "../src/book-view.vala"
	g_signal_parse_name ("size-changed", TYPE_PAGE_VIEW, &_tmp14_, NULL, FALSE);
#line 267 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self);
#line 268 "../src/book-view.vala"
	_tmp15_ = self->priv->page_data;
#line 268 "../src/book-view.vala"
	g_hash_table_remove (_tmp15_, page);
#line 270 "../src/book-view.vala"
	_tmp16_ = new_selection;
#line 270 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp16_);
#line 272 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 273 "../src/book-view.vala"
	book_view_redraw (self);
#line 252 "../src/book-view.vala"
	_g_object_unref0 (page_view);
#line 252 "../src/book-view.vala"
	_g_object_unref0 (new_selection);
#line 1428 "book-view.c"
}


static void
book_view_reorder_cb (BookView* self,
                      Book* book)
{
#line 276 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 278 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 279 "../src/book-view.vala"
	book_view_redraw (self);
#line 1444 "book-view.c"
}


static void
book_view_clear_cb (BookView* self,
                    Book* book)
{
	GHashTable* _tmp0_;
#line 282 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 282 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 284 "../src/book-view.vala"
	_tmp0_ = self->priv->page_data;
#line 284 "../src/book-view.vala"
	g_hash_table_remove_all (_tmp0_);
#line 285 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 285 "../src/book-view.vala"
	self->priv->selected_page_view = NULL;
#line 286 "../src/book-view.vala"
	g_signal_emit (self, book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL], 0, NULL);
#line 287 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 288 "../src/book-view.vala"
	book_view_redraw (self);
#line 1471 "book-view.c"
}


static gboolean
book_view_configure_cb (BookView* self,
                        GtkWidget* widget,
                        GdkEventConfigure* event)
{
	gboolean result = FALSE;
#line 291 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 291 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 291 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 293 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 294 "../src/book-view.vala"
	result = FALSE;
#line 294 "../src/book-view.vala"
	return result;
#line 1493 "book-view.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 297 "../src/book-view.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1502 "book-view.c"
}


static void
book_view_layout_into (BookView* self,
                       gint width,
                       gint height,
                       gint* book_width,
                       gint* book_height)
{
	gint _vala_book_width = 0;
	gint _vala_book_height = 0;
	GList* pages = NULL;
	gint max_dpi = 0;
	GList* _tmp8_;
	gint max_width = 0;
	gint max_height = 0;
	GList* _tmp21_;
	gdouble aspect = 0.0;
	gdouble max_aspect = 0.0;
	gint _tmp49_;
	gint _tmp50_;
	gint spacing = 0;
	GList* _tmp51_;
	GList* _tmp90_;
	gint x_offset = 0;
	GList* _tmp93_;
#line 297 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/book-view.vala"
	pages = NULL;
#line 1534 "book-view.c"
	{
		gint i = 0;
#line 300 "../src/book-view.vala"
		i = 0;
#line 1539 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 300 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 300 "../src/book-view.vala"
			while (TRUE) {
#line 1546 "book-view.c"
				gint _tmp2_;
				Book* _tmp3_;
				guint _tmp4_;
				guint _tmp5_;
				gint _tmp6_;
				PageView* _tmp7_;
#line 300 "../src/book-view.vala"
				if (!_tmp0_) {
#line 1555 "book-view.c"
					gint _tmp1_;
#line 300 "../src/book-view.vala"
					_tmp1_ = i;
#line 300 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 1561 "book-view.c"
				}
#line 300 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 300 "../src/book-view.vala"
				_tmp2_ = i;
#line 300 "../src/book-view.vala"
				_tmp3_ = self->priv->_book;
#line 300 "../src/book-view.vala"
				_tmp4_ = book_get_n_pages (_tmp3_);
#line 300 "../src/book-view.vala"
				_tmp5_ = _tmp4_;
#line 300 "../src/book-view.vala"
				if (!(((guint) _tmp2_) < _tmp5_)) {
#line 300 "../src/book-view.vala"
					break;
#line 1577 "book-view.c"
				}
#line 301 "../src/book-view.vala"
				_tmp6_ = i;
#line 301 "../src/book-view.vala"
				_tmp7_ = book_view_get_nth_page (self, _tmp6_);
#line 301 "../src/book-view.vala"
				pages = g_list_append (pages, _tmp7_);
#line 1585 "book-view.c"
			}
		}
	}
#line 304 "../src/book-view.vala"
	max_dpi = 0;
#line 305 "../src/book-view.vala"
	_tmp8_ = pages;
#line 1593 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 305 "../src/book-view.vala"
		page_collection = _tmp8_;
#line 305 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1601 "book-view.c"
			PageView* _tmp9_;
			PageView* page = NULL;
#line 305 "../src/book-view.vala"
			_tmp9_ = _g_object_ref0 ((PageView*) page_it->data);
#line 305 "../src/book-view.vala"
			page = _tmp9_;
#line 1608 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp10_;
				Page* _tmp11_;
				Page* _tmp12_;
				Page* _tmp13_;
				Page* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
#line 307 "../src/book-view.vala"
				_tmp10_ = page;
#line 307 "../src/book-view.vala"
				_tmp11_ = page_view_get_page (_tmp10_);
#line 307 "../src/book-view.vala"
				_tmp12_ = _tmp11_;
#line 307 "../src/book-view.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 307 "../src/book-view.vala"
				p = _tmp13_;
#line 308 "../src/book-view.vala"
				_tmp14_ = p;
#line 308 "../src/book-view.vala"
				_tmp15_ = page_get_dpi (_tmp14_);
#line 308 "../src/book-view.vala"
				_tmp16_ = _tmp15_;
#line 308 "../src/book-view.vala"
				_tmp17_ = max_dpi;
#line 308 "../src/book-view.vala"
				if (_tmp16_ > _tmp17_) {
#line 1639 "book-view.c"
					Page* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
#line 309 "../src/book-view.vala"
					_tmp18_ = p;
#line 309 "../src/book-view.vala"
					_tmp19_ = page_get_dpi (_tmp18_);
#line 309 "../src/book-view.vala"
					_tmp20_ = _tmp19_;
#line 309 "../src/book-view.vala"
					max_dpi = _tmp20_;
#line 1651 "book-view.c"
				}
#line 305 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 305 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1657 "book-view.c"
			}
		}
	}
#line 313 "../src/book-view.vala"
	max_width = 0;
#line 313 "../src/book-view.vala"
	max_height = 0;
#line 314 "../src/book-view.vala"
	_tmp21_ = pages;
#line 1667 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 314 "../src/book-view.vala"
		page_collection = _tmp21_;
#line 314 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1675 "book-view.c"
			PageView* _tmp22_;
			PageView* page = NULL;
#line 314 "../src/book-view.vala"
			_tmp22_ = _g_object_ref0 ((PageView*) page_it->data);
#line 314 "../src/book-view.vala"
			page = _tmp22_;
#line 1682 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp23_;
				Page* _tmp24_;
				Page* _tmp25_;
				Page* _tmp26_;
				gint w = 0;
				Page* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gint h = 0;
				Page* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				Page* _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				Page* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				gint _tmp46_;
				gint _tmp47_;
#line 316 "../src/book-view.vala"
				_tmp23_ = page;
#line 316 "../src/book-view.vala"
				_tmp24_ = page_view_get_page (_tmp23_);
#line 316 "../src/book-view.vala"
				_tmp25_ = _tmp24_;
#line 316 "../src/book-view.vala"
				_tmp26_ = _g_object_ref0 (_tmp25_);
#line 316 "../src/book-view.vala"
				p = _tmp26_;
#line 317 "../src/book-view.vala"
				_tmp27_ = p;
#line 317 "../src/book-view.vala"
				_tmp28_ = page_get_width (_tmp27_);
#line 317 "../src/book-view.vala"
				_tmp29_ = _tmp28_;
#line 317 "../src/book-view.vala"
				w = _tmp29_;
#line 318 "../src/book-view.vala"
				_tmp30_ = p;
#line 318 "../src/book-view.vala"
				_tmp31_ = page_get_height (_tmp30_);
#line 318 "../src/book-view.vala"
				_tmp32_ = _tmp31_;
#line 318 "../src/book-view.vala"
				h = _tmp32_;
#line 321 "../src/book-view.vala"
				_tmp33_ = w;
#line 321 "../src/book-view.vala"
				_tmp34_ = max_dpi;
#line 321 "../src/book-view.vala"
				_tmp35_ = p;
#line 321 "../src/book-view.vala"
				_tmp36_ = page_get_dpi (_tmp35_);
#line 321 "../src/book-view.vala"
				_tmp37_ = _tmp36_;
#line 321 "../src/book-view.vala"
				w = (gint) (((((gdouble) _tmp33_) * _tmp34_) / _tmp37_) + 0.5);
#line 322 "../src/book-view.vala"
				_tmp38_ = h;
#line 322 "../src/book-view.vala"
				_tmp39_ = max_dpi;
#line 322 "../src/book-view.vala"
				_tmp40_ = p;
#line 322 "../src/book-view.vala"
				_tmp41_ = page_get_dpi (_tmp40_);
#line 322 "../src/book-view.vala"
				_tmp42_ = _tmp41_;
#line 322 "../src/book-view.vala"
				h = (gint) (((((gdouble) _tmp38_) * _tmp39_) / _tmp42_) + 0.5);
#line 324 "../src/book-view.vala"
				_tmp43_ = w;
#line 324 "../src/book-view.vala"
				_tmp44_ = max_width;
#line 324 "../src/book-view.vala"
				if (_tmp43_ > _tmp44_) {
#line 1767 "book-view.c"
					gint _tmp45_;
#line 325 "../src/book-view.vala"
					_tmp45_ = w;
#line 325 "../src/book-view.vala"
					max_width = _tmp45_;
#line 1773 "book-view.c"
				}
#line 326 "../src/book-view.vala"
				_tmp46_ = h;
#line 326 "../src/book-view.vala"
				_tmp47_ = max_height;
#line 326 "../src/book-view.vala"
				if (_tmp46_ > _tmp47_) {
#line 1781 "book-view.c"
					gint _tmp48_;
#line 327 "../src/book-view.vala"
					_tmp48_ = h;
#line 327 "../src/book-view.vala"
					max_height = _tmp48_;
#line 1787 "book-view.c"
				}
#line 314 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 314 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1793 "book-view.c"
			}
		}
	}
#line 330 "../src/book-view.vala"
	aspect = ((gdouble) width) / height;
#line 331 "../src/book-view.vala"
	_tmp49_ = max_width;
#line 331 "../src/book-view.vala"
	_tmp50_ = max_height;
#line 331 "../src/book-view.vala"
	max_aspect = ((gdouble) _tmp49_) / _tmp50_;
#line 334 "../src/book-view.vala"
	spacing = 12;
#line 335 "../src/book-view.vala"
	_vala_book_width = 0;
#line 336 "../src/book-view.vala"
	_vala_book_height = 0;
#line 337 "../src/book-view.vala"
	_tmp51_ = pages;
#line 1813 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 337 "../src/book-view.vala"
		page_collection = _tmp51_;
#line 337 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1821 "book-view.c"
			PageView* _tmp52_;
			PageView* page = NULL;
#line 337 "../src/book-view.vala"
			_tmp52_ = _g_object_ref0 ((PageView*) page_it->data);
#line 337 "../src/book-view.vala"
			page = _tmp52_;
#line 1828 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp53_;
				Page* _tmp54_;
				Page* _tmp55_;
				Page* _tmp56_;
				gdouble _tmp57_;
				gdouble _tmp58_;
				gint h = 0;
				PageView* _tmp79_;
				gint _tmp80_;
				gint _tmp81_;
				gint _tmp82_;
				gint _tmp83_;
				gint _tmp85_;
				PageView* _tmp86_;
				gint _tmp87_;
				gint _tmp88_;
				gint _tmp89_;
#line 339 "../src/book-view.vala"
				_tmp53_ = page;
#line 339 "../src/book-view.vala"
				_tmp54_ = page_view_get_page (_tmp53_);
#line 339 "../src/book-view.vala"
				_tmp55_ = _tmp54_;
#line 339 "../src/book-view.vala"
				_tmp56_ = _g_object_ref0 (_tmp55_);
#line 339 "../src/book-view.vala"
				p = _tmp56_;
#line 342 "../src/book-view.vala"
				_tmp57_ = max_aspect;
#line 342 "../src/book-view.vala"
				_tmp58_ = aspect;
#line 342 "../src/book-view.vala"
				if (_tmp57_ > _tmp58_) {
#line 1864 "book-view.c"
					gint w = 0;
					Page* _tmp59_;
					gint _tmp60_;
					gint _tmp61_;
					gint _tmp62_;
					Page* _tmp63_;
					gint _tmp64_;
					gint _tmp65_;
					gint _tmp66_;
					PageView* _tmp67_;
					gint _tmp68_;
#line 345 "../src/book-view.vala"
					_tmp59_ = p;
#line 345 "../src/book-view.vala"
					_tmp60_ = page_get_width (_tmp59_);
#line 345 "../src/book-view.vala"
					_tmp61_ = _tmp60_;
#line 345 "../src/book-view.vala"
					_tmp62_ = max_dpi;
#line 345 "../src/book-view.vala"
					_tmp63_ = p;
#line 345 "../src/book-view.vala"
					_tmp64_ = page_get_dpi (_tmp63_);
#line 345 "../src/book-view.vala"
					_tmp65_ = _tmp64_;
#line 345 "../src/book-view.vala"
					_tmp66_ = max_width;
#line 345 "../src/book-view.vala"
					w = (gint) (((((gdouble) _tmp61_) * _tmp62_) * width) / (_tmp65_ * _tmp66_));
#line 346 "../src/book-view.vala"
					_tmp67_ = page;
#line 346 "../src/book-view.vala"
					_tmp68_ = w;
#line 346 "../src/book-view.vala"
					page_view_set_width (_tmp67_, _tmp68_);
#line 1900 "book-view.c"
				} else {
					gint h = 0;
					Page* _tmp69_;
					gint _tmp70_;
					gint _tmp71_;
					gint _tmp72_;
					Page* _tmp73_;
					gint _tmp74_;
					gint _tmp75_;
					gint _tmp76_;
					PageView* _tmp77_;
					gint _tmp78_;
#line 351 "../src/book-view.vala"
					_tmp69_ = p;
#line 351 "../src/book-view.vala"
					_tmp70_ = page_get_height (_tmp69_);
#line 351 "../src/book-view.vala"
					_tmp71_ = _tmp70_;
#line 351 "../src/book-view.vala"
					_tmp72_ = max_dpi;
#line 351 "../src/book-view.vala"
					_tmp73_ = p;
#line 351 "../src/book-view.vala"
					_tmp74_ = page_get_dpi (_tmp73_);
#line 351 "../src/book-view.vala"
					_tmp75_ = _tmp74_;
#line 351 "../src/book-view.vala"
					_tmp76_ = max_height;
#line 351 "../src/book-view.vala"
					h = (gint) (((((gdouble) _tmp71_) * _tmp72_) * height) / (_tmp75_ * _tmp76_));
#line 352 "../src/book-view.vala"
					_tmp77_ = page;
#line 352 "../src/book-view.vala"
					_tmp78_ = h;
#line 352 "../src/book-view.vala"
					page_view_set_height (_tmp77_, _tmp78_);
#line 1937 "book-view.c"
				}
#line 355 "../src/book-view.vala"
				_tmp79_ = page;
#line 355 "../src/book-view.vala"
				_tmp80_ = page_view_get_height (_tmp79_);
#line 355 "../src/book-view.vala"
				_tmp81_ = _tmp80_;
#line 355 "../src/book-view.vala"
				h = _tmp81_;
#line 356 "../src/book-view.vala"
				_tmp82_ = h;
#line 356 "../src/book-view.vala"
				_tmp83_ = _vala_book_height;
#line 356 "../src/book-view.vala"
				if (_tmp82_ > _tmp83_) {
#line 1953 "book-view.c"
					gint _tmp84_;
#line 357 "../src/book-view.vala"
					_tmp84_ = h;
#line 357 "../src/book-view.vala"
					_vala_book_height = _tmp84_;
#line 1959 "book-view.c"
				}
#line 358 "../src/book-view.vala"
				_tmp85_ = _vala_book_width;
#line 358 "../src/book-view.vala"
				_tmp86_ = page;
#line 358 "../src/book-view.vala"
				_tmp87_ = page_view_get_width (_tmp86_);
#line 358 "../src/book-view.vala"
				_tmp88_ = _tmp87_;
#line 358 "../src/book-view.vala"
				_tmp89_ = spacing;
#line 358 "../src/book-view.vala"
				_vala_book_width = _tmp85_ + (_tmp88_ + _tmp89_);
#line 337 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 337 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1977 "book-view.c"
			}
		}
	}
#line 360 "../src/book-view.vala"
	_tmp90_ = pages;
#line 360 "../src/book-view.vala"
	if (_tmp90_ != NULL) {
#line 1985 "book-view.c"
		gint _tmp91_;
		gint _tmp92_;
#line 361 "../src/book-view.vala"
		_tmp91_ = _vala_book_width;
#line 361 "../src/book-view.vala"
		_tmp92_ = spacing;
#line 361 "../src/book-view.vala"
		_vala_book_width = _tmp91_ - _tmp92_;
#line 1994 "book-view.c"
	}
#line 363 "../src/book-view.vala"
	x_offset = 0;
#line 364 "../src/book-view.vala"
	_tmp93_ = pages;
#line 2000 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 364 "../src/book-view.vala"
		page_collection = _tmp93_;
#line 364 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 2008 "book-view.c"
			PageView* _tmp94_;
			PageView* page = NULL;
#line 364 "../src/book-view.vala"
			_tmp94_ = _g_object_ref0 ((PageView*) page_it->data);
#line 364 "../src/book-view.vala"
			page = _tmp94_;
#line 2015 "book-view.c"
			{
				PageView* _tmp95_;
				gint _tmp96_;
				gint _tmp97_;
				PageView* _tmp98_;
				gint _tmp99_;
				gint _tmp100_;
				gint _tmp101_;
				PageView* _tmp102_;
				PageView* _tmp103_;
				gint _tmp104_;
				gint _tmp105_;
#line 367 "../src/book-view.vala"
				_tmp95_ = page;
#line 367 "../src/book-view.vala"
				_tmp96_ = x_offset;
#line 367 "../src/book-view.vala"
				page_view_set_x_offset (_tmp95_, _tmp96_);
#line 368 "../src/book-view.vala"
				_tmp97_ = x_offset;
#line 368 "../src/book-view.vala"
				_tmp98_ = page;
#line 368 "../src/book-view.vala"
				_tmp99_ = page_view_get_width (_tmp98_);
#line 368 "../src/book-view.vala"
				_tmp100_ = _tmp99_;
#line 368 "../src/book-view.vala"
				_tmp101_ = spacing;
#line 368 "../src/book-view.vala"
				x_offset = _tmp97_ + (_tmp100_ + _tmp101_);
#line 371 "../src/book-view.vala"
				_tmp102_ = page;
#line 371 "../src/book-view.vala"
				_tmp103_ = page;
#line 371 "../src/book-view.vala"
				_tmp104_ = page_view_get_height (_tmp103_);
#line 371 "../src/book-view.vala"
				_tmp105_ = _tmp104_;
#line 371 "../src/book-view.vala"
				page_view_set_y_offset (_tmp102_, (height - _tmp105_) / 2);
#line 364 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2058 "book-view.c"
			}
		}
	}
#line 297 "../src/book-view.vala"
	(pages == NULL) ? NULL : (pages = (_g_list_free__g_object_unref0_ (pages), NULL));
#line 297 "../src/book-view.vala"
	if (book_width) {
#line 297 "../src/book-view.vala"
		*book_width = _vala_book_width;
#line 2068 "book-view.c"
	}
#line 297 "../src/book-view.vala"
	if (book_height) {
#line 297 "../src/book-view.vala"
		*book_height = _vala_book_height;
#line 2074 "book-view.c"
	}
}


static void
book_view_layout (BookView* self)
{
	gboolean _tmp0_;
	GtkAllocation allocation = {0};
	GtkWidget* _tmp1_;
	GtkAllocation _tmp2_ = {0};
	GtkAllocation box_allocation = {0};
	GtkAllocation _tmp3_ = {0};
	gboolean right_aligned = FALSE;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	GtkAdjustment* _tmp6_;
	gint width = 0;
	GtkAllocation _tmp7_;
	gint _tmp8_;
	gint height = 0;
	GtkAllocation _tmp9_;
	gint _tmp10_;
	gint book_width = 0;
	gint book_height = 0;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gint _tmp15_;
	GtkAllocation _tmp16_;
	gint _tmp17_;
	gboolean _tmp50_;
#line 375 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 377 "../src/book-view.vala"
	_tmp0_ = self->priv->need_layout;
#line 377 "../src/book-view.vala"
	if (!_tmp0_) {
#line 378 "../src/book-view.vala"
		return;
#line 2116 "book-view.c"
	}
#line 380 "../src/book-view.vala"
	self->priv->laying_out = TRUE;
#line 383 "../src/book-view.vala"
	_tmp1_ = self->priv->drawing_area;
#line 383 "../src/book-view.vala"
	gtk_widget_get_allocation (_tmp1_, &_tmp2_);
#line 383 "../src/book-view.vala"
	allocation = _tmp2_;
#line 385 "../src/book-view.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp3_);
#line 385 "../src/book-view.vala"
	box_allocation = _tmp3_;
#line 388 "../src/book-view.vala"
	right_aligned = TRUE;
#line 389 "../src/book-view.vala"
	_tmp4_ = self->priv->adjustment;
#line 389 "../src/book-view.vala"
	_tmp5_ = self->priv->adjustment;
#line 389 "../src/book-view.vala"
	_tmp6_ = self->priv->adjustment;
#line 389 "../src/book-view.vala"
	if (gtk_adjustment_get_value (_tmp4_) < (gtk_adjustment_get_upper (_tmp5_) - gtk_adjustment_get_page_size (_tmp6_))) {
#line 390 "../src/book-view.vala"
		right_aligned = FALSE;
#line 2142 "book-view.c"
	}
#line 393 "../src/book-view.vala"
	_tmp7_ = allocation;
#line 393 "../src/book-view.vala"
	_tmp8_ = _tmp7_.width;
#line 393 "../src/book-view.vala"
	width = (gint) _tmp8_;
#line 394 "../src/book-view.vala"
	_tmp9_ = box_allocation;
#line 394 "../src/book-view.vala"
	_tmp10_ = _tmp9_.height;
#line 394 "../src/book-view.vala"
	height = (gint) (_tmp10_ - (gtk_container_get_border_width ((GtkContainer*) self) * 2));
#line 396 "../src/book-view.vala"
	_tmp11_ = width;
#line 396 "../src/book-view.vala"
	_tmp12_ = height;
#line 396 "../src/book-view.vala"
	book_view_layout_into (self, _tmp11_, _tmp12_, &_tmp13_, &_tmp14_);
#line 396 "../src/book-view.vala"
	book_width = _tmp13_;
#line 396 "../src/book-view.vala"
	book_height = _tmp14_;
#line 399 "../src/book-view.vala"
	_tmp15_ = book_width;
#line 399 "../src/book-view.vala"
	_tmp16_ = allocation;
#line 399 "../src/book-view.vala"
	_tmp17_ = _tmp16_.width;
#line 399 "../src/book-view.vala"
	if (_tmp15_ > _tmp17_) {
#line 2174 "book-view.c"
		GtkAllocation _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gint _tmp22_ = 0;
		gint _tmp23_ = 0;
		GtkAdjustment* _tmp24_;
		GtkAdjustment* _tmp25_;
		gint _tmp26_;
		GtkAdjustment* _tmp27_;
		GtkAllocation _tmp28_;
		gint _tmp29_;
		gint max_offset = 0;
		gint _tmp30_;
		GtkAllocation _tmp31_;
		gint _tmp32_;
		gboolean _tmp33_ = FALSE;
		gboolean _tmp34_;
		GtkScrollbar* _tmp39_;
#line 402 "../src/book-view.vala"
		_tmp18_ = allocation;
#line 402 "../src/book-view.vala"
		_tmp19_ = _tmp18_.height;
#line 402 "../src/book-view.vala"
		height = _tmp19_;
#line 403 "../src/book-view.vala"
		_tmp20_ = width;
#line 403 "../src/book-view.vala"
		_tmp21_ = height;
#line 403 "../src/book-view.vala"
		book_view_layout_into (self, _tmp20_, _tmp21_, &_tmp22_, &_tmp23_);
#line 403 "../src/book-view.vala"
		book_width = _tmp22_;
#line 403 "../src/book-view.vala"
		book_height = _tmp23_;
#line 406 "../src/book-view.vala"
		_tmp24_ = self->priv->adjustment;
#line 406 "../src/book-view.vala"
		gtk_adjustment_set_lower (_tmp24_, (gdouble) 0);
#line 407 "../src/book-view.vala"
		_tmp25_ = self->priv->adjustment;
#line 407 "../src/book-view.vala"
		_tmp26_ = book_width;
#line 407 "../src/book-view.vala"
		gtk_adjustment_set_upper (_tmp25_, (gdouble) _tmp26_);
#line 408 "../src/book-view.vala"
		_tmp27_ = self->priv->adjustment;
#line 408 "../src/book-view.vala"
		_tmp28_ = allocation;
#line 408 "../src/book-view.vala"
		_tmp29_ = _tmp28_.width;
#line 408 "../src/book-view.vala"
		gtk_adjustment_set_page_size (_tmp27_, (gdouble) _tmp29_);
#line 411 "../src/book-view.vala"
		_tmp30_ = book_width;
#line 411 "../src/book-view.vala"
		_tmp31_ = allocation;
#line 411 "../src/book-view.vala"
		_tmp32_ = _tmp31_.width;
#line 411 "../src/book-view.vala"
		max_offset = _tmp30_ - _tmp32_;
#line 412 "../src/book-view.vala"
		_tmp34_ = right_aligned;
#line 412 "../src/book-view.vala"
		if (_tmp34_) {
#line 412 "../src/book-view.vala"
			_tmp33_ = TRUE;
#line 2242 "book-view.c"
		} else {
			gint _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
#line 412 "../src/book-view.vala"
			_tmp35_ = book_view_get_x_offset (self);
#line 412 "../src/book-view.vala"
			_tmp36_ = _tmp35_;
#line 412 "../src/book-view.vala"
			_tmp37_ = max_offset;
#line 412 "../src/book-view.vala"
			_tmp33_ = _tmp36_ > _tmp37_;
#line 2255 "book-view.c"
		}
#line 412 "../src/book-view.vala"
		if (_tmp33_) {
#line 2259 "book-view.c"
			gint _tmp38_;
#line 413 "../src/book-view.vala"
			_tmp38_ = max_offset;
#line 413 "../src/book-view.vala"
			book_view_set_x_offset (self, _tmp38_);
#line 2265 "book-view.c"
		}
#line 415 "../src/book-view.vala"
		_tmp39_ = self->priv->scroll;
#line 415 "../src/book-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp39_, TRUE);
#line 2271 "book-view.c"
	} else {
		GtkScrollbar* _tmp40_;
		gint offset = 0;
		gint _tmp41_;
		GtkAllocation _tmp42_;
		gint _tmp43_;
		GtkAdjustment* _tmp44_;
		gint _tmp45_;
		GtkAdjustment* _tmp46_;
		gint _tmp47_;
		GtkAdjustment* _tmp48_;
		gint _tmp49_;
#line 419 "../src/book-view.vala"
		_tmp40_ = self->priv->scroll;
#line 419 "../src/book-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp40_, FALSE);
#line 420 "../src/book-view.vala"
		_tmp41_ = book_width;
#line 420 "../src/book-view.vala"
		_tmp42_ = allocation;
#line 420 "../src/book-view.vala"
		_tmp43_ = _tmp42_.width;
#line 420 "../src/book-view.vala"
		offset = (_tmp41_ - _tmp43_) / 2;
#line 421 "../src/book-view.vala"
		_tmp44_ = self->priv->adjustment;
#line 421 "../src/book-view.vala"
		_tmp45_ = offset;
#line 421 "../src/book-view.vala"
		gtk_adjustment_set_lower (_tmp44_, (gdouble) _tmp45_);
#line 422 "../src/book-view.vala"
		_tmp46_ = self->priv->adjustment;
#line 422 "../src/book-view.vala"
		_tmp47_ = offset;
#line 422 "../src/book-view.vala"
		gtk_adjustment_set_upper (_tmp46_, (gdouble) _tmp47_);
#line 423 "../src/book-view.vala"
		_tmp48_ = self->priv->adjustment;
#line 423 "../src/book-view.vala"
		gtk_adjustment_set_page_size (_tmp48_, (gdouble) 0);
#line 424 "../src/book-view.vala"
		_tmp49_ = offset;
#line 424 "../src/book-view.vala"
		book_view_set_x_offset (self, _tmp49_);
#line 2316 "book-view.c"
	}
#line 427 "../src/book-view.vala"
	_tmp50_ = self->priv->show_selected_page;
#line 427 "../src/book-view.vala"
	if (_tmp50_) {
#line 2322 "book-view.c"
		PageView* _tmp51_;
#line 428 "../src/book-view.vala"
		_tmp51_ = self->priv->selected_page_view;
#line 428 "../src/book-view.vala"
		book_view_show_page_view (self, _tmp51_);
#line 2328 "book-view.c"
	}
#line 430 "../src/book-view.vala"
	self->priv->need_layout = FALSE;
#line 431 "../src/book-view.vala"
	self->priv->show_selected_page = FALSE;
#line 432 "../src/book-view.vala"
	self->priv->laying_out = FALSE;
#line 2336 "book-view.c"
}


static gboolean
book_view_draw_cb (BookView* self,
                   GtkWidget* widget,
                   cairo_t* context)
{
	gboolean result = FALSE;
	gdouble left = 0.0;
	gdouble top = 0.0;
	gdouble right = 0.0;
	gdouble bottom = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	GList* pages = NULL;
	GList* _tmp12_;
#line 435 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 435 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 435 "../src/book-view.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 437 "../src/book-view.vala"
	book_view_layout (self);
#line 440 "../src/book-view.vala"
	cairo_clip_extents (context, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 440 "../src/book-view.vala"
	left = _tmp0_;
#line 440 "../src/book-view.vala"
	top = _tmp1_;
#line 440 "../src/book-view.vala"
	right = _tmp2_;
#line 440 "../src/book-view.vala"
	bottom = _tmp3_;
#line 442 "../src/book-view.vala"
	pages = NULL;
#line 2376 "book-view.c"
	{
		gint i = 0;
#line 443 "../src/book-view.vala"
		i = 0;
#line 2381 "book-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 443 "../src/book-view.vala"
			_tmp4_ = TRUE;
#line 443 "../src/book-view.vala"
			while (TRUE) {
#line 2388 "book-view.c"
				gint _tmp6_;
				Book* _tmp7_;
				guint _tmp8_;
				guint _tmp9_;
				gint _tmp10_;
				PageView* _tmp11_;
#line 443 "../src/book-view.vala"
				if (!_tmp4_) {
#line 2397 "book-view.c"
					gint _tmp5_;
#line 443 "../src/book-view.vala"
					_tmp5_ = i;
#line 443 "../src/book-view.vala"
					i = _tmp5_ + 1;
#line 2403 "book-view.c"
				}
#line 443 "../src/book-view.vala"
				_tmp4_ = FALSE;
#line 443 "../src/book-view.vala"
				_tmp6_ = i;
#line 443 "../src/book-view.vala"
				_tmp7_ = self->priv->_book;
#line 443 "../src/book-view.vala"
				_tmp8_ = book_get_n_pages (_tmp7_);
#line 443 "../src/book-view.vala"
				_tmp9_ = _tmp8_;
#line 443 "../src/book-view.vala"
				if (!(((guint) _tmp6_) < _tmp9_)) {
#line 443 "../src/book-view.vala"
					break;
#line 2419 "book-view.c"
				}
#line 444 "../src/book-view.vala"
				_tmp10_ = i;
#line 444 "../src/book-view.vala"
				_tmp11_ = book_view_get_nth_page (self, _tmp10_);
#line 444 "../src/book-view.vala"
				pages = g_list_append (pages, _tmp11_);
#line 2427 "book-view.c"
			}
		}
	}
#line 447 "../src/book-view.vala"
	_tmp12_ = pages;
#line 2433 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 447 "../src/book-view.vala"
		page_collection = _tmp12_;
#line 447 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 2441 "book-view.c"
			PageView* _tmp13_;
			PageView* page = NULL;
#line 447 "../src/book-view.vala"
			_tmp13_ = _g_object_ref0 ((PageView*) page_it->data);
#line 447 "../src/book-view.vala"
			page = _tmp13_;
#line 2448 "book-view.c"
			{
				gint left_edge = 0;
				PageView* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint right_edge = 0;
				PageView* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				PageView* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gboolean _tmp27_ = FALSE;
				gint _tmp28_;
				gdouble _tmp29_;
				gint _tmp32_;
				gint _tmp33_;
				PageView* _tmp34_;
				PageView* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
#line 449 "../src/book-view.vala"
				_tmp14_ = page;
#line 449 "../src/book-view.vala"
				_tmp15_ = page_view_get_x_offset (_tmp14_);
#line 449 "../src/book-view.vala"
				_tmp16_ = _tmp15_;
#line 449 "../src/book-view.vala"
				_tmp17_ = book_view_get_x_offset (self);
#line 449 "../src/book-view.vala"
				_tmp18_ = _tmp17_;
#line 449 "../src/book-view.vala"
				left_edge = _tmp16_ - _tmp18_;
#line 450 "../src/book-view.vala"
				_tmp19_ = page;
#line 450 "../src/book-view.vala"
				_tmp20_ = page_view_get_x_offset (_tmp19_);
#line 450 "../src/book-view.vala"
				_tmp21_ = _tmp20_;
#line 450 "../src/book-view.vala"
				_tmp22_ = page;
#line 450 "../src/book-view.vala"
				_tmp23_ = page_view_get_width (_tmp22_);
#line 450 "../src/book-view.vala"
				_tmp24_ = _tmp23_;
#line 450 "../src/book-view.vala"
				_tmp25_ = book_view_get_x_offset (self);
#line 450 "../src/book-view.vala"
				_tmp26_ = _tmp25_;
#line 450 "../src/book-view.vala"
				right_edge = (_tmp21_ + _tmp24_) - _tmp26_;
#line 453 "../src/book-view.vala"
				_tmp28_ = right_edge;
#line 453 "../src/book-view.vala"
				_tmp29_ = left;
#line 453 "../src/book-view.vala"
				if (((gdouble) _tmp28_) < _tmp29_) {
#line 453 "../src/book-view.vala"
					_tmp27_ = TRUE;
#line 2512 "book-view.c"
				} else {
					gint _tmp30_;
					gdouble _tmp31_;
#line 453 "../src/book-view.vala"
					_tmp30_ = left_edge;
#line 453 "../src/book-view.vala"
					_tmp31_ = right;
#line 453 "../src/book-view.vala"
					_tmp27_ = ((gdouble) _tmp30_) > _tmp31_;
#line 2522 "book-view.c"
				}
#line 453 "../src/book-view.vala"
				if (_tmp27_) {
#line 454 "../src/book-view.vala"
					_g_object_unref0 (page);
#line 454 "../src/book-view.vala"
					continue;
#line 2530 "book-view.c"
				}
#line 456 "../src/book-view.vala"
				cairo_save (context);
#line 457 "../src/book-view.vala"
				_tmp32_ = book_view_get_x_offset (self);
#line 457 "../src/book-view.vala"
				_tmp33_ = _tmp32_;
#line 457 "../src/book-view.vala"
				cairo_translate (context, (gdouble) (-_tmp33_), (gdouble) 0);
#line 458 "../src/book-view.vala"
				_tmp34_ = page;
#line 458 "../src/book-view.vala"
				page_view_render (_tmp34_, context);
#line 459 "../src/book-view.vala"
				cairo_restore (context);
#line 461 "../src/book-view.vala"
				_tmp35_ = page;
#line 461 "../src/book-view.vala"
				_tmp36_ = page_view_get_selected (_tmp35_);
#line 461 "../src/book-view.vala"
				_tmp37_ = _tmp36_;
#line 461 "../src/book-view.vala"
				if (_tmp37_) {
#line 2554 "book-view.c"
					GtkWidget* _tmp38_;
					GtkStyleContext* _tmp39_;
					PageView* _tmp40_;
					gint _tmp41_;
					gint _tmp42_;
					gint _tmp43_;
					gint _tmp44_;
					PageView* _tmp45_;
					gint _tmp46_;
					gint _tmp47_;
					PageView* _tmp48_;
					gint _tmp49_;
					gint _tmp50_;
					PageView* _tmp51_;
					gint _tmp52_;
					gint _tmp53_;
#line 462 "../src/book-view.vala"
					_tmp38_ = self->priv->drawing_area;
#line 462 "../src/book-view.vala"
					_tmp39_ = gtk_widget_get_style_context (_tmp38_);
#line 462 "../src/book-view.vala"
					_tmp40_ = page;
#line 462 "../src/book-view.vala"
					_tmp41_ = page_view_get_x_offset (_tmp40_);
#line 462 "../src/book-view.vala"
					_tmp42_ = _tmp41_;
#line 462 "../src/book-view.vala"
					_tmp43_ = book_view_get_x_offset (self);
#line 462 "../src/book-view.vala"
					_tmp44_ = _tmp43_;
#line 462 "../src/book-view.vala"
					_tmp45_ = page;
#line 462 "../src/book-view.vala"
					_tmp46_ = page_view_get_y_offset (_tmp45_);
#line 462 "../src/book-view.vala"
					_tmp47_ = _tmp46_;
#line 462 "../src/book-view.vala"
					_tmp48_ = page;
#line 462 "../src/book-view.vala"
					_tmp49_ = page_view_get_width (_tmp48_);
#line 462 "../src/book-view.vala"
					_tmp50_ = _tmp49_;
#line 462 "../src/book-view.vala"
					_tmp51_ = page;
#line 462 "../src/book-view.vala"
					_tmp52_ = page_view_get_height (_tmp51_);
#line 462 "../src/book-view.vala"
					_tmp53_ = _tmp52_;
#line 462 "../src/book-view.vala"
					gtk_render_focus (_tmp39_, context, (gdouble) (_tmp42_ - _tmp44_), (gdouble) _tmp47_, (gdouble) _tmp50_, (gdouble) _tmp53_);
#line 2605 "book-view.c"
				}
#line 447 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2609 "book-view.c"
			}
		}
	}
#line 469 "../src/book-view.vala"
	result = FALSE;
#line 469 "../src/book-view.vala"
	(pages == NULL) ? NULL : (pages = (_g_list_free__g_object_unref0_ (pages), NULL));
#line 469 "../src/book-view.vala"
	return result;
#line 2619 "book-view.c"
}


static PageView*
book_view_get_page_at (BookView* self,
                       gint x,
                       gint y,
                       gint* x_,
                       gint* y_)
{
	gint _vala_x_ = 0;
	gint _vala_y_ = 0;
	PageView* result = NULL;
	gint _tmp0_;
#line 472 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 474 "../src/book-view.vala"
	_vala_y_ = 0;
#line 474 "../src/book-view.vala"
	_tmp0_ = _vala_y_;
#line 474 "../src/book-view.vala"
	_vala_x_ = _tmp0_;
#line 2642 "book-view.c"
	{
		gint i = 0;
#line 475 "../src/book-view.vala"
		i = 0;
#line 2647 "book-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 475 "../src/book-view.vala"
			_tmp1_ = TRUE;
#line 475 "../src/book-view.vala"
			while (TRUE) {
#line 2654 "book-view.c"
				gint _tmp3_;
				Book* _tmp4_;
				guint _tmp5_;
				guint _tmp6_;
				PageView* page = NULL;
				gint _tmp7_;
				PageView* _tmp8_;
				gint left = 0;
				PageView* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint right = 0;
				gint _tmp12_;
				PageView* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint top = 0;
				PageView* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint bottom = 0;
				gint _tmp19_;
				PageView* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				gboolean _tmp25_ = FALSE;
				gint _tmp26_;
#line 475 "../src/book-view.vala"
				if (!_tmp1_) {
#line 2686 "book-view.c"
					gint _tmp2_;
#line 475 "../src/book-view.vala"
					_tmp2_ = i;
#line 475 "../src/book-view.vala"
					i = _tmp2_ + 1;
#line 2692 "book-view.c"
				}
#line 475 "../src/book-view.vala"
				_tmp1_ = FALSE;
#line 475 "../src/book-view.vala"
				_tmp3_ = i;
#line 475 "../src/book-view.vala"
				_tmp4_ = self->priv->_book;
#line 475 "../src/book-view.vala"
				_tmp5_ = book_get_n_pages (_tmp4_);
#line 475 "../src/book-view.vala"
				_tmp6_ = _tmp5_;
#line 475 "../src/book-view.vala"
				if (!(((guint) _tmp3_) < _tmp6_)) {
#line 475 "../src/book-view.vala"
					break;
#line 2708 "book-view.c"
				}
#line 477 "../src/book-view.vala"
				_tmp7_ = i;
#line 477 "../src/book-view.vala"
				_tmp8_ = book_view_get_nth_page (self, _tmp7_);
#line 477 "../src/book-view.vala"
				page = _tmp8_;
#line 478 "../src/book-view.vala"
				_tmp9_ = page;
#line 478 "../src/book-view.vala"
				_tmp10_ = page_view_get_x_offset (_tmp9_);
#line 478 "../src/book-view.vala"
				_tmp11_ = _tmp10_;
#line 478 "../src/book-view.vala"
				left = _tmp11_;
#line 479 "../src/book-view.vala"
				_tmp12_ = left;
#line 479 "../src/book-view.vala"
				_tmp13_ = page;
#line 479 "../src/book-view.vala"
				_tmp14_ = page_view_get_width (_tmp13_);
#line 479 "../src/book-view.vala"
				_tmp15_ = _tmp14_;
#line 479 "../src/book-view.vala"
				right = _tmp12_ + _tmp15_;
#line 480 "../src/book-view.vala"
				_tmp16_ = page;
#line 480 "../src/book-view.vala"
				_tmp17_ = page_view_get_y_offset (_tmp16_);
#line 480 "../src/book-view.vala"
				_tmp18_ = _tmp17_;
#line 480 "../src/book-view.vala"
				top = _tmp18_;
#line 481 "../src/book-view.vala"
				_tmp19_ = top;
#line 481 "../src/book-view.vala"
				_tmp20_ = page;
#line 481 "../src/book-view.vala"
				_tmp21_ = page_view_get_height (_tmp20_);
#line 481 "../src/book-view.vala"
				_tmp22_ = _tmp21_;
#line 481 "../src/book-view.vala"
				bottom = _tmp19_ + _tmp22_;
#line 482 "../src/book-view.vala"
				_tmp26_ = left;
#line 482 "../src/book-view.vala"
				if (x >= _tmp26_) {
#line 2756 "book-view.c"
					gint _tmp27_;
#line 482 "../src/book-view.vala"
					_tmp27_ = right;
#line 482 "../src/book-view.vala"
					_tmp25_ = x <= _tmp27_;
#line 2762 "book-view.c"
				} else {
#line 482 "../src/book-view.vala"
					_tmp25_ = FALSE;
#line 2766 "book-view.c"
				}
#line 482 "../src/book-view.vala"
				if (_tmp25_) {
#line 2770 "book-view.c"
					gint _tmp28_;
#line 482 "../src/book-view.vala"
					_tmp28_ = top;
#line 482 "../src/book-view.vala"
					_tmp24_ = y >= _tmp28_;
#line 2776 "book-view.c"
				} else {
#line 482 "../src/book-view.vala"
					_tmp24_ = FALSE;
#line 2780 "book-view.c"
				}
#line 482 "../src/book-view.vala"
				if (_tmp24_) {
#line 2784 "book-view.c"
					gint _tmp29_;
#line 482 "../src/book-view.vala"
					_tmp29_ = bottom;
#line 482 "../src/book-view.vala"
					_tmp23_ = y <= _tmp29_;
#line 2790 "book-view.c"
				} else {
#line 482 "../src/book-view.vala"
					_tmp23_ = FALSE;
#line 2794 "book-view.c"
				}
#line 482 "../src/book-view.vala"
				if (_tmp23_) {
#line 2798 "book-view.c"
					gint _tmp30_;
					gint _tmp31_;
#line 484 "../src/book-view.vala"
					_tmp30_ = left;
#line 484 "../src/book-view.vala"
					_vala_x_ = x - _tmp30_;
#line 485 "../src/book-view.vala"
					_tmp31_ = top;
#line 485 "../src/book-view.vala"
					_vala_y_ = y - _tmp31_;
#line 486 "../src/book-view.vala"
					result = page;
#line 486 "../src/book-view.vala"
					if (x_) {
#line 486 "../src/book-view.vala"
						*x_ = _vala_x_;
#line 2815 "book-view.c"
					}
#line 486 "../src/book-view.vala"
					if (y_) {
#line 486 "../src/book-view.vala"
						*y_ = _vala_y_;
#line 2821 "book-view.c"
					}
#line 486 "../src/book-view.vala"
					return result;
#line 2825 "book-view.c"
				}
#line 475 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2829 "book-view.c"
			}
		}
	}
#line 490 "../src/book-view.vala"
	result = NULL;
#line 490 "../src/book-view.vala"
	if (x_) {
#line 490 "../src/book-view.vala"
		*x_ = _vala_x_;
#line 2839 "book-view.c"
	}
#line 490 "../src/book-view.vala"
	if (y_) {
#line 490 "../src/book-view.vala"
		*y_ = _vala_y_;
#line 2845 "book-view.c"
	}
#line 490 "../src/book-view.vala"
	return result;
#line 2849 "book-view.c"
}


static gboolean
book_view_button_cb (BookView* self,
                     GtkWidget* widget,
                     GdkEventButton* event)
{
	gboolean result = FALSE;
	GtkWidget* _tmp0_;
	gint x = 0;
	gint y = 0;
	GdkEventType _tmp1_;
	PageView* _tmp10_;
	guint _tmp11_;
	guint _tmp23_;
#line 493 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 493 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 493 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 495 "../src/book-view.vala"
	book_view_layout (self);
#line 497 "../src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 497 "../src/book-view.vala"
	gtk_widget_grab_focus (_tmp0_);
#line 499 "../src/book-view.vala"
	x = 0;
#line 499 "../src/book-view.vala"
	y = 0;
#line 500 "../src/book-view.vala"
	_tmp1_ = event->type;
#line 500 "../src/book-view.vala"
	if (_tmp1_ == GDK_BUTTON_PRESS) {
#line 2886 "book-view.c"
		gdouble _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gdouble _tmp5_;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
		PageView* _tmp8_;
		PageView* _tmp9_;
#line 501 "../src/book-view.vala"
		_tmp2_ = event->x;
#line 501 "../src/book-view.vala"
		_tmp3_ = book_view_get_x_offset (self);
#line 501 "../src/book-view.vala"
		_tmp4_ = _tmp3_;
#line 501 "../src/book-view.vala"
		_tmp5_ = event->y;
#line 501 "../src/book-view.vala"
		_tmp8_ = book_view_get_page_at (self, (gint) (_tmp2_ + _tmp4_), (gint) _tmp5_, &_tmp6_, &_tmp7_);
#line 501 "../src/book-view.vala"
		x = _tmp6_;
#line 501 "../src/book-view.vala"
		y = _tmp7_;
#line 501 "../src/book-view.vala"
		_tmp9_ = _tmp8_;
#line 501 "../src/book-view.vala"
		book_view_select_page_view (self, _tmp9_);
#line 501 "../src/book-view.vala"
		_g_object_unref0 (_tmp9_);
#line 2915 "book-view.c"
	}
#line 503 "../src/book-view.vala"
	_tmp10_ = self->priv->selected_page_view;
#line 503 "../src/book-view.vala"
	if (_tmp10_ == NULL) {
#line 504 "../src/book-view.vala"
		result = FALSE;
#line 504 "../src/book-view.vala"
		return result;
#line 2925 "book-view.c"
	}
#line 507 "../src/book-view.vala"
	_tmp11_ = event->button;
#line 507 "../src/book-view.vala"
	if (_tmp11_ == ((guint) 1)) {
#line 2931 "book-view.c"
		GdkEventType _tmp12_;
#line 509 "../src/book-view.vala"
		_tmp12_ = event->type;
#line 509 "../src/book-view.vala"
		if (_tmp12_ == GDK_BUTTON_PRESS) {
#line 2937 "book-view.c"
			PageView* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 510 "../src/book-view.vala"
			_tmp13_ = self->priv->selected_page_view;
#line 510 "../src/book-view.vala"
			_tmp14_ = x;
#line 510 "../src/book-view.vala"
			_tmp15_ = y;
#line 510 "../src/book-view.vala"
			page_view_button_press (_tmp13_, _tmp14_, _tmp15_);
#line 2949 "book-view.c"
		} else {
			GdkEventType _tmp16_;
#line 511 "../src/book-view.vala"
			_tmp16_ = event->type;
#line 511 "../src/book-view.vala"
			if (_tmp16_ == GDK_BUTTON_RELEASE) {
#line 2956 "book-view.c"
				PageView* _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 512 "../src/book-view.vala"
				_tmp17_ = self->priv->selected_page_view;
#line 512 "../src/book-view.vala"
				_tmp18_ = x;
#line 512 "../src/book-view.vala"
				_tmp19_ = y;
#line 512 "../src/book-view.vala"
				page_view_button_release (_tmp17_, _tmp18_, _tmp19_);
#line 2968 "book-view.c"
			} else {
				GdkEventType _tmp20_;
#line 513 "../src/book-view.vala"
				_tmp20_ = event->type;
#line 513 "../src/book-view.vala"
				if (_tmp20_ == GDK_2BUTTON_PRESS) {
#line 2975 "book-view.c"
					Page* _tmp21_;
					Page* _tmp22_;
#line 514 "../src/book-view.vala"
					_tmp21_ = book_view_get_selected_page (self);
#line 514 "../src/book-view.vala"
					_tmp22_ = _tmp21_;
#line 514 "../src/book-view.vala"
					g_signal_emit (self, book_view_signals[BOOK_VIEW_SHOW_PAGE_SIGNAL], 0, _tmp22_);
#line 2984 "book-view.c"
				}
			}
		}
	}
#line 518 "../src/book-view.vala"
	_tmp23_ = event->button;
#line 518 "../src/book-view.vala"
	if (_tmp23_ == ((guint) 3)) {
#line 519 "../src/book-view.vala"
		g_signal_emit (self, book_view_signals[BOOK_VIEW_SHOW_MENU_SIGNAL], 0, (GdkEvent*) event);
#line 2995 "book-view.c"
	}
#line 521 "../src/book-view.vala"
	result = FALSE;
#line 521 "../src/book-view.vala"
	return result;
#line 3001 "book-view.c"
}


static void
book_view_set_cursor (BookView* self,
                      GdkCursorType cursor)
{
	GdkCursor* c = NULL;
	GdkCursorType _tmp0_;
	GdkDisplay* _tmp1_;
	GdkCursor* _tmp2_;
	GtkWidget* _tmp3_;
	GdkWindow* _tmp4_;
	GdkCursor* _tmp5_;
#line 524 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 528 "../src/book-view.vala"
	_tmp0_ = self->priv->cursor;
#line 528 "../src/book-view.vala"
	if (_tmp0_ == cursor) {
#line 529 "../src/book-view.vala"
		_g_object_unref0 (c);
#line 529 "../src/book-view.vala"
		return;
#line 3026 "book-view.c"
	}
#line 530 "../src/book-view.vala"
	self->priv->cursor = cursor;
#line 532 "../src/book-view.vala"
	_tmp1_ = gtk_widget_get_display ((GtkWidget*) self);
#line 532 "../src/book-view.vala"
	_tmp2_ = gdk_cursor_new_for_display (_tmp1_, cursor);
#line 532 "../src/book-view.vala"
	_g_object_unref0 (c);
#line 532 "../src/book-view.vala"
	c = _tmp2_;
#line 533 "../src/book-view.vala"
	_tmp3_ = self->priv->drawing_area;
#line 533 "../src/book-view.vala"
	_tmp4_ = gtk_widget_get_window (_tmp3_);
#line 533 "../src/book-view.vala"
	_tmp5_ = c;
#line 533 "../src/book-view.vala"
	gdk_window_set_cursor (_tmp4_, _tmp5_);
#line 524 "../src/book-view.vala"
	_g_object_unref0 (c);
#line 3048 "book-view.c"
}


static gboolean
book_view_motion_cb (BookView* self,
                     GtkWidget* widget,
                     GdkEventMotion* event)
{
	gboolean result = FALSE;
	GdkCursorType cursor = 0;
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_;
	GdkCursorType _tmp33_;
#line 536 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 536 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 536 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 538 "../src/book-view.vala"
	cursor = GDK_ARROW;
#line 541 "../src/book-view.vala"
	_tmp1_ = self->priv->selected_page_view;
#line 541 "../src/book-view.vala"
	if (_tmp1_ != NULL) {
#line 3074 "book-view.c"
		GdkModifierType _tmp2_;
#line 541 "../src/book-view.vala"
		_tmp2_ = event->state;
#line 541 "../src/book-view.vala"
		_tmp0_ = (_tmp2_ & GDK_BUTTON1_MASK) != 0;
#line 3080 "book-view.c"
	} else {
#line 541 "../src/book-view.vala"
		_tmp0_ = FALSE;
#line 3084 "book-view.c"
	}
#line 541 "../src/book-view.vala"
	if (_tmp0_) {
#line 3088 "book-view.c"
		gint x = 0;
		gdouble _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		PageView* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint y = 0;
		gdouble _tmp9_;
		PageView* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		PageView* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		PageView* _tmp16_;
		GdkCursorType _tmp17_;
		GdkCursorType _tmp18_;
#line 543 "../src/book-view.vala"
		_tmp3_ = event->x;
#line 543 "../src/book-view.vala"
		_tmp4_ = book_view_get_x_offset (self);
#line 543 "../src/book-view.vala"
		_tmp5_ = _tmp4_;
#line 543 "../src/book-view.vala"
		_tmp6_ = self->priv->selected_page_view;
#line 543 "../src/book-view.vala"
		_tmp7_ = page_view_get_x_offset (_tmp6_);
#line 543 "../src/book-view.vala"
		_tmp8_ = _tmp7_;
#line 543 "../src/book-view.vala"
		x = (gint) ((_tmp3_ + _tmp5_) - _tmp8_);
#line 544 "../src/book-view.vala"
		_tmp9_ = event->y;
#line 544 "../src/book-view.vala"
		_tmp10_ = self->priv->selected_page_view;
#line 544 "../src/book-view.vala"
		_tmp11_ = page_view_get_y_offset (_tmp10_);
#line 544 "../src/book-view.vala"
		_tmp12_ = _tmp11_;
#line 544 "../src/book-view.vala"
		y = (gint) (_tmp9_ - _tmp12_);
#line 545 "../src/book-view.vala"
		_tmp13_ = self->priv->selected_page_view;
#line 545 "../src/book-view.vala"
		_tmp14_ = x;
#line 545 "../src/book-view.vala"
		_tmp15_ = y;
#line 545 "../src/book-view.vala"
		page_view_motion (_tmp13_, _tmp14_, _tmp15_);
#line 546 "../src/book-view.vala"
		_tmp16_ = self->priv->selected_page_view;
#line 546 "../src/book-view.vala"
		_tmp17_ = page_view_get_cursor (_tmp16_);
#line 546 "../src/book-view.vala"
		_tmp18_ = _tmp17_;
#line 546 "../src/book-view.vala"
		cursor = _tmp18_;
#line 3147 "book-view.c"
	} else {
		gint x = 0;
		gint y = 0;
		PageView* over_page = NULL;
		gdouble _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		gdouble _tmp22_;
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
		PageView* _tmp25_;
		PageView* _tmp26_;
#line 551 "../src/book-view.vala"
		_tmp19_ = event->x;
#line 551 "../src/book-view.vala"
		_tmp20_ = book_view_get_x_offset (self);
#line 551 "../src/book-view.vala"
		_tmp21_ = _tmp20_;
#line 551 "../src/book-view.vala"
		_tmp22_ = event->y;
#line 551 "../src/book-view.vala"
		_tmp25_ = book_view_get_page_at (self, (gint) (_tmp19_ + _tmp21_), (gint) _tmp22_, &_tmp23_, &_tmp24_);
#line 551 "../src/book-view.vala"
		x = _tmp23_;
#line 551 "../src/book-view.vala"
		y = _tmp24_;
#line 551 "../src/book-view.vala"
		over_page = _tmp25_;
#line 552 "../src/book-view.vala"
		_tmp26_ = over_page;
#line 552 "../src/book-view.vala"
		if (_tmp26_ != NULL) {
#line 3180 "book-view.c"
			PageView* _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
			PageView* _tmp30_;
			GdkCursorType _tmp31_;
			GdkCursorType _tmp32_;
#line 554 "../src/book-view.vala"
			_tmp27_ = over_page;
#line 554 "../src/book-view.vala"
			_tmp28_ = x;
#line 554 "../src/book-view.vala"
			_tmp29_ = y;
#line 554 "../src/book-view.vala"
			page_view_motion (_tmp27_, _tmp28_, _tmp29_);
#line 555 "../src/book-view.vala"
			_tmp30_ = over_page;
#line 555 "../src/book-view.vala"
			_tmp31_ = page_view_get_cursor (_tmp30_);
#line 555 "../src/book-view.vala"
			_tmp32_ = _tmp31_;
#line 555 "../src/book-view.vala"
			cursor = _tmp32_;
#line 3203 "book-view.c"
		}
#line 541 "../src/book-view.vala"
		_g_object_unref0 (over_page);
#line 3207 "book-view.c"
	}
#line 559 "../src/book-view.vala"
	_tmp33_ = cursor;
#line 559 "../src/book-view.vala"
	book_view_set_cursor (self, _tmp33_);
#line 561 "../src/book-view.vala"
	result = FALSE;
#line 561 "../src/book-view.vala"
	return result;
#line 3217 "book-view.c"
}


static gboolean
book_view_key_cb (BookView* self,
                  GtkWidget* widget,
                  GdkEventKey* event)
{
	gboolean result = FALSE;
	guint _tmp0_;
#line 564 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 564 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 564 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 566 "../src/book-view.vala"
	_tmp0_ = event->keyval;
#line 566 "../src/book-view.vala"
	switch (_tmp0_) {
#line 566 "../src/book-view.vala"
		case 0xff50:
#line 3240 "book-view.c"
		{
			Book* _tmp1_;
			Page* _tmp2_;
			Page* _tmp3_;
#line 569 "../src/book-view.vala"
			_tmp1_ = self->priv->_book;
#line 569 "../src/book-view.vala"
			_tmp2_ = book_get_page (_tmp1_, 0);
#line 569 "../src/book-view.vala"
			_tmp3_ = _tmp2_;
#line 569 "../src/book-view.vala"
			book_view_set_selected_page (self, _tmp3_);
#line 569 "../src/book-view.vala"
			_g_object_unref0 (_tmp3_);
#line 570 "../src/book-view.vala"
			result = TRUE;
#line 570 "../src/book-view.vala"
			return result;
#line 3259 "book-view.c"
		}
#line 566 "../src/book-view.vala"
		case 0xff51:
#line 3263 "book-view.c"
		{
			PageView* _tmp4_;
			PageView* _tmp5_;
			PageView* _tmp6_;
#line 572 "../src/book-view.vala"
			_tmp4_ = self->priv->selected_page_view;
#line 572 "../src/book-view.vala"
			_tmp5_ = book_view_get_prev_page (self, _tmp4_);
#line 572 "../src/book-view.vala"
			_tmp6_ = _tmp5_;
#line 572 "../src/book-view.vala"
			book_view_select_page_view (self, _tmp6_);
#line 572 "../src/book-view.vala"
			_g_object_unref0 (_tmp6_);
#line 573 "../src/book-view.vala"
			result = TRUE;
#line 573 "../src/book-view.vala"
			return result;
#line 3282 "book-view.c"
		}
#line 566 "../src/book-view.vala"
		case 0xff53:
#line 3286 "book-view.c"
		{
			PageView* _tmp7_;
			PageView* _tmp8_;
			PageView* _tmp9_;
#line 575 "../src/book-view.vala"
			_tmp7_ = self->priv->selected_page_view;
#line 575 "../src/book-view.vala"
			_tmp8_ = book_view_get_next_page (self, _tmp7_);
#line 575 "../src/book-view.vala"
			_tmp9_ = _tmp8_;
#line 575 "../src/book-view.vala"
			book_view_select_page_view (self, _tmp9_);
#line 575 "../src/book-view.vala"
			_g_object_unref0 (_tmp9_);
#line 576 "../src/book-view.vala"
			result = TRUE;
#line 576 "../src/book-view.vala"
			return result;
#line 3305 "book-view.c"
		}
#line 566 "../src/book-view.vala"
		case 0xFF57:
#line 3309 "book-view.c"
		{
			Book* _tmp10_;
			Book* _tmp11_;
			guint _tmp12_;
			guint _tmp13_;
			Page* _tmp14_;
			Page* _tmp15_;
#line 578 "../src/book-view.vala"
			_tmp10_ = self->priv->_book;
#line 578 "../src/book-view.vala"
			_tmp11_ = self->priv->_book;
#line 578 "../src/book-view.vala"
			_tmp12_ = book_get_n_pages (_tmp11_);
#line 578 "../src/book-view.vala"
			_tmp13_ = _tmp12_;
#line 578 "../src/book-view.vala"
			_tmp14_ = book_get_page (_tmp10_, ((gint) _tmp13_) - 1);
#line 578 "../src/book-view.vala"
			_tmp15_ = _tmp14_;
#line 578 "../src/book-view.vala"
			book_view_set_selected_page (self, _tmp15_);
#line 578 "../src/book-view.vala"
			_g_object_unref0 (_tmp15_);
#line 579 "../src/book-view.vala"
			result = TRUE;
#line 579 "../src/book-view.vala"
			return result;
#line 3337 "book-view.c"
		}
		default:
		{
#line 582 "../src/book-view.vala"
			result = FALSE;
#line 582 "../src/book-view.vala"
			return result;
#line 3345 "book-view.c"
		}
	}
}


static gboolean
book_view_focus_cb (BookView* self,
                    GtkWidget* widget,
                    GdkEventFocus* event)
{
	gboolean result = FALSE;
	PageView* _tmp0_;
#line 586 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 586 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 586 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 588 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 588 "../src/book-view.vala"
	book_view_set_selected_page_view (self, _tmp0_);
#line 589 "../src/book-view.vala"
	result = FALSE;
#line 589 "../src/book-view.vala"
	return result;
#line 3372 "book-view.c"
}


static void
book_view_scroll_cb (BookView* self,
                     GtkAdjustment* adjustment)
{
	gboolean _tmp0_;
#line 592 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 592 "../src/book-view.vala"
	g_return_if_fail (adjustment != NULL);
#line 594 "../src/book-view.vala"
	_tmp0_ = self->priv->laying_out;
#line 594 "../src/book-view.vala"
	if (!_tmp0_) {
#line 595 "../src/book-view.vala"
		book_view_redraw (self);
#line 3391 "book-view.c"
	}
}


void
book_view_redraw (BookView* self)
{
	GtkWidget* _tmp0_;
#line 598 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 600 "../src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 600 "../src/book-view.vala"
	gtk_widget_queue_draw (_tmp0_);
#line 3406 "book-view.c"
}


void
book_view_select_next_page (BookView* self)
{
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
#line 603 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 605 "../src/book-view.vala"
	_tmp1_ = book_view_get_next_page (self, _tmp0_);
#line 605 "../src/book-view.vala"
	_tmp2_ = _tmp1_;
#line 605 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp2_);
#line 605 "../src/book-view.vala"
	_g_object_unref0 (_tmp2_);
#line 3428 "book-view.c"
}


void
book_view_select_prev_page (BookView* self)
{
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
#line 608 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 610 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 610 "../src/book-view.vala"
	_tmp1_ = book_view_get_prev_page (self, _tmp0_);
#line 610 "../src/book-view.vala"
	_tmp2_ = _tmp1_;
#line 610 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp2_);
#line 610 "../src/book-view.vala"
	_g_object_unref0 (_tmp2_);
#line 3450 "book-view.c"
}


Book*
book_view_get_book (BookView* self)
{
	Book* result;
	Book* _tmp0_;
#line 18 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 18 "../src/book-view.vala"
	result = _tmp0_;
#line 18 "../src/book-view.vala"
	return result;
#line 3467 "book-view.c"
}


static void
book_view_set_book (BookView* self,
                    Book* value)
{
#line 18 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/book-view.vala"
	if (book_view_get_book (self) != value) {
#line 3479 "book-view.c"
		Book* _tmp0_;
#line 18 "../src/book-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/book-view.vala"
		_g_object_unref0 (self->priv->_book);
#line 18 "../src/book-view.vala"
		self->priv->_book = _tmp0_;
#line 18 "../src/book-view.vala"
		g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_BOOK_PROPERTY]);
#line 3489 "book-view.c"
	}
}


Page*
book_view_get_selected_page (BookView* self)
{
	Page* result;
	PageView* _tmp0_;
#line 30 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 32 "../src/book-view.vala"
	if (_tmp0_ != NULL) {
#line 3505 "book-view.c"
		PageView* _tmp1_;
		Page* _tmp2_;
		Page* _tmp3_;
#line 33 "../src/book-view.vala"
		_tmp1_ = self->priv->selected_page_view;
#line 33 "../src/book-view.vala"
		_tmp2_ = page_view_get_page (_tmp1_);
#line 33 "../src/book-view.vala"
		_tmp3_ = _tmp2_;
#line 33 "../src/book-view.vala"
		result = _tmp3_;
#line 33 "../src/book-view.vala"
		return result;
#line 3519 "book-view.c"
	} else {
#line 35 "../src/book-view.vala"
		result = NULL;
#line 35 "../src/book-view.vala"
		return result;
#line 3525 "book-view.c"
	}
}


void
book_view_set_selected_page (BookView* self,
                             Page* value)
{
	Page* _tmp0_;
	Page* _tmp1_;
#line 37 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/book-view.vala"
	_tmp0_ = book_view_get_selected_page (self);
#line 39 "../src/book-view.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/book-view.vala"
	if (_tmp1_ == value) {
#line 40 "../src/book-view.vala"
		return;
#line 3546 "book-view.c"
	}
#line 42 "../src/book-view.vala"
	if (value != NULL) {
#line 3550 "book-view.c"
		GHashTable* _tmp2_;
		gconstpointer _tmp3_;
#line 43 "../src/book-view.vala"
		_tmp2_ = self->priv->page_data;
#line 43 "../src/book-view.vala"
		_tmp3_ = g_hash_table_lookup (_tmp2_, value);
#line 43 "../src/book-view.vala"
		book_view_select_page_view (self, (PageView*) _tmp3_);
#line 3559 "book-view.c"
	} else {
#line 45 "../src/book-view.vala"
		book_view_select_page_view (self, NULL);
#line 3563 "book-view.c"
	}
#line 37 "../src/book-view.vala"
	g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_SELECTED_PAGE_PROPERTY]);
#line 3567 "book-view.c"
}


gint
book_view_get_x_offset (BookView* self)
{
	gint result;
	GtkAdjustment* _tmp0_;
#line 64 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../src/book-view.vala"
	_tmp0_ = self->priv->adjustment;
#line 66 "../src/book-view.vala"
	result = (gint) gtk_adjustment_get_value (_tmp0_);
#line 66 "../src/book-view.vala"
	return result;
#line 3584 "book-view.c"
}


void
book_view_set_x_offset (BookView* self,
                        gint value)
{
	GtkAdjustment* _tmp0_;
#line 68 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/book-view.vala"
	_tmp0_ = self->priv->adjustment;
#line 70 "../src/book-view.vala"
	gtk_adjustment_set_value (_tmp0_, (gdouble) value);
#line 68 "../src/book-view.vala"
	g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_X_OFFSET_PROPERTY]);
#line 3601 "book-view.c"
}


static void
book_view_class_init (BookViewClass * klass)
{
#line 15 "../src/book-view.vala"
	book_view_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/book-view.vala"
	g_type_class_adjust_private_offset (klass, &BookView_private_offset);
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_book_view_get_property;
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_book_view_set_property;
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->finalize = book_view_finalize;
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_BOOK_PROPERTY, book_view_properties[BOOK_VIEW_BOOK_PROPERTY] = g_param_spec_object ("book", "book", "book", TYPE_BOOK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_SELECTED_PAGE_PROPERTY, book_view_properties[BOOK_VIEW_SELECTED_PAGE_PROPERTY] = g_param_spec_object ("selected-page", "selected-page", "selected-page", TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_X_OFFSET_PROPERTY, book_view_properties[BOOK_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL] = g_signal_new ("page-selected", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PAGE);
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_SHOW_PAGE_SIGNAL] = g_signal_new ("show-page", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PAGE);
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_SHOW_MENU_SIGNAL] = g_signal_new ("show-menu", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
#line 3630 "book-view.c"
}


static void
book_view_instance_init (BookView * self)
{
#line 15 "../src/book-view.vala"
	self->priv = book_view_get_instance_private (self);
#line 27 "../src/book-view.vala"
	self->priv->selected_page_view = NULL;
#line 3641 "book-view.c"
}


static void
book_view_finalize (GObject * obj)
{
	BookView * self;
	Book* _tmp0_;
	guint _tmp1_;
	Book* _tmp2_;
	guint _tmp3_;
	Book* _tmp4_;
	guint _tmp5_;
	Book* _tmp6_;
	guint _tmp7_;
	GtkWidget* _tmp8_;
	guint _tmp9_;
	GtkWidget* _tmp10_;
	guint _tmp11_;
	GtkWidget* _tmp12_;
	guint _tmp13_;
	GtkWidget* _tmp14_;
	guint _tmp15_;
	GtkWidget* _tmp16_;
	guint _tmp17_;
	GtkWidget* _tmp18_;
	guint _tmp19_;
	GtkWidget* _tmp20_;
	guint _tmp21_;
	GtkWidget* _tmp22_;
	guint _tmp23_;
	GtkAdjustment* _tmp24_;
	guint _tmp25_;
#line 15 "../src/book-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOK_VIEW, BookView);
#line 124 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 124 "../src/book-view.vala"
	g_signal_parse_name ("page-added", TYPE_BOOK, &_tmp1_, NULL, FALSE);
#line 124 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _book_view_add_cb_book_page_added, self);
#line 125 "../src/book-view.vala"
	_tmp2_ = self->priv->_book;
#line 125 "../src/book-view.vala"
	g_signal_parse_name ("page-removed", TYPE_BOOK, &_tmp3_, NULL, FALSE);
#line 125 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _book_view_remove_cb_book_page_removed, self);
#line 126 "../src/book-view.vala"
	_tmp4_ = self->priv->_book;
#line 126 "../src/book-view.vala"
	g_signal_parse_name ("reordered", TYPE_BOOK, &_tmp5_, NULL, FALSE);
#line 126 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _book_view_reorder_cb_book_reordered, self);
#line 127 "../src/book-view.vala"
	_tmp6_ = self->priv->_book;
#line 127 "../src/book-view.vala"
	g_signal_parse_name ("cleared", TYPE_BOOK, &_tmp7_, NULL, FALSE);
#line 127 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _book_view_clear_cb_book_cleared, self);
#line 128 "../src/book-view.vala"
	_tmp8_ = self->priv->drawing_area;
#line 128 "../src/book-view.vala"
	g_signal_parse_name ("configure-event", gtk_widget_get_type (), &_tmp9_, NULL, FALSE);
#line 128 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _book_view_configure_cb_gtk_widget_configure_event, self);
#line 129 "../src/book-view.vala"
	_tmp10_ = self->priv->drawing_area;
#line 129 "../src/book-view.vala"
	g_signal_parse_name ("draw", gtk_widget_get_type (), &_tmp11_, NULL, FALSE);
#line 129 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _book_view_draw_cb_gtk_widget_draw, self);
#line 130 "../src/book-view.vala"
	_tmp12_ = self->priv->drawing_area;
#line 130 "../src/book-view.vala"
	g_signal_parse_name ("motion-notify-event", gtk_widget_get_type (), &_tmp13_, NULL, FALSE);
#line 130 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _book_view_motion_cb_gtk_widget_motion_notify_event, self);
#line 131 "../src/book-view.vala"
	_tmp14_ = self->priv->drawing_area;
#line 131 "../src/book-view.vala"
	g_signal_parse_name ("key-press-event", gtk_widget_get_type (), &_tmp15_, NULL, FALSE);
#line 131 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _book_view_key_cb_gtk_widget_key_press_event, self);
#line 132 "../src/book-view.vala"
	_tmp16_ = self->priv->drawing_area;
#line 132 "../src/book-view.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp17_, NULL, FALSE);
#line 132 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _book_view_button_cb_gtk_widget_button_press_event, self);
#line 133 "../src/book-view.vala"
	_tmp18_ = self->priv->drawing_area;
#line 133 "../src/book-view.vala"
	g_signal_parse_name ("button-release-event", gtk_widget_get_type (), &_tmp19_, NULL, FALSE);
#line 133 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _book_view_button_cb_gtk_widget_button_release_event, self);
#line 134 "../src/book-view.vala"
	_tmp20_ = self->priv->drawing_area;
#line 134 "../src/book-view.vala"
	g_signal_parse_name ("focus-in-event", gtk_widget_get_type (), &_tmp21_, NULL, FALSE);
#line 134 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp21_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_widget_focus_in_event, self);
#line 135 "../src/book-view.vala"
	_tmp22_ = self->priv->drawing_area;
#line 135 "../src/book-view.vala"
	g_signal_parse_name ("focus-out-event", gtk_widget_get_type (), &_tmp23_, NULL, FALSE);
#line 135 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_widget_focus_out_event, self);
#line 136 "../src/book-view.vala"
	_tmp24_ = self->priv->adjustment;
#line 136 "../src/book-view.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp25_, NULL, FALSE);
#line 136 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self);
#line 18 "../src/book-view.vala"
	_g_object_unref0 (self->priv->_book);
#line 19 "../src/book-view.vala"
	_g_hash_table_unref0 (self->priv->page_data);
#line 27 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 50 "../src/book-view.vala"
	_g_object_unref0 (self->priv->drawing_area);
#line 53 "../src/book-view.vala"
	_g_object_unref0 (self->priv->scroll);
#line 54 "../src/book-view.vala"
	_g_object_unref0 (self->priv->adjustment);
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (book_view_parent_class)->finalize (obj);
#line 3769 "book-view.c"
}


GType
book_view_get_type (void)
{
	static volatile gsize book_view_type_id__volatile = 0;
	if (g_once_init_enter (&book_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BookViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) book_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BookView), 0, (GInstanceInitFunc) book_view_instance_init, NULL };
		GType book_view_type_id;
		book_view_type_id = g_type_register_static (gtk_box_get_type (), "BookView", &g_define_type_info, 0);
		BookView_private_offset = g_type_add_instance_private (book_view_type_id, sizeof (BookViewPrivate));
		g_once_init_leave (&book_view_type_id__volatile, book_view_type_id);
	}
	return book_view_type_id__volatile;
}


static void
_vala_book_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	BookView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOK_VIEW, BookView);
#line 15 "../src/book-view.vala"
	switch (property_id) {
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_BOOK_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_object (value, book_view_get_book (self));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_SELECTED_PAGE_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_object (value, book_view_get_selected_page (self));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_X_OFFSET_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_int (value, book_view_get_x_offset (self));
#line 15 "../src/book-view.vala"
		break;
#line 3816 "book-view.c"
		default:
#line 15 "../src/book-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/book-view.vala"
		break;
#line 3822 "book-view.c"
	}
}


static void
_vala_book_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	BookView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOK_VIEW, BookView);
#line 15 "../src/book-view.vala"
	switch (property_id) {
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_BOOK_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_book (self, g_value_get_object (value));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_SELECTED_PAGE_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_selected_page (self, g_value_get_object (value));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_X_OFFSET_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_x_offset (self, g_value_get_int (value));
#line 15 "../src/book-view.vala"
		break;
#line 3855 "book-view.c"
		default:
#line 15 "../src/book-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/book-view.vala"
		break;
#line 3861 "book-view.c"
	}
}



