/* page-view.c generated by valac 0.42.6, the Vala compiler
 * generated from page-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <cairo.h>

typedef enum  {
	CROP_LOCATION_NONE = 0,
	CROP_LOCATION_MIDDLE,
	CROP_LOCATION_TOP,
	CROP_LOCATION_BOTTOM,
	CROP_LOCATION_LEFT,
	CROP_LOCATION_RIGHT,
	CROP_LOCATION_TOP_LEFT,
	CROP_LOCATION_TOP_RIGHT,
	CROP_LOCATION_BOTTOM_LEFT,
	CROP_LOCATION_BOTTOM_RIGHT
} CropLocation;


#define TYPE_CROP_LOCATION (crop_location_get_type ())

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
typedef struct _PageViewPrivate PageViewPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;


#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())
enum  {
	PAGE_VIEW_0_PROPERTY,
	PAGE_VIEW_PAGE_PROPERTY,
	PAGE_VIEW_SELECTED_PROPERTY,
	PAGE_VIEW_X_OFFSET_PROPERTY,
	PAGE_VIEW_Y_OFFSET_PROPERTY,
	PAGE_VIEW_CURSOR_PROPERTY,
	PAGE_VIEW_WIDTH_PROPERTY,
	PAGE_VIEW_HEIGHT_PROPERTY,
	PAGE_VIEW_NUM_PROPERTIES
};
static GParamSpec* page_view_properties[PAGE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	PAGE_VIEW_SIZE_CHANGED_SIGNAL,
	PAGE_VIEW_CHANGED_SIGNAL,
	PAGE_VIEW_NUM_SIGNALS
};
static guint page_view_signals[PAGE_VIEW_NUM_SIGNALS] = {0};

struct _PageView {
	GObject parent_instance;
	PageViewPrivate * priv;
};

struct _PageViewClass {
	GObjectClass parent_class;
};

struct _PageViewPrivate {
	Page* _page;
	GdkPixbuf* image;
	gboolean selected_;
	gint border_width;
	gboolean update_image;
	ScanDirection scan_direction;
	gint scan_line;
	gint width_;
	gint height_;
	gint _x_offset;
	gint _y_offset;
	CropLocation crop_location;
	gdouble selected_crop_px;
	gdouble selected_crop_py;
	gint selected_crop_x;
	gint selected_crop_y;
	gint selected_crop_w;
	gint selected_crop_h;
	GdkCursorType _cursor;
	gint animate_n_segments;
	gint animate_segment;
	guint animate_timeout;
};


static gint PageView_private_offset;
static gpointer page_view_parent_class = NULL;

GType crop_location_get_type (void) G_GNUC_CONST;
GType page_view_get_type (void) G_GNUC_CONST;
GType page_get_type (void) G_GNUC_CONST;
GType scan_direction_get_type (void) G_GNUC_CONST;
Page* page_view_get_page (PageView* self);
static void page_view_page_pixels_changed_cb (PageView* self,
                                       Page* p);
static void _page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                            gpointer self);
static void page_view_page_size_changed_cb (PageView* self,
                                     Page* p);
static void _page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                        gpointer self);
static void page_view_page_overlay_changed_cb (PageView* self,
                                        Page* p);
static void _page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                           gpointer self);
static void _page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                                gpointer self);
static void page_view_scan_direction_changed_cb (PageView* self,
                                          Page* p);
static void _page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                       gpointer self);
PageView* page_view_new (Page* page);
PageView* page_view_construct (GType object_type,
                               Page* page);
static void page_view_set_page (PageView* self,
                         Page* value);
static guchar page_view_get_sample (PageView* self,
                             guchar* pixels,
                             int pixels_length1,
                             gint offset,
                             gint x,
                             gint depth,
                             gint sample);
static void page_view_get_pixel (PageView* self,
                          Page* page,
                          gint x,
                          gint y,
                          guchar* pixel,
                          int pixel_length1);
ScanDirection page_get_scan_direction (Page* self);
gint page_get_scan_width (Page* self);
gint page_get_scan_height (Page* self);
gint page_get_depth (Page* self);
gint page_get_n_channels (Page* self);
guchar* page_get_pixels (Page* self,
                         int* result_length1);
gint page_get_rowstride (Page* self);
static void page_view_set_pixel (PageView* self,
                          Page* page,
                          gdouble l,
                          gdouble r,
                          gdouble t,
                          gdouble b,
                          guchar* output,
                          int output_length1,
                          gint offset);
static void page_view_update_preview (PageView* self,
                               Page* page,
                               GdkPixbuf* * output_image,
                               gint output_width,
                               gint output_height,
                               ScanDirection scan_direction,
                               gint old_scan_line,
                               gint scan_line);
gint page_get_width (Page* self);
gint page_get_height (Page* self);
gboolean page_get_has_data (Page* self);
static gint page_view_get_preview_width (PageView* self);
static gint page_view_get_preview_height (PageView* self);
static void page_view_update_page_view (PageView* self);
gint page_get_scan_line (Page* self);
static gint page_view_page_to_screen_x (PageView* self,
                                 gint x);
static gint page_view_page_to_screen_y (PageView* self,
                                 gint y);
static gint page_view_screen_to_page_x (PageView* self,
                                 gint x);
static gint page_view_screen_to_page_y (PageView* self,
                                 gint y);
static CropLocation page_view_get_crop_location (PageView* self,
                                          gint x,
                                          gint y);
gboolean page_get_has_crop (Page* self);
gint page_get_crop_x (Page* self);
gint page_get_crop_y (Page* self);
gint page_get_crop_width (Page* self);
gint page_get_crop_height (Page* self);
const gchar* page_get_crop_name (Page* self);
void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
void page_view_motion (PageView* self,
                       gint x,
                       gint y);
static void page_view_set_cursor (PageView* self,
                           GdkCursorType value);
void page_move_crop (Page* self,
                     gint x,
                     gint y);
void page_set_custom_crop (Page* self,
                           gint width,
                           gint height);
void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static gboolean page_view_animation_cb (PageView* self);
static void page_view_update_animation (PageView* self);
gboolean page_get_is_scanning (Page* self);
static gboolean _page_view_animation_cb_gsource_func (gpointer self);
void page_view_render (PageView* self,
                       cairo_t* context);
gint page_view_get_x_offset (PageView* self);
gint page_view_get_y_offset (PageView* self);
gboolean page_view_get_selected (PageView* self);
void page_view_set_selected (PageView* self,
                             gboolean value);
void page_view_set_x_offset (PageView* self,
                             gint value);
void page_view_set_y_offset (PageView* self,
                             gint value);
GdkCursorType page_view_get_cursor (PageView* self);
gint page_view_get_width (PageView* self);
void page_view_set_width (PageView* self,
                          gint value);
gint page_view_get_height (PageView* self);
void page_view_set_height (PageView* self,
                           gint value);
static void page_view_finalize (GObject * obj);
static void _vala_page_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_page_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);


GType
crop_location_get_type (void)
{
	static volatile gsize crop_location_type_id__volatile = 0;
	if (g_once_init_enter (&crop_location_type_id__volatile)) {
		static const GEnumValue values[] = {{CROP_LOCATION_NONE, "CROP_LOCATION_NONE", "none"}, {CROP_LOCATION_MIDDLE, "CROP_LOCATION_MIDDLE", "middle"}, {CROP_LOCATION_TOP, "CROP_LOCATION_TOP", "top"}, {CROP_LOCATION_BOTTOM, "CROP_LOCATION_BOTTOM", "bottom"}, {CROP_LOCATION_LEFT, "CROP_LOCATION_LEFT", "left"}, {CROP_LOCATION_RIGHT, "CROP_LOCATION_RIGHT", "right"}, {CROP_LOCATION_TOP_LEFT, "CROP_LOCATION_TOP_LEFT", "top-left"}, {CROP_LOCATION_TOP_RIGHT, "CROP_LOCATION_TOP_RIGHT", "top-right"}, {CROP_LOCATION_BOTTOM_LEFT, "CROP_LOCATION_BOTTOM_LEFT", "bottom-left"}, {CROP_LOCATION_BOTTOM_RIGHT, "CROP_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType crop_location_type_id;
		crop_location_type_id = g_enum_register_static ("CropLocation", values);
		g_once_init_leave (&crop_location_type_id__volatile, crop_location_type_id);
	}
	return crop_location_type_id__volatile;
}


static inline gpointer
page_view_get_instance_private (PageView* self)
{
	return G_STRUCT_MEMBER_P (self, PageView_private_offset);
}


static void
_page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                       gpointer self)
{
#line 97 "../src/page-view.vala"
	page_view_page_pixels_changed_cb ((PageView*) self, _sender);
#line 298 "page-view.c"
}


static void
_page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                   gpointer self)
{
#line 98 "../src/page-view.vala"
	page_view_page_size_changed_cb ((PageView*) self, _sender);
#line 308 "page-view.c"
}


static void
_page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                      gpointer self)
{
#line 99 "../src/page-view.vala"
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
#line 318 "page-view.c"
}


static void
_page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                           gpointer self)
{
#line 100 "../src/page-view.vala"
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
#line 328 "page-view.c"
}


static void
_page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                  gpointer self)
{
#line 101 "../src/page-view.vala"
	page_view_scan_direction_changed_cb ((PageView*) self, _sender);
#line 338 "page-view.c"
}


PageView*
page_view_construct (GType object_type,
                     Page* page)
{
	PageView * self = NULL;
#line 85 "../src/page-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 85 "../src/page-view.vala"
	self = (PageView*) g_object_new (object_type, NULL);
#line 87 "../src/page-view.vala"
	page_view_set_page (self, page);
#line 88 "../src/page-view.vala"
	g_signal_connect_object (page, "pixels-changed", (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self, 0);
#line 89 "../src/page-view.vala"
	g_signal_connect_object (page, "size-changed", (GCallback) _page_view_page_size_changed_cb_page_size_changed, self, 0);
#line 90 "../src/page-view.vala"
	g_signal_connect_object (page, "crop-changed", (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self, 0);
#line 91 "../src/page-view.vala"
	g_signal_connect_object (page, "scan-line-changed", (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self, 0);
#line 92 "../src/page-view.vala"
	g_signal_connect_object (page, "scan-direction-changed", (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self, 0);
#line 85 "../src/page-view.vala"
	return self;
#line 365 "page-view.c"
}


PageView*
page_view_new (Page* page)
{
#line 85 "../src/page-view.vala"
	return page_view_construct (TYPE_PAGE_VIEW, page);
#line 374 "page-view.c"
}


static guchar
page_view_get_sample (PageView* self,
                      guchar* pixels,
                      int pixels_length1,
                      gint offset,
                      gint x,
                      gint depth,
                      gint sample)
{
	guchar result = '\0';
#line 104 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 107 "../src/page-view.vala"
	result = (guchar) 0xFF;
#line 107 "../src/page-view.vala"
	return result;
#line 394 "page-view.c"
}


static void
page_view_get_pixel (PageView* self,
                     Page* page,
                     gint x,
                     gint y,
                     guchar* pixel,
                     int pixel_length1)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gint depth = 0;
	gint _tmp12_;
	gint _tmp13_;
	gint n_channels = 0;
	gint _tmp14_;
	gint _tmp15_;
	guchar* pixels = NULL;
	gint _tmp16_ = 0;
	guchar* _tmp17_;
	gint pixels_length1;
	gint _pixels_size_;
	gint offset = 0;
	gint _tmp18_;
	gint _tmp19_;
	gboolean _tmp20_ = FALSE;
	gint _tmp21_;
	guchar* _tmp59_;
	gint _tmp59__length1;
	gint _tmp60_;
	gint _tmp61_;
	gint _tmp62_;
	guchar* _tmp63_;
	gint _tmp63__length1;
	gint _tmp64_;
	gint _tmp65_;
	gint _tmp66_;
	guchar* _tmp67_;
	gint _tmp67__length1;
	gint _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
#line 110 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 112 "../src/page-view.vala"
	_tmp0_ = page_get_scan_direction (page);
#line 112 "../src/page-view.vala"
	_tmp1_ = _tmp0_;
#line 112 "../src/page-view.vala"
	switch (_tmp1_) {
#line 112 "../src/page-view.vala"
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 451 "page-view.c"
		{
#line 115 "../src/page-view.vala"
			break;
#line 455 "page-view.c"
		}
#line 112 "../src/page-view.vala"
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 459 "page-view.c"
		{
			gint _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 117 "../src/page-view.vala"
			_tmp2_ = page_get_scan_width (page);
#line 117 "../src/page-view.vala"
			_tmp3_ = _tmp2_;
#line 117 "../src/page-view.vala"
			x = (_tmp3_ - x) - 1;
#line 118 "../src/page-view.vala"
			_tmp4_ = page_get_scan_height (page);
#line 118 "../src/page-view.vala"
			_tmp5_ = _tmp4_;
#line 118 "../src/page-view.vala"
			y = (_tmp5_ - y) - 1;
#line 119 "../src/page-view.vala"
			break;
#line 479 "page-view.c"
		}
#line 112 "../src/page-view.vala"
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 483 "page-view.c"
		{
			gint t = 0;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 121 "../src/page-view.vala"
			t = x;
#line 122 "../src/page-view.vala"
			_tmp6_ = page_get_scan_width (page);
#line 122 "../src/page-view.vala"
			_tmp7_ = _tmp6_;
#line 122 "../src/page-view.vala"
			x = (_tmp7_ - y) - 1;
#line 123 "../src/page-view.vala"
			_tmp8_ = t;
#line 123 "../src/page-view.vala"
			y = _tmp8_;
#line 124 "../src/page-view.vala"
			break;
#line 503 "page-view.c"
		}
#line 112 "../src/page-view.vala"
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 507 "page-view.c"
		{
			gint t = 0;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
#line 126 "../src/page-view.vala"
			t = x;
#line 127 "../src/page-view.vala"
			x = y;
#line 128 "../src/page-view.vala"
			_tmp9_ = page_get_scan_height (page);
#line 128 "../src/page-view.vala"
			_tmp10_ = _tmp9_;
#line 128 "../src/page-view.vala"
			_tmp11_ = t;
#line 128 "../src/page-view.vala"
			y = (_tmp10_ - _tmp11_) - 1;
#line 129 "../src/page-view.vala"
			break;
#line 527 "page-view.c"
		}
		default:
#line 112 "../src/page-view.vala"
		break;
#line 532 "page-view.c"
	}
#line 132 "../src/page-view.vala"
	_tmp12_ = page_get_depth (page);
#line 132 "../src/page-view.vala"
	_tmp13_ = _tmp12_;
#line 132 "../src/page-view.vala"
	depth = _tmp13_;
#line 133 "../src/page-view.vala"
	_tmp14_ = page_get_n_channels (page);
#line 133 "../src/page-view.vala"
	_tmp15_ = _tmp14_;
#line 133 "../src/page-view.vala"
	n_channels = _tmp15_;
#line 134 "../src/page-view.vala"
	_tmp17_ = page_get_pixels (page, &_tmp16_);
#line 134 "../src/page-view.vala"
	pixels = _tmp17_;
#line 134 "../src/page-view.vala"
	pixels_length1 = _tmp16_;
#line 134 "../src/page-view.vala"
	_pixels_size_ = pixels_length1;
#line 135 "../src/page-view.vala"
	_tmp18_ = page_get_rowstride (page);
#line 135 "../src/page-view.vala"
	_tmp19_ = _tmp18_;
#line 135 "../src/page-view.vala"
	offset = _tmp19_ * y;
#line 138 "../src/page-view.vala"
	_tmp21_ = depth;
#line 138 "../src/page-view.vala"
	if (_tmp21_ == 8) {
#line 564 "page-view.c"
		gint _tmp22_;
#line 138 "../src/page-view.vala"
		_tmp22_ = n_channels;
#line 138 "../src/page-view.vala"
		_tmp20_ = _tmp22_ == 3;
#line 570 "page-view.c"
	} else {
#line 138 "../src/page-view.vala"
		_tmp20_ = FALSE;
#line 574 "page-view.c"
	}
#line 138 "../src/page-view.vala"
	if (_tmp20_) {
#line 578 "page-view.c"
		gint o = 0;
		gint _tmp23_;
		gint _tmp24_;
		guchar* _tmp25_;
		gint _tmp25__length1;
		gint _tmp26_;
		guchar _tmp27_;
		guchar* _tmp28_;
		gint _tmp28__length1;
		gint _tmp29_;
		guchar _tmp30_;
		guchar* _tmp31_;
		gint _tmp31__length1;
		gint _tmp32_;
		guchar _tmp33_;
#line 140 "../src/page-view.vala"
		_tmp23_ = offset;
#line 140 "../src/page-view.vala"
		_tmp24_ = n_channels;
#line 140 "../src/page-view.vala"
		o = _tmp23_ + (x * _tmp24_);
#line 141 "../src/page-view.vala"
		_tmp25_ = pixels;
#line 141 "../src/page-view.vala"
		_tmp25__length1 = pixels_length1;
#line 141 "../src/page-view.vala"
		_tmp26_ = o;
#line 141 "../src/page-view.vala"
		_tmp27_ = _tmp25_[_tmp26_];
#line 141 "../src/page-view.vala"
		pixel[0] = _tmp27_;
#line 142 "../src/page-view.vala"
		_tmp28_ = pixels;
#line 142 "../src/page-view.vala"
		_tmp28__length1 = pixels_length1;
#line 142 "../src/page-view.vala"
		_tmp29_ = o;
#line 142 "../src/page-view.vala"
		_tmp30_ = _tmp28_[_tmp29_ + 1];
#line 142 "../src/page-view.vala"
		pixel[1] = _tmp30_;
#line 143 "../src/page-view.vala"
		_tmp31_ = pixels;
#line 143 "../src/page-view.vala"
		_tmp31__length1 = pixels_length1;
#line 143 "../src/page-view.vala"
		_tmp32_ = o;
#line 143 "../src/page-view.vala"
		_tmp33_ = _tmp31_[_tmp32_ + 2];
#line 143 "../src/page-view.vala"
		pixel[2] = _tmp33_;
#line 144 "../src/page-view.vala"
		return;
#line 632 "page-view.c"
	} else {
		gboolean _tmp34_ = FALSE;
		gint _tmp35_;
#line 146 "../src/page-view.vala"
		_tmp35_ = depth;
#line 146 "../src/page-view.vala"
		if (_tmp35_ == 8) {
#line 640 "page-view.c"
			gint _tmp36_;
#line 146 "../src/page-view.vala"
			_tmp36_ = n_channels;
#line 146 "../src/page-view.vala"
			_tmp34_ = _tmp36_ == 1;
#line 646 "page-view.c"
		} else {
#line 146 "../src/page-view.vala"
			_tmp34_ = FALSE;
#line 650 "page-view.c"
		}
#line 146 "../src/page-view.vala"
		if (_tmp34_) {
#line 654 "page-view.c"
			guchar* _tmp37_;
			gint _tmp37__length1;
			gint _tmp38_;
			guchar _tmp39_;
#line 148 "../src/page-view.vala"
			_tmp37_ = pixels;
#line 148 "../src/page-view.vala"
			_tmp37__length1 = pixels_length1;
#line 148 "../src/page-view.vala"
			_tmp38_ = offset;
#line 148 "../src/page-view.vala"
			_tmp39_ = _tmp37_[_tmp38_ + x];
#line 148 "../src/page-view.vala"
			pixel[2] = _tmp39_;
#line 148 "../src/page-view.vala"
			pixel[1] = _tmp39_;
#line 148 "../src/page-view.vala"
			pixel[0] = _tmp39_;
#line 149 "../src/page-view.vala"
			return;
#line 675 "page-view.c"
		} else {
			gboolean _tmp40_ = FALSE;
			gint _tmp41_;
#line 153 "../src/page-view.vala"
			_tmp41_ = depth;
#line 153 "../src/page-view.vala"
			if (_tmp41_ == 1) {
#line 683 "page-view.c"
				gint _tmp42_;
#line 153 "../src/page-view.vala"
				_tmp42_ = n_channels;
#line 153 "../src/page-view.vala"
				_tmp40_ = _tmp42_ == 1;
#line 689 "page-view.c"
			} else {
#line 153 "../src/page-view.vala"
				_tmp40_ = FALSE;
#line 693 "page-view.c"
			}
#line 153 "../src/page-view.vala"
			if (_tmp40_) {
#line 697 "page-view.c"
				gint o = 0;
				gint _tmp43_;
				gint _tmp44_ = 0;
				guchar* _tmp45_;
				gint _tmp45__length1;
				gint _tmp46_;
				guchar _tmp47_;
#line 155 "../src/page-view.vala"
				_tmp43_ = offset;
#line 155 "../src/page-view.vala"
				o = _tmp43_ + (x / 8);
#line 156 "../src/page-view.vala"
				_tmp45_ = pixels;
#line 156 "../src/page-view.vala"
				_tmp45__length1 = pixels_length1;
#line 156 "../src/page-view.vala"
				_tmp46_ = o;
#line 156 "../src/page-view.vala"
				_tmp47_ = _tmp45_[_tmp46_];
#line 156 "../src/page-view.vala"
				if (((gint) (_tmp47_ & (0x80 >> (x % 8)))) != 0) {
#line 156 "../src/page-view.vala"
					_tmp44_ = 0x00;
#line 721 "page-view.c"
				} else {
#line 156 "../src/page-view.vala"
					_tmp44_ = 0xFF;
#line 725 "page-view.c"
				}
#line 156 "../src/page-view.vala"
				pixel[2] = (guchar) _tmp44_;
#line 156 "../src/page-view.vala"
				pixel[1] = (guchar) _tmp44_;
#line 156 "../src/page-view.vala"
				pixel[0] = (guchar) _tmp44_;
#line 157 "../src/page-view.vala"
				return;
#line 735 "page-view.c"
			} else {
				gboolean _tmp48_ = FALSE;
				gint _tmp49_;
#line 161 "../src/page-view.vala"
				_tmp49_ = depth;
#line 161 "../src/page-view.vala"
				if (_tmp49_ == 2) {
#line 743 "page-view.c"
					gint _tmp50_;
#line 161 "../src/page-view.vala"
					_tmp50_ = n_channels;
#line 161 "../src/page-view.vala"
					_tmp48_ = _tmp50_ == 1;
#line 749 "page-view.c"
				} else {
#line 161 "../src/page-view.vala"
					_tmp48_ = FALSE;
#line 753 "page-view.c"
				}
#line 161 "../src/page-view.vala"
				if (_tmp48_) {
#line 757 "page-view.c"
					gint block_shift[4] = {0};
					gint _tmp51_[4] = {0};
					gint o = 0;
					gint _tmp52_;
					gint sample = 0;
					guchar* _tmp53_;
					gint _tmp53__length1;
					gint _tmp54_;
					guchar _tmp55_;
					gint _tmp56_;
					gint _tmp57_;
					gint _tmp58_;
#line 163 "../src/page-view.vala"
					_tmp51_[0] = 6;
#line 163 "../src/page-view.vala"
					_tmp51_[1] = 4;
#line 163 "../src/page-view.vala"
					_tmp51_[2] = 2;
#line 163 "../src/page-view.vala"
					_tmp51_[3] = 0;
#line 163 "../src/page-view.vala"
					memcpy (block_shift, _tmp51_, 4 * sizeof (gint));
#line 165 "../src/page-view.vala"
					_tmp52_ = offset;
#line 165 "../src/page-view.vala"
					o = _tmp52_ + (x / 4);
#line 166 "../src/page-view.vala"
					_tmp53_ = pixels;
#line 166 "../src/page-view.vala"
					_tmp53__length1 = pixels_length1;
#line 166 "../src/page-view.vala"
					_tmp54_ = o;
#line 166 "../src/page-view.vala"
					_tmp55_ = _tmp53_[_tmp54_];
#line 166 "../src/page-view.vala"
					_tmp56_ = block_shift[x % 4];
#line 166 "../src/page-view.vala"
					sample = (_tmp55_ >> _tmp56_) & 0x3;
#line 167 "../src/page-view.vala"
					_tmp57_ = sample;
#line 167 "../src/page-view.vala"
					sample = (_tmp57_ * 255) / 3;
#line 169 "../src/page-view.vala"
					_tmp58_ = sample;
#line 169 "../src/page-view.vala"
					pixel[2] = (guchar) _tmp58_;
#line 169 "../src/page-view.vala"
					pixel[1] = (guchar) _tmp58_;
#line 169 "../src/page-view.vala"
					pixel[0] = (guchar) _tmp58_;
#line 170 "../src/page-view.vala"
					return;
#line 810 "page-view.c"
				}
			}
		}
	}
#line 174 "../src/page-view.vala"
	_tmp59_ = pixels;
#line 174 "../src/page-view.vala"
	_tmp59__length1 = pixels_length1;
#line 174 "../src/page-view.vala"
	_tmp60_ = offset;
#line 174 "../src/page-view.vala"
	_tmp61_ = depth;
#line 174 "../src/page-view.vala"
	_tmp62_ = n_channels;
#line 174 "../src/page-view.vala"
	pixel[0] = page_view_get_sample (self, _tmp59_, _tmp59__length1, _tmp60_, x, _tmp61_, x * _tmp62_);
#line 175 "../src/page-view.vala"
	_tmp63_ = pixels;
#line 175 "../src/page-view.vala"
	_tmp63__length1 = pixels_length1;
#line 175 "../src/page-view.vala"
	_tmp64_ = offset;
#line 175 "../src/page-view.vala"
	_tmp65_ = depth;
#line 175 "../src/page-view.vala"
	_tmp66_ = n_channels;
#line 175 "../src/page-view.vala"
	pixel[1] = page_view_get_sample (self, _tmp63_, _tmp63__length1, _tmp64_, x, _tmp65_, (x * _tmp66_) + 1);
#line 176 "../src/page-view.vala"
	_tmp67_ = pixels;
#line 176 "../src/page-view.vala"
	_tmp67__length1 = pixels_length1;
#line 176 "../src/page-view.vala"
	_tmp68_ = offset;
#line 176 "../src/page-view.vala"
	_tmp69_ = depth;
#line 176 "../src/page-view.vala"
	_tmp70_ = n_channels;
#line 176 "../src/page-view.vala"
	pixel[2] = page_view_get_sample (self, _tmp67_, _tmp67__length1, _tmp68_, x, _tmp69_, (x * _tmp70_) + 2);
#line 851 "page-view.c"
}


static void
page_view_set_pixel (PageView* self,
                     Page* page,
                     gdouble l,
                     gdouble r,
                     gdouble t,
                     gdouble b,
                     guchar* output,
                     int output_length1,
                     gint offset)
{
	gint L = 0;
	gint _tmp0_;
	gint R = 0;
	gint T = 0;
	gint _tmp2_;
	gint B = 0;
	gdouble red = 0.0;
	gdouble green = 0.0;
	gdouble blue = 0.0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp165_ = FALSE;
	gint _tmp166_;
	gboolean _tmp182_ = FALSE;
	gint _tmp183_;
	gboolean _tmp199_ = FALSE;
	gint _tmp200_;
	gboolean _tmp216_ = FALSE;
	gint _tmp217_;
	gdouble scale = 0.0;
	gdouble _tmp233_;
	gdouble _tmp234_;
	gdouble _tmp235_;
	gdouble _tmp236_;
	gdouble _tmp237_;
	gdouble _tmp238_;
#line 179 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 225 "../src/page-view.vala"
	L = (gint) l;
#line 226 "../src/page-view.vala"
	_tmp0_ = L;
#line 226 "../src/page-view.vala"
	if (((gdouble) _tmp0_) != l) {
#line 902 "page-view.c"
		gint _tmp1_;
#line 227 "../src/page-view.vala"
		_tmp1_ = L;
#line 227 "../src/page-view.vala"
		L = _tmp1_ + 1;
#line 908 "page-view.c"
	}
#line 228 "../src/page-view.vala"
	R = (gint) r;
#line 229 "../src/page-view.vala"
	T = (gint) t;
#line 230 "../src/page-view.vala"
	_tmp2_ = T;
#line 230 "../src/page-view.vala"
	if (((gdouble) _tmp2_) != t) {
#line 918 "page-view.c"
		gint _tmp3_;
#line 231 "../src/page-view.vala"
		_tmp3_ = T;
#line 231 "../src/page-view.vala"
		T = _tmp3_ + 1;
#line 924 "page-view.c"
	}
#line 232 "../src/page-view.vala"
	B = (gint) b;
#line 234 "../src/page-view.vala"
	red = 0.0;
#line 235 "../src/page-view.vala"
	green = 0.0;
#line 236 "../src/page-view.vala"
	blue = 0.0;
#line 247 "../src/page-view.vala"
	if ((r - l) <= 1.0) {
#line 247 "../src/page-view.vala"
		_tmp5_ = ((gint) r) == ((gint) l);
#line 938 "page-view.c"
	} else {
#line 247 "../src/page-view.vala"
		_tmp5_ = FALSE;
#line 942 "page-view.c"
	}
#line 247 "../src/page-view.vala"
	if (_tmp5_) {
#line 247 "../src/page-view.vala"
		_tmp4_ = TRUE;
#line 948 "page-view.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 247 "../src/page-view.vala"
		if ((b - t) <= 1.0) {
#line 247 "../src/page-view.vala"
			_tmp6_ = ((gint) b) == ((gint) t);
#line 955 "page-view.c"
		} else {
#line 247 "../src/page-view.vala"
			_tmp6_ = FALSE;
#line 959 "page-view.c"
		}
#line 247 "../src/page-view.vala"
		_tmp4_ = _tmp6_;
#line 963 "page-view.c"
	}
#line 247 "../src/page-view.vala"
	if (_tmp4_) {
#line 967 "page-view.c"
		gboolean _tmp7_ = FALSE;
		gint _tmp11_;
		gint _tmp12_;
		gdouble scale = 0.0;
		gdouble _tmp83_;
		gdouble _tmp84_;
		gdouble _tmp85_;
		gdouble _tmp86_;
		gdouble _tmp87_;
		gdouble _tmp88_;
#line 250 "../src/page-view.vala"
		if (((gint) l) == ((gint) r)) {
#line 250 "../src/page-view.vala"
			_tmp7_ = TRUE;
#line 982 "page-view.c"
		} else {
#line 250 "../src/page-view.vala"
			_tmp7_ = ((gint) t) == ((gint) b);
#line 986 "page-view.c"
		}
#line 250 "../src/page-view.vala"
		if (_tmp7_) {
#line 990 "page-view.c"
			guchar p[3] = {0};
			guchar _tmp8_;
			guchar _tmp9_;
			guchar _tmp10_;
#line 253 "../src/page-view.vala"
			page_view_get_pixel (self, page, (gint) l, (gint) t, p, 3);
#line 254 "../src/page-view.vala"
			_tmp8_ = p[0];
#line 254 "../src/page-view.vala"
			output[offset] = _tmp8_;
#line 255 "../src/page-view.vala"
			_tmp9_ = p[1];
#line 255 "../src/page-view.vala"
			output[offset + 1] = _tmp9_;
#line 256 "../src/page-view.vala"
			_tmp10_ = p[2];
#line 256 "../src/page-view.vala"
			output[offset + 2] = _tmp10_;
#line 257 "../src/page-view.vala"
			return;
#line 1011 "page-view.c"
		}
#line 261 "../src/page-view.vala"
		_tmp11_ = L;
#line 261 "../src/page-view.vala"
		_tmp12_ = R;
#line 261 "../src/page-view.vala"
		if (_tmp11_ > _tmp12_) {
#line 1019 "page-view.c"
			guchar p[3] = {0};
			gint _tmp13_;
			gint _tmp14_;
			gdouble _tmp15_;
			guchar _tmp16_;
			gint _tmp17_;
			gdouble _tmp18_;
			guchar _tmp19_;
			gint _tmp20_;
			gdouble _tmp21_;
			guchar _tmp22_;
			gint _tmp23_;
			gint _tmp37_;
			gint _tmp38_;
			gdouble _tmp39_;
			guchar _tmp40_;
			gint _tmp41_;
			gdouble _tmp42_;
			guchar _tmp43_;
			gint _tmp44_;
			gdouble _tmp45_;
			guchar _tmp46_;
			gint _tmp47_;
#line 264 "../src/page-view.vala"
			_tmp13_ = R;
#line 264 "../src/page-view.vala"
			_tmp14_ = T;
#line 264 "../src/page-view.vala"
			page_view_get_pixel (self, page, _tmp13_, _tmp14_ - 1, p, 3);
#line 265 "../src/page-view.vala"
			_tmp15_ = red;
#line 265 "../src/page-view.vala"
			_tmp16_ = p[0];
#line 265 "../src/page-view.vala"
			_tmp17_ = T;
#line 265 "../src/page-view.vala"
			red = _tmp15_ + ((_tmp16_ * (r - l)) * (_tmp17_ - t));
#line 266 "../src/page-view.vala"
			_tmp18_ = green;
#line 266 "../src/page-view.vala"
			_tmp19_ = p[1];
#line 266 "../src/page-view.vala"
			_tmp20_ = T;
#line 266 "../src/page-view.vala"
			green = _tmp18_ + ((_tmp19_ * (r - l)) * (_tmp20_ - t));
#line 267 "../src/page-view.vala"
			_tmp21_ = blue;
#line 267 "../src/page-view.vala"
			_tmp22_ = p[2];
#line 267 "../src/page-view.vala"
			_tmp23_ = T;
#line 267 "../src/page-view.vala"
			blue = _tmp21_ + ((_tmp22_ * (r - l)) * (_tmp23_ - t));
#line 1073 "page-view.c"
			{
				gint y = 0;
				gint _tmp24_;
#line 268 "../src/page-view.vala"
				_tmp24_ = T;
#line 268 "../src/page-view.vala"
				y = _tmp24_;
#line 1081 "page-view.c"
				{
					gboolean _tmp25_ = FALSE;
#line 268 "../src/page-view.vala"
					_tmp25_ = TRUE;
#line 268 "../src/page-view.vala"
					while (TRUE) {
#line 1088 "page-view.c"
						gint _tmp27_;
						gint _tmp28_;
						gint _tmp29_;
						gint _tmp30_;
						gdouble _tmp31_;
						guchar _tmp32_;
						gdouble _tmp33_;
						guchar _tmp34_;
						gdouble _tmp35_;
						guchar _tmp36_;
#line 268 "../src/page-view.vala"
						if (!_tmp25_) {
#line 1101 "page-view.c"
							gint _tmp26_;
#line 268 "../src/page-view.vala"
							_tmp26_ = y;
#line 268 "../src/page-view.vala"
							y = _tmp26_ + 1;
#line 1107 "page-view.c"
						}
#line 268 "../src/page-view.vala"
						_tmp25_ = FALSE;
#line 268 "../src/page-view.vala"
						_tmp27_ = y;
#line 268 "../src/page-view.vala"
						_tmp28_ = B;
#line 268 "../src/page-view.vala"
						if (!(_tmp27_ < _tmp28_)) {
#line 268 "../src/page-view.vala"
							break;
#line 1119 "page-view.c"
						}
#line 270 "../src/page-view.vala"
						_tmp29_ = R;
#line 270 "../src/page-view.vala"
						_tmp30_ = y;
#line 270 "../src/page-view.vala"
						page_view_get_pixel (self, page, _tmp29_, _tmp30_, p, 3);
#line 271 "../src/page-view.vala"
						_tmp31_ = red;
#line 271 "../src/page-view.vala"
						_tmp32_ = p[0];
#line 271 "../src/page-view.vala"
						red = _tmp31_ + (_tmp32_ * (r - l));
#line 272 "../src/page-view.vala"
						_tmp33_ = green;
#line 272 "../src/page-view.vala"
						_tmp34_ = p[1];
#line 272 "../src/page-view.vala"
						green = _tmp33_ + (_tmp34_ * (r - l));
#line 273 "../src/page-view.vala"
						_tmp35_ = blue;
#line 273 "../src/page-view.vala"
						_tmp36_ = p[2];
#line 273 "../src/page-view.vala"
						blue = _tmp35_ + (_tmp36_ * (r - l));
#line 1145 "page-view.c"
					}
				}
			}
#line 275 "../src/page-view.vala"
			_tmp37_ = R;
#line 275 "../src/page-view.vala"
			_tmp38_ = B;
#line 275 "../src/page-view.vala"
			page_view_get_pixel (self, page, _tmp37_, _tmp38_, p, 3);
#line 276 "../src/page-view.vala"
			_tmp39_ = red;
#line 276 "../src/page-view.vala"
			_tmp40_ = p[0];
#line 276 "../src/page-view.vala"
			_tmp41_ = B;
#line 276 "../src/page-view.vala"
			red = _tmp39_ + ((_tmp40_ * (r - l)) * (b - _tmp41_));
#line 277 "../src/page-view.vala"
			_tmp42_ = green;
#line 277 "../src/page-view.vala"
			_tmp43_ = p[1];
#line 277 "../src/page-view.vala"
			_tmp44_ = B;
#line 277 "../src/page-view.vala"
			green = _tmp42_ + ((_tmp43_ * (r - l)) * (b - _tmp44_));
#line 278 "../src/page-view.vala"
			_tmp45_ = blue;
#line 278 "../src/page-view.vala"
			_tmp46_ = p[2];
#line 278 "../src/page-view.vala"
			_tmp47_ = B;
#line 278 "../src/page-view.vala"
			blue = _tmp45_ + ((_tmp46_ * (r - l)) * (b - _tmp47_));
#line 1179 "page-view.c"
		} else {
			guchar p[3] = {0};
			gint _tmp48_;
			gint _tmp49_;
			gdouble _tmp50_;
			guchar _tmp51_;
			gint _tmp52_;
			gdouble _tmp53_;
			guchar _tmp54_;
			gint _tmp55_;
			gdouble _tmp56_;
			guchar _tmp57_;
			gint _tmp58_;
			gint _tmp72_;
			gint _tmp73_;
			gdouble _tmp74_;
			guchar _tmp75_;
			gint _tmp76_;
			gdouble _tmp77_;
			guchar _tmp78_;
			gint _tmp79_;
			gdouble _tmp80_;
			guchar _tmp81_;
			gint _tmp82_;
#line 284 "../src/page-view.vala"
			_tmp48_ = L;
#line 284 "../src/page-view.vala"
			_tmp49_ = B;
#line 284 "../src/page-view.vala"
			page_view_get_pixel (self, page, _tmp48_ - 1, _tmp49_, p, 3);
#line 285 "../src/page-view.vala"
			_tmp50_ = red;
#line 285 "../src/page-view.vala"
			_tmp51_ = p[0];
#line 285 "../src/page-view.vala"
			_tmp52_ = L;
#line 285 "../src/page-view.vala"
			red = _tmp50_ + ((_tmp51_ * (b - t)) * (_tmp52_ - l));
#line 286 "../src/page-view.vala"
			_tmp53_ = green;
#line 286 "../src/page-view.vala"
			_tmp54_ = p[1];
#line 286 "../src/page-view.vala"
			_tmp55_ = L;
#line 286 "../src/page-view.vala"
			green = _tmp53_ + ((_tmp54_ * (b - t)) * (_tmp55_ - l));
#line 287 "../src/page-view.vala"
			_tmp56_ = blue;
#line 287 "../src/page-view.vala"
			_tmp57_ = p[2];
#line 287 "../src/page-view.vala"
			_tmp58_ = L;
#line 287 "../src/page-view.vala"
			blue = _tmp56_ + ((_tmp57_ * (b - t)) * (_tmp58_ - l));
#line 1234 "page-view.c"
			{
				gint x = 0;
				gint _tmp59_;
#line 288 "../src/page-view.vala"
				_tmp59_ = L;
#line 288 "../src/page-view.vala"
				x = _tmp59_;
#line 1242 "page-view.c"
				{
					gboolean _tmp60_ = FALSE;
#line 288 "../src/page-view.vala"
					_tmp60_ = TRUE;
#line 288 "../src/page-view.vala"
					while (TRUE) {
#line 1249 "page-view.c"
						gint _tmp62_;
						gint _tmp63_;
						gint _tmp64_;
						gint _tmp65_;
						gdouble _tmp66_;
						guchar _tmp67_;
						gdouble _tmp68_;
						guchar _tmp69_;
						gdouble _tmp70_;
						guchar _tmp71_;
#line 288 "../src/page-view.vala"
						if (!_tmp60_) {
#line 1262 "page-view.c"
							gint _tmp61_;
#line 288 "../src/page-view.vala"
							_tmp61_ = x;
#line 288 "../src/page-view.vala"
							x = _tmp61_ + 1;
#line 1268 "page-view.c"
						}
#line 288 "../src/page-view.vala"
						_tmp60_ = FALSE;
#line 288 "../src/page-view.vala"
						_tmp62_ = x;
#line 288 "../src/page-view.vala"
						_tmp63_ = R;
#line 288 "../src/page-view.vala"
						if (!(_tmp62_ < _tmp63_)) {
#line 288 "../src/page-view.vala"
							break;
#line 1280 "page-view.c"
						}
#line 289 "../src/page-view.vala"
						_tmp64_ = x;
#line 289 "../src/page-view.vala"
						_tmp65_ = B;
#line 289 "../src/page-view.vala"
						page_view_get_pixel (self, page, _tmp64_, _tmp65_, p, 3);
#line 290 "../src/page-view.vala"
						_tmp66_ = red;
#line 290 "../src/page-view.vala"
						_tmp67_ = p[0];
#line 290 "../src/page-view.vala"
						red = _tmp66_ + (_tmp67_ * (b - t));
#line 291 "../src/page-view.vala"
						_tmp68_ = green;
#line 291 "../src/page-view.vala"
						_tmp69_ = p[1];
#line 291 "../src/page-view.vala"
						green = _tmp68_ + (_tmp69_ * (b - t));
#line 292 "../src/page-view.vala"
						_tmp70_ = blue;
#line 292 "../src/page-view.vala"
						_tmp71_ = p[2];
#line 292 "../src/page-view.vala"
						blue = _tmp70_ + (_tmp71_ * (b - t));
#line 1306 "page-view.c"
					}
				}
			}
#line 294 "../src/page-view.vala"
			_tmp72_ = R;
#line 294 "../src/page-view.vala"
			_tmp73_ = B;
#line 294 "../src/page-view.vala"
			page_view_get_pixel (self, page, _tmp72_, _tmp73_, p, 3);
#line 295 "../src/page-view.vala"
			_tmp74_ = red;
#line 295 "../src/page-view.vala"
			_tmp75_ = p[0];
#line 295 "../src/page-view.vala"
			_tmp76_ = R;
#line 295 "../src/page-view.vala"
			red = _tmp74_ + ((_tmp75_ * (b - t)) * (r - _tmp76_));
#line 296 "../src/page-view.vala"
			_tmp77_ = green;
#line 296 "../src/page-view.vala"
			_tmp78_ = p[1];
#line 296 "../src/page-view.vala"
			_tmp79_ = R;
#line 296 "../src/page-view.vala"
			green = _tmp77_ + ((_tmp78_ * (b - t)) * (r - _tmp79_));
#line 297 "../src/page-view.vala"
			_tmp80_ = blue;
#line 297 "../src/page-view.vala"
			_tmp81_ = p[2];
#line 297 "../src/page-view.vala"
			_tmp82_ = R;
#line 297 "../src/page-view.vala"
			blue = _tmp80_ + ((_tmp81_ * (b - t)) * (r - _tmp82_));
#line 1340 "page-view.c"
		}
#line 300 "../src/page-view.vala"
		scale = 1.0 / ((r - l) * (b - t));
#line 301 "../src/page-view.vala"
		_tmp83_ = red;
#line 301 "../src/page-view.vala"
		_tmp84_ = scale;
#line 301 "../src/page-view.vala"
		output[offset] = (guchar) ((_tmp83_ * _tmp84_) + 0.5);
#line 302 "../src/page-view.vala"
		_tmp85_ = green;
#line 302 "../src/page-view.vala"
		_tmp86_ = scale;
#line 302 "../src/page-view.vala"
		output[offset + 1] = (guchar) ((_tmp85_ * _tmp86_) + 0.5);
#line 303 "../src/page-view.vala"
		_tmp87_ = blue;
#line 303 "../src/page-view.vala"
		_tmp88_ = scale;
#line 303 "../src/page-view.vala"
		output[offset + 2] = (guchar) ((_tmp87_ * _tmp88_) + 0.5);
#line 304 "../src/page-view.vala"
		return;
#line 1364 "page-view.c"
	}
	{
		gint x = 0;
		gint _tmp89_;
#line 308 "../src/page-view.vala"
		_tmp89_ = L;
#line 308 "../src/page-view.vala"
		x = _tmp89_;
#line 1373 "page-view.c"
		{
			gboolean _tmp90_ = FALSE;
#line 308 "../src/page-view.vala"
			_tmp90_ = TRUE;
#line 308 "../src/page-view.vala"
			while (TRUE) {
#line 1380 "page-view.c"
				gint _tmp92_;
				gint _tmp93_;
#line 308 "../src/page-view.vala"
				if (!_tmp90_) {
#line 1385 "page-view.c"
					gint _tmp91_;
#line 308 "../src/page-view.vala"
					_tmp91_ = x;
#line 308 "../src/page-view.vala"
					x = _tmp91_ + 1;
#line 1391 "page-view.c"
				}
#line 308 "../src/page-view.vala"
				_tmp90_ = FALSE;
#line 308 "../src/page-view.vala"
				_tmp92_ = x;
#line 308 "../src/page-view.vala"
				_tmp93_ = R;
#line 308 "../src/page-view.vala"
				if (!(_tmp92_ < _tmp93_)) {
#line 308 "../src/page-view.vala"
					break;
#line 1403 "page-view.c"
				}
				{
					gint y = 0;
					gint _tmp94_;
#line 310 "../src/page-view.vala"
					_tmp94_ = T;
#line 310 "../src/page-view.vala"
					y = _tmp94_;
#line 1412 "page-view.c"
					{
						gboolean _tmp95_ = FALSE;
#line 310 "../src/page-view.vala"
						_tmp95_ = TRUE;
#line 310 "../src/page-view.vala"
						while (TRUE) {
#line 1419 "page-view.c"
							gint _tmp97_;
							gint _tmp98_;
							guchar p[3] = {0};
							gint _tmp99_;
							gint _tmp100_;
							gdouble _tmp101_;
							guchar _tmp102_;
							gdouble _tmp103_;
							guchar _tmp104_;
							gdouble _tmp105_;
							guchar _tmp106_;
#line 310 "../src/page-view.vala"
							if (!_tmp95_) {
#line 1433 "page-view.c"
								gint _tmp96_;
#line 310 "../src/page-view.vala"
								_tmp96_ = y;
#line 310 "../src/page-view.vala"
								y = _tmp96_ + 1;
#line 1439 "page-view.c"
							}
#line 310 "../src/page-view.vala"
							_tmp95_ = FALSE;
#line 310 "../src/page-view.vala"
							_tmp97_ = y;
#line 310 "../src/page-view.vala"
							_tmp98_ = B;
#line 310 "../src/page-view.vala"
							if (!(_tmp97_ < _tmp98_)) {
#line 310 "../src/page-view.vala"
								break;
#line 1451 "page-view.c"
							}
#line 313 "../src/page-view.vala"
							_tmp99_ = x;
#line 313 "../src/page-view.vala"
							_tmp100_ = y;
#line 313 "../src/page-view.vala"
							page_view_get_pixel (self, page, _tmp99_, _tmp100_, p, 3);
#line 314 "../src/page-view.vala"
							_tmp101_ = red;
#line 314 "../src/page-view.vala"
							_tmp102_ = p[0];
#line 314 "../src/page-view.vala"
							red = _tmp101_ + _tmp102_;
#line 315 "../src/page-view.vala"
							_tmp103_ = green;
#line 315 "../src/page-view.vala"
							_tmp104_ = p[1];
#line 315 "../src/page-view.vala"
							green = _tmp103_ + _tmp104_;
#line 316 "../src/page-view.vala"
							_tmp105_ = blue;
#line 316 "../src/page-view.vala"
							_tmp106_ = p[2];
#line 316 "../src/page-view.vala"
							blue = _tmp105_ + _tmp106_;
#line 1477 "page-view.c"
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
		gint _tmp107_;
#line 321 "../src/page-view.vala"
		_tmp107_ = L;
#line 321 "../src/page-view.vala"
		x = _tmp107_;
#line 1491 "page-view.c"
		{
			gboolean _tmp108_ = FALSE;
#line 321 "../src/page-view.vala"
			_tmp108_ = TRUE;
#line 321 "../src/page-view.vala"
			while (TRUE) {
#line 1498 "page-view.c"
				gint _tmp110_;
				gint _tmp111_;
				gint _tmp112_;
				gint _tmp124_;
#line 321 "../src/page-view.vala"
				if (!_tmp108_) {
#line 1505 "page-view.c"
					gint _tmp109_;
#line 321 "../src/page-view.vala"
					_tmp109_ = x;
#line 321 "../src/page-view.vala"
					x = _tmp109_ + 1;
#line 1511 "page-view.c"
				}
#line 321 "../src/page-view.vala"
				_tmp108_ = FALSE;
#line 321 "../src/page-view.vala"
				_tmp110_ = x;
#line 321 "../src/page-view.vala"
				_tmp111_ = R;
#line 321 "../src/page-view.vala"
				if (!(_tmp110_ < _tmp111_)) {
#line 321 "../src/page-view.vala"
					break;
#line 1523 "page-view.c"
				}
#line 323 "../src/page-view.vala"
				_tmp112_ = T;
#line 323 "../src/page-view.vala"
				if (t != ((gdouble) _tmp112_)) {
#line 1529 "page-view.c"
					guchar p[3] = {0};
					gint _tmp113_;
					gint _tmp114_;
					gdouble _tmp115_;
					guchar _tmp116_;
					gint _tmp117_;
					gdouble _tmp118_;
					guchar _tmp119_;
					gint _tmp120_;
					gdouble _tmp121_;
					guchar _tmp122_;
					gint _tmp123_;
#line 326 "../src/page-view.vala"
					_tmp113_ = x;
#line 326 "../src/page-view.vala"
					_tmp114_ = T;
#line 326 "../src/page-view.vala"
					page_view_get_pixel (self, page, _tmp113_, _tmp114_ - 1, p, 3);
#line 327 "../src/page-view.vala"
					_tmp115_ = red;
#line 327 "../src/page-view.vala"
					_tmp116_ = p[0];
#line 327 "../src/page-view.vala"
					_tmp117_ = T;
#line 327 "../src/page-view.vala"
					red = _tmp115_ + (_tmp116_ * (_tmp117_ - t));
#line 328 "../src/page-view.vala"
					_tmp118_ = green;
#line 328 "../src/page-view.vala"
					_tmp119_ = p[1];
#line 328 "../src/page-view.vala"
					_tmp120_ = T;
#line 328 "../src/page-view.vala"
					green = _tmp118_ + (_tmp119_ * (_tmp120_ - t));
#line 329 "../src/page-view.vala"
					_tmp121_ = blue;
#line 329 "../src/page-view.vala"
					_tmp122_ = p[2];
#line 329 "../src/page-view.vala"
					_tmp123_ = T;
#line 329 "../src/page-view.vala"
					blue = _tmp121_ + (_tmp122_ * (_tmp123_ - t));
#line 1572 "page-view.c"
				}
#line 332 "../src/page-view.vala"
				_tmp124_ = B;
#line 332 "../src/page-view.vala"
				if (b != ((gdouble) _tmp124_)) {
#line 1578 "page-view.c"
					guchar p[3] = {0};
					gint _tmp125_;
					gint _tmp126_;
					gdouble _tmp127_;
					guchar _tmp128_;
					gint _tmp129_;
					gdouble _tmp130_;
					guchar _tmp131_;
					gint _tmp132_;
					gdouble _tmp133_;
					guchar _tmp134_;
					gint _tmp135_;
#line 335 "../src/page-view.vala"
					_tmp125_ = x;
#line 335 "../src/page-view.vala"
					_tmp126_ = B;
#line 335 "../src/page-view.vala"
					page_view_get_pixel (self, page, _tmp125_, _tmp126_, p, 3);
#line 336 "../src/page-view.vala"
					_tmp127_ = red;
#line 336 "../src/page-view.vala"
					_tmp128_ = p[0];
#line 336 "../src/page-view.vala"
					_tmp129_ = B;
#line 336 "../src/page-view.vala"
					red = _tmp127_ + (_tmp128_ * (b - _tmp129_));
#line 337 "../src/page-view.vala"
					_tmp130_ = green;
#line 337 "../src/page-view.vala"
					_tmp131_ = p[1];
#line 337 "../src/page-view.vala"
					_tmp132_ = B;
#line 337 "../src/page-view.vala"
					green = _tmp130_ + (_tmp131_ * (b - _tmp132_));
#line 338 "../src/page-view.vala"
					_tmp133_ = blue;
#line 338 "../src/page-view.vala"
					_tmp134_ = p[2];
#line 338 "../src/page-view.vala"
					_tmp135_ = B;
#line 338 "../src/page-view.vala"
					blue = _tmp133_ + (_tmp134_ * (b - _tmp135_));
#line 1621 "page-view.c"
				}
			}
		}
	}
	{
		gint y = 0;
		gint _tmp136_;
#line 343 "../src/page-view.vala"
		_tmp136_ = T;
#line 343 "../src/page-view.vala"
		y = _tmp136_;
#line 1633 "page-view.c"
		{
			gboolean _tmp137_ = FALSE;
#line 343 "../src/page-view.vala"
			_tmp137_ = TRUE;
#line 343 "../src/page-view.vala"
			while (TRUE) {
#line 1640 "page-view.c"
				gint _tmp139_;
				gint _tmp140_;
				gint _tmp141_;
				gint _tmp153_;
#line 343 "../src/page-view.vala"
				if (!_tmp137_) {
#line 1647 "page-view.c"
					gint _tmp138_;
#line 343 "../src/page-view.vala"
					_tmp138_ = y;
#line 343 "../src/page-view.vala"
					y = _tmp138_ + 1;
#line 1653 "page-view.c"
				}
#line 343 "../src/page-view.vala"
				_tmp137_ = FALSE;
#line 343 "../src/page-view.vala"
				_tmp139_ = y;
#line 343 "../src/page-view.vala"
				_tmp140_ = B;
#line 343 "../src/page-view.vala"
				if (!(_tmp139_ < _tmp140_)) {
#line 343 "../src/page-view.vala"
					break;
#line 1665 "page-view.c"
				}
#line 345 "../src/page-view.vala"
				_tmp141_ = L;
#line 345 "../src/page-view.vala"
				if (l != ((gdouble) _tmp141_)) {
#line 1671 "page-view.c"
					guchar p[3] = {0};
					gint _tmp142_;
					gint _tmp143_;
					gdouble _tmp144_;
					guchar _tmp145_;
					gint _tmp146_;
					gdouble _tmp147_;
					guchar _tmp148_;
					gint _tmp149_;
					gdouble _tmp150_;
					guchar _tmp151_;
					gint _tmp152_;
#line 348 "../src/page-view.vala"
					_tmp142_ = L;
#line 348 "../src/page-view.vala"
					_tmp143_ = y;
#line 348 "../src/page-view.vala"
					page_view_get_pixel (self, page, _tmp142_ - 1, _tmp143_, p, 3);
#line 349 "../src/page-view.vala"
					_tmp144_ = red;
#line 349 "../src/page-view.vala"
					_tmp145_ = p[0];
#line 349 "../src/page-view.vala"
					_tmp146_ = L;
#line 349 "../src/page-view.vala"
					red = _tmp144_ + (_tmp145_ * (_tmp146_ - l));
#line 350 "../src/page-view.vala"
					_tmp147_ = green;
#line 350 "../src/page-view.vala"
					_tmp148_ = p[1];
#line 350 "../src/page-view.vala"
					_tmp149_ = L;
#line 350 "../src/page-view.vala"
					green = _tmp147_ + (_tmp148_ * (_tmp149_ - l));
#line 351 "../src/page-view.vala"
					_tmp150_ = blue;
#line 351 "../src/page-view.vala"
					_tmp151_ = p[2];
#line 351 "../src/page-view.vala"
					_tmp152_ = L;
#line 351 "../src/page-view.vala"
					blue = _tmp150_ + (_tmp151_ * (_tmp152_ - l));
#line 1714 "page-view.c"
				}
#line 354 "../src/page-view.vala"
				_tmp153_ = R;
#line 354 "../src/page-view.vala"
				if (r != ((gdouble) _tmp153_)) {
#line 1720 "page-view.c"
					guchar p[3] = {0};
					gint _tmp154_;
					gint _tmp155_;
					gdouble _tmp156_;
					guchar _tmp157_;
					gint _tmp158_;
					gdouble _tmp159_;
					guchar _tmp160_;
					gint _tmp161_;
					gdouble _tmp162_;
					guchar _tmp163_;
					gint _tmp164_;
#line 357 "../src/page-view.vala"
					_tmp154_ = R;
#line 357 "../src/page-view.vala"
					_tmp155_ = y;
#line 357 "../src/page-view.vala"
					page_view_get_pixel (self, page, _tmp154_, _tmp155_, p, 3);
#line 358 "../src/page-view.vala"
					_tmp156_ = red;
#line 358 "../src/page-view.vala"
					_tmp157_ = p[0];
#line 358 "../src/page-view.vala"
					_tmp158_ = R;
#line 358 "../src/page-view.vala"
					red = _tmp156_ + (_tmp157_ * (r - _tmp158_));
#line 359 "../src/page-view.vala"
					_tmp159_ = green;
#line 359 "../src/page-view.vala"
					_tmp160_ = p[1];
#line 359 "../src/page-view.vala"
					_tmp161_ = R;
#line 359 "../src/page-view.vala"
					green = _tmp159_ + (_tmp160_ * (r - _tmp161_));
#line 360 "../src/page-view.vala"
					_tmp162_ = blue;
#line 360 "../src/page-view.vala"
					_tmp163_ = p[2];
#line 360 "../src/page-view.vala"
					_tmp164_ = R;
#line 360 "../src/page-view.vala"
					blue = _tmp162_ + (_tmp163_ * (r - _tmp164_));
#line 1763 "page-view.c"
				}
			}
		}
	}
#line 365 "../src/page-view.vala"
	_tmp166_ = L;
#line 365 "../src/page-view.vala"
	if (l != ((gdouble) _tmp166_)) {
#line 1772 "page-view.c"
		gint _tmp167_;
#line 365 "../src/page-view.vala"
		_tmp167_ = T;
#line 365 "../src/page-view.vala"
		_tmp165_ = t != ((gdouble) _tmp167_);
#line 1778 "page-view.c"
	} else {
#line 365 "../src/page-view.vala"
		_tmp165_ = FALSE;
#line 1782 "page-view.c"
	}
#line 365 "../src/page-view.vala"
	if (_tmp165_) {
#line 1786 "page-view.c"
		guchar p[3] = {0};
		gint _tmp168_;
		gint _tmp169_;
		gdouble _tmp170_;
		guchar _tmp171_;
		gint _tmp172_;
		gint _tmp173_;
		gdouble _tmp174_;
		guchar _tmp175_;
		gint _tmp176_;
		gint _tmp177_;
		gdouble _tmp178_;
		guchar _tmp179_;
		gint _tmp180_;
		gint _tmp181_;
#line 368 "../src/page-view.vala"
		_tmp168_ = L;
#line 368 "../src/page-view.vala"
		_tmp169_ = T;
#line 368 "../src/page-view.vala"
		page_view_get_pixel (self, page, _tmp168_ - 1, _tmp169_ - 1, p, 3);
#line 369 "../src/page-view.vala"
		_tmp170_ = red;
#line 369 "../src/page-view.vala"
		_tmp171_ = p[0];
#line 369 "../src/page-view.vala"
		_tmp172_ = L;
#line 369 "../src/page-view.vala"
		_tmp173_ = T;
#line 369 "../src/page-view.vala"
		red = _tmp170_ + ((_tmp171_ * (_tmp172_ - l)) * (_tmp173_ - t));
#line 370 "../src/page-view.vala"
		_tmp174_ = green;
#line 370 "../src/page-view.vala"
		_tmp175_ = p[1];
#line 370 "../src/page-view.vala"
		_tmp176_ = L;
#line 370 "../src/page-view.vala"
		_tmp177_ = T;
#line 370 "../src/page-view.vala"
		green = _tmp174_ + ((_tmp175_ * (_tmp176_ - l)) * (_tmp177_ - t));
#line 371 "../src/page-view.vala"
		_tmp178_ = blue;
#line 371 "../src/page-view.vala"
		_tmp179_ = p[2];
#line 371 "../src/page-view.vala"
		_tmp180_ = L;
#line 371 "../src/page-view.vala"
		_tmp181_ = T;
#line 371 "../src/page-view.vala"
		blue = _tmp178_ + ((_tmp179_ * (_tmp180_ - l)) * (_tmp181_ - t));
#line 1838 "page-view.c"
	}
#line 373 "../src/page-view.vala"
	_tmp183_ = R;
#line 373 "../src/page-view.vala"
	if (r != ((gdouble) _tmp183_)) {
#line 1844 "page-view.c"
		gint _tmp184_;
#line 373 "../src/page-view.vala"
		_tmp184_ = T;
#line 373 "../src/page-view.vala"
		_tmp182_ = t != ((gdouble) _tmp184_);
#line 1850 "page-view.c"
	} else {
#line 373 "../src/page-view.vala"
		_tmp182_ = FALSE;
#line 1854 "page-view.c"
	}
#line 373 "../src/page-view.vala"
	if (_tmp182_) {
#line 1858 "page-view.c"
		guchar p[3] = {0};
		gint _tmp185_;
		gint _tmp186_;
		gdouble _tmp187_;
		guchar _tmp188_;
		gint _tmp189_;
		gint _tmp190_;
		gdouble _tmp191_;
		guchar _tmp192_;
		gint _tmp193_;
		gint _tmp194_;
		gdouble _tmp195_;
		guchar _tmp196_;
		gint _tmp197_;
		gint _tmp198_;
#line 376 "../src/page-view.vala"
		_tmp185_ = R;
#line 376 "../src/page-view.vala"
		_tmp186_ = T;
#line 376 "../src/page-view.vala"
		page_view_get_pixel (self, page, _tmp185_, _tmp186_ - 1, p, 3);
#line 377 "../src/page-view.vala"
		_tmp187_ = red;
#line 377 "../src/page-view.vala"
		_tmp188_ = p[0];
#line 377 "../src/page-view.vala"
		_tmp189_ = R;
#line 377 "../src/page-view.vala"
		_tmp190_ = T;
#line 377 "../src/page-view.vala"
		red = _tmp187_ + ((_tmp188_ * (r - _tmp189_)) * (_tmp190_ - t));
#line 378 "../src/page-view.vala"
		_tmp191_ = green;
#line 378 "../src/page-view.vala"
		_tmp192_ = p[1];
#line 378 "../src/page-view.vala"
		_tmp193_ = R;
#line 378 "../src/page-view.vala"
		_tmp194_ = T;
#line 378 "../src/page-view.vala"
		green = _tmp191_ + ((_tmp192_ * (r - _tmp193_)) * (_tmp194_ - t));
#line 379 "../src/page-view.vala"
		_tmp195_ = blue;
#line 379 "../src/page-view.vala"
		_tmp196_ = p[2];
#line 379 "../src/page-view.vala"
		_tmp197_ = R;
#line 379 "../src/page-view.vala"
		_tmp198_ = T;
#line 379 "../src/page-view.vala"
		blue = _tmp195_ + ((_tmp196_ * (r - _tmp197_)) * (_tmp198_ - t));
#line 1910 "page-view.c"
	}
#line 381 "../src/page-view.vala"
	_tmp200_ = R;
#line 381 "../src/page-view.vala"
	if (r != ((gdouble) _tmp200_)) {
#line 1916 "page-view.c"
		gint _tmp201_;
#line 381 "../src/page-view.vala"
		_tmp201_ = B;
#line 381 "../src/page-view.vala"
		_tmp199_ = b != ((gdouble) _tmp201_);
#line 1922 "page-view.c"
	} else {
#line 381 "../src/page-view.vala"
		_tmp199_ = FALSE;
#line 1926 "page-view.c"
	}
#line 381 "../src/page-view.vala"
	if (_tmp199_) {
#line 1930 "page-view.c"
		guchar p[3] = {0};
		gint _tmp202_;
		gint _tmp203_;
		gdouble _tmp204_;
		guchar _tmp205_;
		gint _tmp206_;
		gint _tmp207_;
		gdouble _tmp208_;
		guchar _tmp209_;
		gint _tmp210_;
		gint _tmp211_;
		gdouble _tmp212_;
		guchar _tmp213_;
		gint _tmp214_;
		gint _tmp215_;
#line 384 "../src/page-view.vala"
		_tmp202_ = R;
#line 384 "../src/page-view.vala"
		_tmp203_ = B;
#line 384 "../src/page-view.vala"
		page_view_get_pixel (self, page, _tmp202_, _tmp203_, p, 3);
#line 385 "../src/page-view.vala"
		_tmp204_ = red;
#line 385 "../src/page-view.vala"
		_tmp205_ = p[0];
#line 385 "../src/page-view.vala"
		_tmp206_ = R;
#line 385 "../src/page-view.vala"
		_tmp207_ = B;
#line 385 "../src/page-view.vala"
		red = _tmp204_ + ((_tmp205_ * (r - _tmp206_)) * (b - _tmp207_));
#line 386 "../src/page-view.vala"
		_tmp208_ = green;
#line 386 "../src/page-view.vala"
		_tmp209_ = p[1];
#line 386 "../src/page-view.vala"
		_tmp210_ = R;
#line 386 "../src/page-view.vala"
		_tmp211_ = B;
#line 386 "../src/page-view.vala"
		green = _tmp208_ + ((_tmp209_ * (r - _tmp210_)) * (b - _tmp211_));
#line 387 "../src/page-view.vala"
		_tmp212_ = blue;
#line 387 "../src/page-view.vala"
		_tmp213_ = p[2];
#line 387 "../src/page-view.vala"
		_tmp214_ = R;
#line 387 "../src/page-view.vala"
		_tmp215_ = B;
#line 387 "../src/page-view.vala"
		blue = _tmp212_ + ((_tmp213_ * (r - _tmp214_)) * (b - _tmp215_));
#line 1982 "page-view.c"
	}
#line 389 "../src/page-view.vala"
	_tmp217_ = L;
#line 389 "../src/page-view.vala"
	if (l != ((gdouble) _tmp217_)) {
#line 1988 "page-view.c"
		gint _tmp218_;
#line 389 "../src/page-view.vala"
		_tmp218_ = B;
#line 389 "../src/page-view.vala"
		_tmp216_ = b != ((gdouble) _tmp218_);
#line 1994 "page-view.c"
	} else {
#line 389 "../src/page-view.vala"
		_tmp216_ = FALSE;
#line 1998 "page-view.c"
	}
#line 389 "../src/page-view.vala"
	if (_tmp216_) {
#line 2002 "page-view.c"
		guchar p[3] = {0};
		gint _tmp219_;
		gint _tmp220_;
		gdouble _tmp221_;
		guchar _tmp222_;
		gint _tmp223_;
		gint _tmp224_;
		gdouble _tmp225_;
		guchar _tmp226_;
		gint _tmp227_;
		gint _tmp228_;
		gdouble _tmp229_;
		guchar _tmp230_;
		gint _tmp231_;
		gint _tmp232_;
#line 392 "../src/page-view.vala"
		_tmp219_ = L;
#line 392 "../src/page-view.vala"
		_tmp220_ = B;
#line 392 "../src/page-view.vala"
		page_view_get_pixel (self, page, _tmp219_ - 1, _tmp220_, p, 3);
#line 393 "../src/page-view.vala"
		_tmp221_ = red;
#line 393 "../src/page-view.vala"
		_tmp222_ = p[0];
#line 393 "../src/page-view.vala"
		_tmp223_ = L;
#line 393 "../src/page-view.vala"
		_tmp224_ = B;
#line 393 "../src/page-view.vala"
		red = _tmp221_ + ((_tmp222_ * (_tmp223_ - l)) * (b - _tmp224_));
#line 394 "../src/page-view.vala"
		_tmp225_ = green;
#line 394 "../src/page-view.vala"
		_tmp226_ = p[1];
#line 394 "../src/page-view.vala"
		_tmp227_ = L;
#line 394 "../src/page-view.vala"
		_tmp228_ = B;
#line 394 "../src/page-view.vala"
		green = _tmp225_ + ((_tmp226_ * (_tmp227_ - l)) * (b - _tmp228_));
#line 395 "../src/page-view.vala"
		_tmp229_ = blue;
#line 395 "../src/page-view.vala"
		_tmp230_ = p[2];
#line 395 "../src/page-view.vala"
		_tmp231_ = L;
#line 395 "../src/page-view.vala"
		_tmp232_ = B;
#line 395 "../src/page-view.vala"
		blue = _tmp229_ + ((_tmp230_ * (_tmp231_ - l)) * (b - _tmp232_));
#line 2054 "page-view.c"
	}
#line 399 "../src/page-view.vala"
	scale = 1.0 / ((r - l) * (b - t));
#line 400 "../src/page-view.vala"
	_tmp233_ = red;
#line 400 "../src/page-view.vala"
	_tmp234_ = scale;
#line 400 "../src/page-view.vala"
	output[offset] = (guchar) ((_tmp233_ * _tmp234_) + 0.5);
#line 401 "../src/page-view.vala"
	_tmp235_ = green;
#line 401 "../src/page-view.vala"
	_tmp236_ = scale;
#line 401 "../src/page-view.vala"
	output[offset + 1] = (guchar) ((_tmp235_ * _tmp236_) + 0.5);
#line 402 "../src/page-view.vala"
	_tmp237_ = blue;
#line 402 "../src/page-view.vala"
	_tmp238_ = scale;
#line 402 "../src/page-view.vala"
	output[offset + 2] = (guchar) ((_tmp237_ * _tmp238_) + 0.5);
#line 2076 "page-view.c"
}


static void
page_view_update_preview (PageView* self,
                          Page* page,
                          GdkPixbuf* * output_image,
                          gint output_width,
                          gint output_height,
                          ScanDirection scan_direction,
                          gint old_scan_line,
                          gint scan_line)
{
	gint input_width = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint input_height = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint L = 0;
	gint R = 0;
	gint T = 0;
	gint B = 0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	guchar* output = NULL;
	guint8* _tmp32_;
	gint output_length1;
	gint _output_size_;
	gint output_rowstride = 0;
	gint _tmp33_;
	gint _tmp34_;
	gint output_n_channels = 0;
	gint _tmp35_;
	gint _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
#line 405 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 405 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 408 "../src/page-view.vala"
	_tmp0_ = page_get_width (page);
#line 408 "../src/page-view.vala"
	_tmp1_ = _tmp0_;
#line 408 "../src/page-view.vala"
	input_width = _tmp1_;
#line 409 "../src/page-view.vala"
	_tmp2_ = page_get_height (page);
#line 409 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 409 "../src/page-view.vala"
	input_height = _tmp3_;
#line 413 "../src/page-view.vala"
	if ((*output_image) == NULL) {
#line 413 "../src/page-view.vala"
		_tmp5_ = TRUE;
#line 2140 "page-view.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 414 "../src/page-view.vala"
		_tmp6_ = gdk_pixbuf_get_width (*output_image);
#line 414 "../src/page-view.vala"
		_tmp7_ = _tmp6_;
#line 414 "../src/page-view.vala"
		_tmp5_ = _tmp7_ != output_width;
#line 2150 "page-view.c"
	}
#line 413 "../src/page-view.vala"
	if (_tmp5_) {
#line 413 "../src/page-view.vala"
		_tmp4_ = TRUE;
#line 2156 "page-view.c"
	} else {
		gint _tmp8_;
		gint _tmp9_;
#line 415 "../src/page-view.vala"
		_tmp8_ = gdk_pixbuf_get_height (*output_image);
#line 415 "../src/page-view.vala"
		_tmp9_ = _tmp8_;
#line 415 "../src/page-view.vala"
		_tmp4_ = _tmp9_ != output_height;
#line 2166 "page-view.c"
	}
#line 413 "../src/page-view.vala"
	if (_tmp4_) {
#line 2170 "page-view.c"
		GdkPixbuf* _tmp10_;
#line 417 "../src/page-view.vala"
		_tmp10_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, output_width, output_height);
#line 417 "../src/page-view.vala"
		_g_object_unref0 (*output_image);
#line 417 "../src/page-view.vala"
		*output_image = _tmp10_;
#line 424 "../src/page-view.vala"
		L = 0;
#line 425 "../src/page-view.vala"
		R = output_width - 1;
#line 426 "../src/page-view.vala"
		T = 0;
#line 427 "../src/page-view.vala"
		B = output_height - 1;
#line 2186 "page-view.c"
	} else {
#line 432 "../src/page-view.vala"
		switch (scan_direction) {
#line 432 "../src/page-view.vala"
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 2192 "page-view.c"
			{
				gint _tmp11_;
				gint _tmp12_;
#line 435 "../src/page-view.vala"
				L = 0;
#line 436 "../src/page-view.vala"
				R = output_width - 1;
#line 437 "../src/page-view.vala"
				_tmp11_ = input_height;
#line 437 "../src/page-view.vala"
				T = (gint) ((((gdouble) old_scan_line) * output_height) / _tmp11_);
#line 438 "../src/page-view.vala"
				_tmp12_ = input_height;
#line 438 "../src/page-view.vala"
				B = (gint) (((((gdouble) scan_line) * output_height) / _tmp12_) + 0.5);
#line 439 "../src/page-view.vala"
				break;
#line 2210 "page-view.c"
			}
#line 432 "../src/page-view.vala"
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 2214 "page-view.c"
			{
				gint _tmp13_;
				gint _tmp14_;
#line 441 "../src/page-view.vala"
				_tmp13_ = input_width;
#line 441 "../src/page-view.vala"
				L = (gint) ((((gdouble) old_scan_line) * output_width) / _tmp13_);
#line 442 "../src/page-view.vala"
				_tmp14_ = input_width;
#line 442 "../src/page-view.vala"
				R = (gint) (((((gdouble) scan_line) * output_width) / _tmp14_) + 0.5);
#line 443 "../src/page-view.vala"
				T = 0;
#line 444 "../src/page-view.vala"
				B = output_height - 1;
#line 445 "../src/page-view.vala"
				break;
#line 2232 "page-view.c"
			}
#line 432 "../src/page-view.vala"
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 2236 "page-view.c"
			{
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 447 "../src/page-view.vala"
				L = 0;
#line 448 "../src/page-view.vala"
				R = output_width - 1;
#line 449 "../src/page-view.vala"
				_tmp15_ = input_height;
#line 449 "../src/page-view.vala"
				_tmp16_ = input_height;
#line 449 "../src/page-view.vala"
				T = (gint) ((((gdouble) (_tmp15_ - scan_line)) * output_height) / _tmp16_);
#line 450 "../src/page-view.vala"
				_tmp17_ = input_height;
#line 450 "../src/page-view.vala"
				_tmp18_ = input_height;
#line 450 "../src/page-view.vala"
				B = (gint) (((((gdouble) (_tmp17_ - old_scan_line)) * output_height) / _tmp18_) + 0.5);
#line 451 "../src/page-view.vala"
				break;
#line 2260 "page-view.c"
			}
#line 432 "../src/page-view.vala"
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 2264 "page-view.c"
			{
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 453 "../src/page-view.vala"
				_tmp19_ = input_width;
#line 453 "../src/page-view.vala"
				_tmp20_ = input_width;
#line 453 "../src/page-view.vala"
				L = (gint) ((((gdouble) (_tmp19_ - scan_line)) * output_width) / _tmp20_);
#line 454 "../src/page-view.vala"
				_tmp21_ = input_width;
#line 454 "../src/page-view.vala"
				_tmp22_ = input_width;
#line 454 "../src/page-view.vala"
				R = (gint) (((((gdouble) (_tmp21_ - old_scan_line)) * output_width) / _tmp22_) + 0.5);
#line 455 "../src/page-view.vala"
				T = 0;
#line 456 "../src/page-view.vala"
				B = output_height - 1;
#line 457 "../src/page-view.vala"
				break;
#line 2288 "page-view.c"
			}
			default:
			{
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 459 "../src/page-view.vala"
				T = 0;
#line 459 "../src/page-view.vala"
				_tmp23_ = T;
#line 459 "../src/page-view.vala"
				B = _tmp23_;
#line 459 "../src/page-view.vala"
				_tmp24_ = B;
#line 459 "../src/page-view.vala"
				R = _tmp24_;
#line 459 "../src/page-view.vala"
				_tmp25_ = R;
#line 459 "../src/page-view.vala"
				L = _tmp25_;
#line 460 "../src/page-view.vala"
				break;
#line 2311 "page-view.c"
			}
		}
	}
#line 465 "../src/page-view.vala"
	_tmp26_ = R;
#line 465 "../src/page-view.vala"
	if (_tmp26_ >= output_width) {
#line 466 "../src/page-view.vala"
		R = output_width - 1;
#line 2321 "page-view.c"
	}
#line 467 "../src/page-view.vala"
	_tmp27_ = B;
#line 467 "../src/page-view.vala"
	if (_tmp27_ >= output_height) {
#line 468 "../src/page-view.vala"
		B = output_height - 1;
#line 2329 "page-view.c"
	}
#line 470 "../src/page-view.vala"
	_tmp28_ = L;
#line 470 "../src/page-view.vala"
	g_return_if_fail (_tmp28_ >= 0);
#line 471 "../src/page-view.vala"
	_tmp29_ = R;
#line 471 "../src/page-view.vala"
	g_return_if_fail (_tmp29_ < output_width);
#line 472 "../src/page-view.vala"
	_tmp30_ = T;
#line 472 "../src/page-view.vala"
	g_return_if_fail (_tmp30_ >= 0);
#line 473 "../src/page-view.vala"
	_tmp31_ = B;
#line 473 "../src/page-view.vala"
	g_return_if_fail (_tmp31_ < output_height);
#line 474 "../src/page-view.vala"
	g_return_if_fail ((*output_image) != NULL);
#line 476 "../src/page-view.vala"
	_tmp32_ = gdk_pixbuf_get_pixels (*output_image);
#line 476 "../src/page-view.vala"
	output = _tmp32_;
#line 476 "../src/page-view.vala"
	output_length1 = -1;
#line 476 "../src/page-view.vala"
	_output_size_ = output_length1;
#line 477 "../src/page-view.vala"
	_tmp33_ = gdk_pixbuf_get_rowstride (*output_image);
#line 477 "../src/page-view.vala"
	_tmp34_ = _tmp33_;
#line 477 "../src/page-view.vala"
	output_rowstride = _tmp34_;
#line 478 "../src/page-view.vala"
	_tmp35_ = gdk_pixbuf_get_n_channels (*output_image);
#line 478 "../src/page-view.vala"
	_tmp36_ = _tmp35_;
#line 478 "../src/page-view.vala"
	output_n_channels = _tmp36_;
#line 480 "../src/page-view.vala"
	_tmp37_ = page_get_has_data (page);
#line 480 "../src/page-view.vala"
	_tmp38_ = _tmp37_;
#line 480 "../src/page-view.vala"
	if (!_tmp38_) {
#line 2375 "page-view.c"
		{
			gint x = 0;
			gint _tmp39_;
#line 482 "../src/page-view.vala"
			_tmp39_ = L;
#line 482 "../src/page-view.vala"
			x = _tmp39_;
#line 2383 "page-view.c"
			{
				gboolean _tmp40_ = FALSE;
#line 482 "../src/page-view.vala"
				_tmp40_ = TRUE;
#line 482 "../src/page-view.vala"
				while (TRUE) {
#line 2390 "page-view.c"
					gint _tmp42_;
					gint _tmp43_;
#line 482 "../src/page-view.vala"
					if (!_tmp40_) {
#line 2395 "page-view.c"
						gint _tmp41_;
#line 482 "../src/page-view.vala"
						_tmp41_ = x;
#line 482 "../src/page-view.vala"
						x = _tmp41_ + 1;
#line 2401 "page-view.c"
					}
#line 482 "../src/page-view.vala"
					_tmp40_ = FALSE;
#line 482 "../src/page-view.vala"
					_tmp42_ = x;
#line 482 "../src/page-view.vala"
					_tmp43_ = R;
#line 482 "../src/page-view.vala"
					if (!(_tmp42_ <= _tmp43_)) {
#line 482 "../src/page-view.vala"
						break;
#line 2413 "page-view.c"
					}
					{
						gint y = 0;
						gint _tmp44_;
#line 483 "../src/page-view.vala"
						_tmp44_ = T;
#line 483 "../src/page-view.vala"
						y = _tmp44_;
#line 2422 "page-view.c"
						{
							gboolean _tmp45_ = FALSE;
#line 483 "../src/page-view.vala"
							_tmp45_ = TRUE;
#line 483 "../src/page-view.vala"
							while (TRUE) {
#line 2429 "page-view.c"
								gint _tmp47_;
								gint _tmp48_;
								gint o = 0;
								gint _tmp49_;
								gint _tmp50_;
								gint _tmp51_;
								gint _tmp52_;
								guchar* _tmp53_;
								gint _tmp53__length1;
								gint _tmp54_;
								guchar* _tmp55_;
								gint _tmp55__length1;
								gint _tmp56_;
								guchar* _tmp57_;
								gint _tmp57__length1;
								gint _tmp58_;
#line 483 "../src/page-view.vala"
								if (!_tmp45_) {
#line 2448 "page-view.c"
									gint _tmp46_;
#line 483 "../src/page-view.vala"
									_tmp46_ = y;
#line 483 "../src/page-view.vala"
									y = _tmp46_ + 1;
#line 2454 "page-view.c"
								}
#line 483 "../src/page-view.vala"
								_tmp45_ = FALSE;
#line 483 "../src/page-view.vala"
								_tmp47_ = y;
#line 483 "../src/page-view.vala"
								_tmp48_ = B;
#line 483 "../src/page-view.vala"
								if (!(_tmp47_ <= _tmp48_)) {
#line 483 "../src/page-view.vala"
									break;
#line 2466 "page-view.c"
								}
#line 485 "../src/page-view.vala"
								_tmp49_ = output_rowstride;
#line 485 "../src/page-view.vala"
								_tmp50_ = y;
#line 485 "../src/page-view.vala"
								_tmp51_ = x;
#line 485 "../src/page-view.vala"
								_tmp52_ = output_n_channels;
#line 485 "../src/page-view.vala"
								o = (_tmp49_ * _tmp50_) + (_tmp51_ * _tmp52_);
#line 486 "../src/page-view.vala"
								_tmp53_ = output;
#line 486 "../src/page-view.vala"
								_tmp53__length1 = output_length1;
#line 486 "../src/page-view.vala"
								_tmp54_ = o;
#line 486 "../src/page-view.vala"
								_tmp55_ = output;
#line 486 "../src/page-view.vala"
								_tmp55__length1 = output_length1;
#line 486 "../src/page-view.vala"
								_tmp56_ = o;
#line 486 "../src/page-view.vala"
								_tmp57_ = output;
#line 486 "../src/page-view.vala"
								_tmp57__length1 = output_length1;
#line 486 "../src/page-view.vala"
								_tmp58_ = o;
#line 486 "../src/page-view.vala"
								_tmp57_[_tmp58_ + 2] = (guchar) 0xFF;
#line 486 "../src/page-view.vala"
								_tmp55_[_tmp56_ + 1] = (guchar) 0xFF;
#line 486 "../src/page-view.vala"
								_tmp53_[_tmp54_] = (guchar) 0xFF;
#line 2502 "page-view.c"
							}
						}
					}
				}
			}
		}
#line 488 "../src/page-view.vala"
		return;
#line 2511 "page-view.c"
	}
	{
		gint x = 0;
		gint _tmp59_;
#line 492 "../src/page-view.vala"
		_tmp59_ = L;
#line 492 "../src/page-view.vala"
		x = _tmp59_;
#line 2520 "page-view.c"
		{
			gboolean _tmp60_ = FALSE;
#line 492 "../src/page-view.vala"
			_tmp60_ = TRUE;
#line 492 "../src/page-view.vala"
			while (TRUE) {
#line 2527 "page-view.c"
				gint _tmp62_;
				gint _tmp63_;
				gdouble l = 0.0;
				gint _tmp64_;
				gint _tmp65_;
				gdouble r = 0.0;
				gint _tmp66_;
				gint _tmp67_;
#line 492 "../src/page-view.vala"
				if (!_tmp60_) {
#line 2538 "page-view.c"
					gint _tmp61_;
#line 492 "../src/page-view.vala"
					_tmp61_ = x;
#line 492 "../src/page-view.vala"
					x = _tmp61_ + 1;
#line 2544 "page-view.c"
				}
#line 492 "../src/page-view.vala"
				_tmp60_ = FALSE;
#line 492 "../src/page-view.vala"
				_tmp62_ = x;
#line 492 "../src/page-view.vala"
				_tmp63_ = R;
#line 492 "../src/page-view.vala"
				if (!(_tmp62_ <= _tmp63_)) {
#line 492 "../src/page-view.vala"
					break;
#line 2556 "page-view.c"
				}
#line 494 "../src/page-view.vala"
				_tmp64_ = x;
#line 494 "../src/page-view.vala"
				_tmp65_ = input_width;
#line 494 "../src/page-view.vala"
				l = (((gdouble) _tmp64_) * _tmp65_) / output_width;
#line 495 "../src/page-view.vala"
				_tmp66_ = x;
#line 495 "../src/page-view.vala"
				_tmp67_ = input_width;
#line 495 "../src/page-view.vala"
				r = (((gdouble) (_tmp66_ + 1)) * _tmp67_) / output_width;
#line 2570 "page-view.c"
				{
					gint y = 0;
					gint _tmp68_;
#line 497 "../src/page-view.vala"
					_tmp68_ = T;
#line 497 "../src/page-view.vala"
					y = _tmp68_;
#line 2578 "page-view.c"
					{
						gboolean _tmp69_ = FALSE;
#line 497 "../src/page-view.vala"
						_tmp69_ = TRUE;
#line 497 "../src/page-view.vala"
						while (TRUE) {
#line 2585 "page-view.c"
							gint _tmp71_;
							gint _tmp72_;
							gdouble t = 0.0;
							gint _tmp73_;
							gint _tmp74_;
							gdouble b = 0.0;
							gint _tmp75_;
							gint _tmp76_;
							gdouble _tmp77_;
							gdouble _tmp78_;
							gdouble _tmp79_;
							gdouble _tmp80_;
							guchar* _tmp81_;
							gint _tmp81__length1;
							gint _tmp82_;
							gint _tmp83_;
							gint _tmp84_;
							gint _tmp85_;
#line 497 "../src/page-view.vala"
							if (!_tmp69_) {
#line 2606 "page-view.c"
								gint _tmp70_;
#line 497 "../src/page-view.vala"
								_tmp70_ = y;
#line 497 "../src/page-view.vala"
								y = _tmp70_ + 1;
#line 2612 "page-view.c"
							}
#line 497 "../src/page-view.vala"
							_tmp69_ = FALSE;
#line 497 "../src/page-view.vala"
							_tmp71_ = y;
#line 497 "../src/page-view.vala"
							_tmp72_ = B;
#line 497 "../src/page-view.vala"
							if (!(_tmp71_ <= _tmp72_)) {
#line 497 "../src/page-view.vala"
								break;
#line 2624 "page-view.c"
							}
#line 499 "../src/page-view.vala"
							_tmp73_ = y;
#line 499 "../src/page-view.vala"
							_tmp74_ = input_height;
#line 499 "../src/page-view.vala"
							t = (((gdouble) _tmp73_) * _tmp74_) / output_height;
#line 500 "../src/page-view.vala"
							_tmp75_ = y;
#line 500 "../src/page-view.vala"
							_tmp76_ = input_height;
#line 500 "../src/page-view.vala"
							b = (((gdouble) (_tmp75_ + 1)) * _tmp76_) / output_height;
#line 502 "../src/page-view.vala"
							_tmp77_ = l;
#line 502 "../src/page-view.vala"
							_tmp78_ = r;
#line 502 "../src/page-view.vala"
							_tmp79_ = t;
#line 502 "../src/page-view.vala"
							_tmp80_ = b;
#line 502 "../src/page-view.vala"
							_tmp81_ = output;
#line 502 "../src/page-view.vala"
							_tmp81__length1 = output_length1;
#line 502 "../src/page-view.vala"
							_tmp82_ = output_rowstride;
#line 502 "../src/page-view.vala"
							_tmp83_ = y;
#line 502 "../src/page-view.vala"
							_tmp84_ = x;
#line 502 "../src/page-view.vala"
							_tmp85_ = output_n_channels;
#line 502 "../src/page-view.vala"
							page_view_set_pixel (self, page, _tmp77_, _tmp78_, _tmp79_, _tmp80_, _tmp81_, _tmp81__length1, (_tmp82_ * _tmp83_) + (_tmp84_ * _tmp85_));
#line 2660 "page-view.c"
						}
					}
				}
			}
		}
	}
}


static gint
page_view_get_preview_width (PageView* self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 509 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 511 "../src/page-view.vala"
	_tmp0_ = self->priv->width_;
#line 511 "../src/page-view.vala"
	_tmp1_ = self->priv->border_width;
#line 511 "../src/page-view.vala"
	result = _tmp0_ - (_tmp1_ * 2);
#line 511 "../src/page-view.vala"
	return result;
#line 2686 "page-view.c"
}


static gint
page_view_get_preview_height (PageView* self)
{
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 514 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 516 "../src/page-view.vala"
	_tmp0_ = self->priv->height_;
#line 516 "../src/page-view.vala"
	_tmp1_ = self->priv->border_width;
#line 516 "../src/page-view.vala"
	result = _tmp0_ - (_tmp1_ * 2);
#line 516 "../src/page-view.vala"
	return result;
#line 2706 "page-view.c"
}


static void
page_view_update_page_view (PageView* self)
{
	gboolean _tmp0_;
	gint old_scan_line = 0;
	gint _tmp1_;
	gint scan_line = 0;
	Page* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ScanDirection left_steps = 0;
	ScanDirection _tmp5_;
	Page* _tmp6_;
	ScanDirection _tmp7_;
	ScanDirection _tmp8_;
	gboolean _tmp9_ = FALSE;
	ScanDirection _tmp10_;
	Page* _tmp12_;
	ScanDirection _tmp13_;
	ScanDirection _tmp14_;
	Page* _tmp15_;
	Page* _tmp16_;
	ScanDirection _tmp17_;
	ScanDirection _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
#line 519 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 521 "../src/page-view.vala"
	_tmp0_ = self->priv->update_image;
#line 521 "../src/page-view.vala"
	if (!_tmp0_) {
#line 522 "../src/page-view.vala"
		return;
#line 2745 "page-view.c"
	}
#line 524 "../src/page-view.vala"
	_tmp1_ = self->priv->scan_line;
#line 524 "../src/page-view.vala"
	old_scan_line = _tmp1_;
#line 525 "../src/page-view.vala"
	_tmp2_ = self->priv->_page;
#line 525 "../src/page-view.vala"
	_tmp3_ = page_get_scan_line (_tmp2_);
#line 525 "../src/page-view.vala"
	_tmp4_ = _tmp3_;
#line 525 "../src/page-view.vala"
	scan_line = _tmp4_;
#line 528 "../src/page-view.vala"
	_tmp5_ = self->priv->scan_direction;
#line 528 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 528 "../src/page-view.vala"
	_tmp7_ = page_get_scan_direction (_tmp6_);
#line 528 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 528 "../src/page-view.vala"
	left_steps = _tmp5_ - _tmp8_;
#line 529 "../src/page-view.vala"
	_tmp10_ = left_steps;
#line 529 "../src/page-view.vala"
	if (_tmp10_ != 0) {
#line 2773 "page-view.c"
		GdkPixbuf* _tmp11_;
#line 529 "../src/page-view.vala"
		_tmp11_ = self->priv->image;
#line 529 "../src/page-view.vala"
		_tmp9_ = _tmp11_ != NULL;
#line 2779 "page-view.c"
	} else {
#line 529 "../src/page-view.vala"
		_tmp9_ = FALSE;
#line 2783 "page-view.c"
	}
#line 529 "../src/page-view.vala"
	if (_tmp9_) {
#line 530 "../src/page-view.vala"
		_g_object_unref0 (self->priv->image);
#line 530 "../src/page-view.vala"
		self->priv->image = NULL;
#line 2791 "page-view.c"
	}
#line 531 "../src/page-view.vala"
	_tmp12_ = self->priv->_page;
#line 531 "../src/page-view.vala"
	_tmp13_ = page_get_scan_direction (_tmp12_);
#line 531 "../src/page-view.vala"
	_tmp14_ = _tmp13_;
#line 531 "../src/page-view.vala"
	self->priv->scan_direction = _tmp14_;
#line 533 "../src/page-view.vala"
	_tmp15_ = self->priv->_page;
#line 533 "../src/page-view.vala"
	_tmp16_ = self->priv->_page;
#line 533 "../src/page-view.vala"
	_tmp17_ = page_get_scan_direction (_tmp16_);
#line 533 "../src/page-view.vala"
	_tmp18_ = _tmp17_;
#line 533 "../src/page-view.vala"
	_tmp19_ = old_scan_line;
#line 533 "../src/page-view.vala"
	_tmp20_ = scan_line;
#line 533 "../src/page-view.vala"
	page_view_update_preview (self, _tmp15_, &self->priv->image, page_view_get_preview_width (self), page_view_get_preview_height (self), _tmp18_, _tmp19_, _tmp20_);
#line 539 "../src/page-view.vala"
	self->priv->update_image = FALSE;
#line 540 "../src/page-view.vala"
	_tmp21_ = scan_line;
#line 540 "../src/page-view.vala"
	self->priv->scan_line = _tmp21_;
#line 2821 "page-view.c"
}


static gint
page_view_page_to_screen_x (PageView* self,
                            gint x)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 543 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 545 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 545 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 545 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 545 "../src/page-view.vala"
	result = (gint) (((((gdouble) x) * page_view_get_preview_width (self)) / _tmp2_) + 0.5);
#line 545 "../src/page-view.vala"
	return result;
#line 2845 "page-view.c"
}


static gint
page_view_page_to_screen_y (PageView* self,
                            gint y)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 548 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 550 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 550 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 550 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 550 "../src/page-view.vala"
	result = (gint) (((((gdouble) y) * page_view_get_preview_height (self)) / _tmp2_) + 0.5);
#line 550 "../src/page-view.vala"
	return result;
#line 2869 "page-view.c"
}


static gint
page_view_screen_to_page_x (PageView* self,
                            gint x)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 553 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 555 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 555 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 555 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 555 "../src/page-view.vala"
	result = (gint) (((((gdouble) x) * _tmp2_) / page_view_get_preview_width (self)) + 0.5);
#line 555 "../src/page-view.vala"
	return result;
#line 2893 "page-view.c"
}


static gint
page_view_screen_to_page_y (PageView* self,
                            gint y)
{
	gint result = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 558 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 560 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 560 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 560 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 560 "../src/page-view.vala"
	result = (gint) (((((gdouble) y) * _tmp2_) / page_view_get_preview_height (self)) + 0.5);
#line 560 "../src/page-view.vala"
	return result;
#line 2917 "page-view.c"
}


static CropLocation
page_view_get_crop_location (PageView* self,
                             gint x,
                             gint y)
{
	CropLocation result = 0;
	Page* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint cx = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint cy = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gint _tmp15_;
	gint dy = 0;
	gint _tmp16_;
	gint dw = 0;
	gint _tmp17_;
	gint dh = 0;
	gint _tmp18_;
	gint ix = 0;
	gint _tmp19_;
	gint iy = 0;
	gint _tmp20_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gint _tmp24_;
	gchar* name = NULL;
	Page* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	gint crop_border = 0;
	gint _tmp35_;
	gint _tmp36_;
	gint _tmp38_;
	gint _tmp39_;
	gboolean _tmp41_ = FALSE;
	gint _tmp42_;
	gint _tmp43_;
	gboolean _tmp46_ = FALSE;
	gint _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gboolean _tmp52_ = FALSE;
	gint _tmp53_;
	gint _tmp54_;
	gboolean _tmp58_ = FALSE;
	gint _tmp59_;
	gint _tmp60_;
	gint _tmp61_;
	gint _tmp65_;
	gint _tmp66_;
	gint _tmp67_;
	gint _tmp68_;
	gint _tmp69_;
	gint _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
#line 563 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 565 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 565 "../src/page-view.vala"
	_tmp1_ = page_get_has_crop (_tmp0_);
#line 565 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 565 "../src/page-view.vala"
	if (!_tmp2_) {
#line 566 "../src/page-view.vala"
		result = CROP_LOCATION_NONE;
#line 566 "../src/page-view.vala"
		return result;
#line 3011 "page-view.c"
	}
#line 568 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 568 "../src/page-view.vala"
	_tmp4_ = page_get_crop_x (_tmp3_);
#line 568 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 568 "../src/page-view.vala"
	cx = _tmp5_;
#line 569 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 569 "../src/page-view.vala"
	_tmp7_ = page_get_crop_y (_tmp6_);
#line 569 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 569 "../src/page-view.vala"
	cy = _tmp8_;
#line 570 "../src/page-view.vala"
	_tmp9_ = self->priv->_page;
#line 570 "../src/page-view.vala"
	_tmp10_ = page_get_crop_width (_tmp9_);
#line 570 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 570 "../src/page-view.vala"
	cw = _tmp11_;
#line 571 "../src/page-view.vala"
	_tmp12_ = self->priv->_page;
#line 571 "../src/page-view.vala"
	_tmp13_ = page_get_crop_height (_tmp12_);
#line 571 "../src/page-view.vala"
	_tmp14_ = _tmp13_;
#line 571 "../src/page-view.vala"
	ch = _tmp14_;
#line 572 "../src/page-view.vala"
	_tmp15_ = cx;
#line 572 "../src/page-view.vala"
	dx = page_view_page_to_screen_x (self, _tmp15_);
#line 573 "../src/page-view.vala"
	_tmp16_ = cy;
#line 573 "../src/page-view.vala"
	dy = page_view_page_to_screen_y (self, _tmp16_);
#line 574 "../src/page-view.vala"
	_tmp17_ = cw;
#line 574 "../src/page-view.vala"
	dw = page_view_page_to_screen_x (self, _tmp17_);
#line 575 "../src/page-view.vala"
	_tmp18_ = ch;
#line 575 "../src/page-view.vala"
	dh = page_view_page_to_screen_y (self, _tmp18_);
#line 576 "../src/page-view.vala"
	_tmp19_ = dx;
#line 576 "../src/page-view.vala"
	ix = x - _tmp19_;
#line 577 "../src/page-view.vala"
	_tmp20_ = dy;
#line 577 "../src/page-view.vala"
	iy = y - _tmp20_;
#line 579 "../src/page-view.vala"
	_tmp24_ = ix;
#line 579 "../src/page-view.vala"
	if (_tmp24_ < 0) {
#line 579 "../src/page-view.vala"
		_tmp23_ = TRUE;
#line 3075 "page-view.c"
	} else {
		gint _tmp25_;
		gint _tmp26_;
#line 579 "../src/page-view.vala"
		_tmp25_ = ix;
#line 579 "../src/page-view.vala"
		_tmp26_ = dw;
#line 579 "../src/page-view.vala"
		_tmp23_ = _tmp25_ > _tmp26_;
#line 3085 "page-view.c"
	}
#line 579 "../src/page-view.vala"
	if (_tmp23_) {
#line 579 "../src/page-view.vala"
		_tmp22_ = TRUE;
#line 3091 "page-view.c"
	} else {
		gint _tmp27_;
#line 579 "../src/page-view.vala"
		_tmp27_ = iy;
#line 579 "../src/page-view.vala"
		_tmp22_ = _tmp27_ < 0;
#line 3098 "page-view.c"
	}
#line 579 "../src/page-view.vala"
	if (_tmp22_) {
#line 579 "../src/page-view.vala"
		_tmp21_ = TRUE;
#line 3104 "page-view.c"
	} else {
		gint _tmp28_;
		gint _tmp29_;
#line 579 "../src/page-view.vala"
		_tmp28_ = iy;
#line 579 "../src/page-view.vala"
		_tmp29_ = dh;
#line 579 "../src/page-view.vala"
		_tmp21_ = _tmp28_ > _tmp29_;
#line 3114 "page-view.c"
	}
#line 579 "../src/page-view.vala"
	if (_tmp21_) {
#line 580 "../src/page-view.vala"
		result = CROP_LOCATION_NONE;
#line 580 "../src/page-view.vala"
		return result;
#line 3122 "page-view.c"
	}
#line 583 "../src/page-view.vala"
	_tmp30_ = self->priv->_page;
#line 583 "../src/page-view.vala"
	_tmp31_ = page_get_crop_name (_tmp30_);
#line 583 "../src/page-view.vala"
	_tmp32_ = _tmp31_;
#line 583 "../src/page-view.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 583 "../src/page-view.vala"
	name = _tmp33_;
#line 584 "../src/page-view.vala"
	_tmp34_ = name;
#line 584 "../src/page-view.vala"
	if (_tmp34_ != NULL) {
#line 585 "../src/page-view.vala"
		result = CROP_LOCATION_MIDDLE;
#line 585 "../src/page-view.vala"
		_g_free0 (name);
#line 585 "../src/page-view.vala"
		return result;
#line 3144 "page-view.c"
	}
#line 588 "../src/page-view.vala"
	crop_border = 20;
#line 589 "../src/page-view.vala"
	_tmp35_ = dw;
#line 589 "../src/page-view.vala"
	_tmp36_ = crop_border;
#line 589 "../src/page-view.vala"
	if (_tmp35_ < (_tmp36_ * 3)) {
#line 3154 "page-view.c"
		gint _tmp37_;
#line 590 "../src/page-view.vala"
		_tmp37_ = dw;
#line 590 "../src/page-view.vala"
		crop_border = _tmp37_ / 3;
#line 3160 "page-view.c"
	}
#line 591 "../src/page-view.vala"
	_tmp38_ = dh;
#line 591 "../src/page-view.vala"
	_tmp39_ = crop_border;
#line 591 "../src/page-view.vala"
	if (_tmp38_ < (_tmp39_ * 3)) {
#line 3168 "page-view.c"
		gint _tmp40_;
#line 592 "../src/page-view.vala"
		_tmp40_ = dh;
#line 592 "../src/page-view.vala"
		crop_border = _tmp40_ / 3;
#line 3174 "page-view.c"
	}
#line 595 "../src/page-view.vala"
	_tmp42_ = ix;
#line 595 "../src/page-view.vala"
	_tmp43_ = crop_border;
#line 595 "../src/page-view.vala"
	if (_tmp42_ < _tmp43_) {
#line 3182 "page-view.c"
		gint _tmp44_;
		gint _tmp45_;
#line 595 "../src/page-view.vala"
		_tmp44_ = iy;
#line 595 "../src/page-view.vala"
		_tmp45_ = crop_border;
#line 595 "../src/page-view.vala"
		_tmp41_ = _tmp44_ < _tmp45_;
#line 3191 "page-view.c"
	} else {
#line 595 "../src/page-view.vala"
		_tmp41_ = FALSE;
#line 3195 "page-view.c"
	}
#line 595 "../src/page-view.vala"
	if (_tmp41_) {
#line 596 "../src/page-view.vala"
		result = CROP_LOCATION_TOP_LEFT;
#line 596 "../src/page-view.vala"
		_g_free0 (name);
#line 596 "../src/page-view.vala"
		return result;
#line 3205 "page-view.c"
	}
#line 598 "../src/page-view.vala"
	_tmp47_ = ix;
#line 598 "../src/page-view.vala"
	_tmp48_ = dw;
#line 598 "../src/page-view.vala"
	_tmp49_ = crop_border;
#line 598 "../src/page-view.vala"
	if (_tmp47_ > (_tmp48_ - _tmp49_)) {
#line 3215 "page-view.c"
		gint _tmp50_;
		gint _tmp51_;
#line 598 "../src/page-view.vala"
		_tmp50_ = iy;
#line 598 "../src/page-view.vala"
		_tmp51_ = crop_border;
#line 598 "../src/page-view.vala"
		_tmp46_ = _tmp50_ < _tmp51_;
#line 3224 "page-view.c"
	} else {
#line 598 "../src/page-view.vala"
		_tmp46_ = FALSE;
#line 3228 "page-view.c"
	}
#line 598 "../src/page-view.vala"
	if (_tmp46_) {
#line 599 "../src/page-view.vala"
		result = CROP_LOCATION_TOP_RIGHT;
#line 599 "../src/page-view.vala"
		_g_free0 (name);
#line 599 "../src/page-view.vala"
		return result;
#line 3238 "page-view.c"
	}
#line 601 "../src/page-view.vala"
	_tmp53_ = ix;
#line 601 "../src/page-view.vala"
	_tmp54_ = crop_border;
#line 601 "../src/page-view.vala"
	if (_tmp53_ < _tmp54_) {
#line 3246 "page-view.c"
		gint _tmp55_;
		gint _tmp56_;
		gint _tmp57_;
#line 601 "../src/page-view.vala"
		_tmp55_ = iy;
#line 601 "../src/page-view.vala"
		_tmp56_ = dh;
#line 601 "../src/page-view.vala"
		_tmp57_ = crop_border;
#line 601 "../src/page-view.vala"
		_tmp52_ = _tmp55_ > (_tmp56_ - _tmp57_);
#line 3258 "page-view.c"
	} else {
#line 601 "../src/page-view.vala"
		_tmp52_ = FALSE;
#line 3262 "page-view.c"
	}
#line 601 "../src/page-view.vala"
	if (_tmp52_) {
#line 602 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM_LEFT;
#line 602 "../src/page-view.vala"
		_g_free0 (name);
#line 602 "../src/page-view.vala"
		return result;
#line 3272 "page-view.c"
	}
#line 604 "../src/page-view.vala"
	_tmp59_ = ix;
#line 604 "../src/page-view.vala"
	_tmp60_ = dw;
#line 604 "../src/page-view.vala"
	_tmp61_ = crop_border;
#line 604 "../src/page-view.vala"
	if (_tmp59_ > (_tmp60_ - _tmp61_)) {
#line 3282 "page-view.c"
		gint _tmp62_;
		gint _tmp63_;
		gint _tmp64_;
#line 604 "../src/page-view.vala"
		_tmp62_ = iy;
#line 604 "../src/page-view.vala"
		_tmp63_ = dh;
#line 604 "../src/page-view.vala"
		_tmp64_ = crop_border;
#line 604 "../src/page-view.vala"
		_tmp58_ = _tmp62_ > (_tmp63_ - _tmp64_);
#line 3294 "page-view.c"
	} else {
#line 604 "../src/page-view.vala"
		_tmp58_ = FALSE;
#line 3298 "page-view.c"
	}
#line 604 "../src/page-view.vala"
	if (_tmp58_) {
#line 605 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM_RIGHT;
#line 605 "../src/page-view.vala"
		_g_free0 (name);
#line 605 "../src/page-view.vala"
		return result;
#line 3308 "page-view.c"
	}
#line 608 "../src/page-view.vala"
	_tmp65_ = ix;
#line 608 "../src/page-view.vala"
	_tmp66_ = crop_border;
#line 608 "../src/page-view.vala"
	if (_tmp65_ < _tmp66_) {
#line 609 "../src/page-view.vala"
		result = CROP_LOCATION_LEFT;
#line 609 "../src/page-view.vala"
		_g_free0 (name);
#line 609 "../src/page-view.vala"
		return result;
#line 3322 "page-view.c"
	}
#line 611 "../src/page-view.vala"
	_tmp67_ = ix;
#line 611 "../src/page-view.vala"
	_tmp68_ = dw;
#line 611 "../src/page-view.vala"
	_tmp69_ = crop_border;
#line 611 "../src/page-view.vala"
	if (_tmp67_ > (_tmp68_ - _tmp69_)) {
#line 612 "../src/page-view.vala"
		result = CROP_LOCATION_RIGHT;
#line 612 "../src/page-view.vala"
		_g_free0 (name);
#line 612 "../src/page-view.vala"
		return result;
#line 3338 "page-view.c"
	}
#line 614 "../src/page-view.vala"
	_tmp70_ = iy;
#line 614 "../src/page-view.vala"
	_tmp71_ = crop_border;
#line 614 "../src/page-view.vala"
	if (_tmp70_ < _tmp71_) {
#line 615 "../src/page-view.vala"
		result = CROP_LOCATION_TOP;
#line 615 "../src/page-view.vala"
		_g_free0 (name);
#line 615 "../src/page-view.vala"
		return result;
#line 3352 "page-view.c"
	}
#line 617 "../src/page-view.vala"
	_tmp72_ = iy;
#line 617 "../src/page-view.vala"
	_tmp73_ = dh;
#line 617 "../src/page-view.vala"
	_tmp74_ = crop_border;
#line 617 "../src/page-view.vala"
	if (_tmp72_ > (_tmp73_ - _tmp74_)) {
#line 618 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM;
#line 618 "../src/page-view.vala"
		_g_free0 (name);
#line 618 "../src/page-view.vala"
		return result;
#line 3368 "page-view.c"
	}
#line 621 "../src/page-view.vala"
	result = CROP_LOCATION_MIDDLE;
#line 621 "../src/page-view.vala"
	_g_free0 (name);
#line 621 "../src/page-view.vala"
	return result;
#line 3376 "page-view.c"
}


void
page_view_button_press (PageView* self,
                        gint x,
                        gint y)
{
	CropLocation location = 0;
	CropLocation _tmp0_;
#line 624 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/page-view.vala"
	location = page_view_get_crop_location (self, x, y);
#line 628 "../src/page-view.vala"
	_tmp0_ = location;
#line 628 "../src/page-view.vala"
	if (_tmp0_ != CROP_LOCATION_NONE) {
#line 3395 "page-view.c"
		CropLocation _tmp1_;
		Page* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		Page* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		Page* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		Page* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 630 "../src/page-view.vala"
		_tmp1_ = location;
#line 630 "../src/page-view.vala"
		self->priv->crop_location = _tmp1_;
#line 631 "../src/page-view.vala"
		self->priv->selected_crop_px = (gdouble) x;
#line 632 "../src/page-view.vala"
		self->priv->selected_crop_py = (gdouble) y;
#line 633 "../src/page-view.vala"
		_tmp2_ = self->priv->_page;
#line 633 "../src/page-view.vala"
		_tmp3_ = page_get_crop_x (_tmp2_);
#line 633 "../src/page-view.vala"
		_tmp4_ = _tmp3_;
#line 633 "../src/page-view.vala"
		self->priv->selected_crop_x = _tmp4_;
#line 634 "../src/page-view.vala"
		_tmp5_ = self->priv->_page;
#line 634 "../src/page-view.vala"
		_tmp6_ = page_get_crop_y (_tmp5_);
#line 634 "../src/page-view.vala"
		_tmp7_ = _tmp6_;
#line 634 "../src/page-view.vala"
		self->priv->selected_crop_y = _tmp7_;
#line 635 "../src/page-view.vala"
		_tmp8_ = self->priv->_page;
#line 635 "../src/page-view.vala"
		_tmp9_ = page_get_crop_width (_tmp8_);
#line 635 "../src/page-view.vala"
		_tmp10_ = _tmp9_;
#line 635 "../src/page-view.vala"
		self->priv->selected_crop_w = _tmp10_;
#line 636 "../src/page-view.vala"
		_tmp11_ = self->priv->_page;
#line 636 "../src/page-view.vala"
		_tmp12_ = page_get_crop_height (_tmp11_);
#line 636 "../src/page-view.vala"
		_tmp13_ = _tmp12_;
#line 636 "../src/page-view.vala"
		self->priv->selected_crop_h = _tmp13_;
#line 3449 "page-view.c"
	}
}


void
page_view_motion (PageView* self,
                  gint x,
                  gint y)
{
	CropLocation location = 0;
	GdkCursorType cursor = 0;
	CropLocation _tmp0_;
	CropLocation _tmp1_;
	gint pw = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint ph = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gdouble _tmp15_;
	gint dy = 0;
	gdouble _tmp16_;
	gint new_x = 0;
	gint _tmp17_;
	gint new_y = 0;
	gint _tmp18_;
	gint new_w = 0;
	gint _tmp19_;
	gint new_h = 0;
	gint _tmp20_;
	gint min_size = 0;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	CropLocation _tmp23_;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	CropLocation _tmp36_;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	CropLocation _tmp49_;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_ = FALSE;
	CropLocation _tmp66_;
	CropLocation _tmp81_;
	CropLocation _tmp102_;
	gboolean _tmp107_ = FALSE;
	gboolean _tmp108_ = FALSE;
	CropLocation _tmp109_;
	gboolean _tmp116_ = FALSE;
	gboolean _tmp117_ = FALSE;
	CropLocation _tmp118_;
	gboolean _tmp125_ = FALSE;
	gboolean _tmp126_ = FALSE;
	CropLocation _tmp127_;
	gboolean _tmp132_ = FALSE;
	gboolean _tmp133_ = FALSE;
	CropLocation _tmp134_;
	Page* _tmp139_;
	gint _tmp140_;
	gint _tmp141_;
	gboolean _tmp142_ = FALSE;
	gint _tmp143_;
	gint _tmp144_;
#line 640 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 642 "../src/page-view.vala"
	location = page_view_get_crop_location (self, x, y);
#line 644 "../src/page-view.vala"
	_tmp0_ = location;
#line 644 "../src/page-view.vala"
	switch (_tmp0_) {
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_MIDDLE:
#line 3534 "page-view.c"
		{
#line 647 "../src/page-view.vala"
			cursor = GDK_HAND1;
#line 648 "../src/page-view.vala"
			break;
#line 3540 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_TOP:
#line 3544 "page-view.c"
		{
#line 650 "../src/page-view.vala"
			cursor = GDK_TOP_SIDE;
#line 651 "../src/page-view.vala"
			break;
#line 3550 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM:
#line 3554 "page-view.c"
		{
#line 653 "../src/page-view.vala"
			cursor = GDK_BOTTOM_SIDE;
#line 654 "../src/page-view.vala"
			break;
#line 3560 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_LEFT:
#line 3564 "page-view.c"
		{
#line 656 "../src/page-view.vala"
			cursor = GDK_LEFT_SIDE;
#line 657 "../src/page-view.vala"
			break;
#line 3570 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_RIGHT:
#line 3574 "page-view.c"
		{
#line 659 "../src/page-view.vala"
			cursor = GDK_RIGHT_SIDE;
#line 660 "../src/page-view.vala"
			break;
#line 3580 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_TOP_LEFT:
#line 3584 "page-view.c"
		{
#line 662 "../src/page-view.vala"
			cursor = GDK_TOP_LEFT_CORNER;
#line 663 "../src/page-view.vala"
			break;
#line 3590 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_TOP_RIGHT:
#line 3594 "page-view.c"
		{
#line 665 "../src/page-view.vala"
			cursor = GDK_TOP_RIGHT_CORNER;
#line 666 "../src/page-view.vala"
			break;
#line 3600 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM_LEFT:
#line 3604 "page-view.c"
		{
#line 668 "../src/page-view.vala"
			cursor = GDK_BOTTOM_LEFT_CORNER;
#line 669 "../src/page-view.vala"
			break;
#line 3610 "page-view.c"
		}
#line 644 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM_RIGHT:
#line 3614 "page-view.c"
		{
#line 671 "../src/page-view.vala"
			cursor = GDK_BOTTOM_RIGHT_CORNER;
#line 672 "../src/page-view.vala"
			break;
#line 3620 "page-view.c"
		}
		default:
		{
#line 674 "../src/page-view.vala"
			cursor = GDK_ARROW;
#line 675 "../src/page-view.vala"
			break;
#line 3628 "page-view.c"
		}
	}
#line 678 "../src/page-view.vala"
	_tmp1_ = self->priv->crop_location;
#line 678 "../src/page-view.vala"
	if (_tmp1_ == CROP_LOCATION_NONE) {
#line 3635 "page-view.c"
		GdkCursorType _tmp2_;
#line 680 "../src/page-view.vala"
		_tmp2_ = cursor;
#line 680 "../src/page-view.vala"
		page_view_set_cursor (self, _tmp2_);
#line 681 "../src/page-view.vala"
		return;
#line 3643 "page-view.c"
	}
#line 685 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 685 "../src/page-view.vala"
	_tmp4_ = page_get_width (_tmp3_);
#line 685 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 685 "../src/page-view.vala"
	pw = _tmp5_;
#line 686 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 686 "../src/page-view.vala"
	_tmp7_ = page_get_height (_tmp6_);
#line 686 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 686 "../src/page-view.vala"
	ph = _tmp8_;
#line 687 "../src/page-view.vala"
	_tmp9_ = self->priv->_page;
#line 687 "../src/page-view.vala"
	_tmp10_ = page_get_crop_width (_tmp9_);
#line 687 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 687 "../src/page-view.vala"
	cw = _tmp11_;
#line 688 "../src/page-view.vala"
	_tmp12_ = self->priv->_page;
#line 688 "../src/page-view.vala"
	_tmp13_ = page_get_crop_height (_tmp12_);
#line 688 "../src/page-view.vala"
	_tmp14_ = _tmp13_;
#line 688 "../src/page-view.vala"
	ch = _tmp14_;
#line 690 "../src/page-view.vala"
	_tmp15_ = self->priv->selected_crop_px;
#line 690 "../src/page-view.vala"
	dx = page_view_screen_to_page_x (self, x - ((gint) _tmp15_));
#line 691 "../src/page-view.vala"
	_tmp16_ = self->priv->selected_crop_py;
#line 691 "../src/page-view.vala"
	dy = page_view_screen_to_page_y (self, y - ((gint) _tmp16_));
#line 693 "../src/page-view.vala"
	_tmp17_ = self->priv->selected_crop_x;
#line 693 "../src/page-view.vala"
	new_x = _tmp17_;
#line 694 "../src/page-view.vala"
	_tmp18_ = self->priv->selected_crop_y;
#line 694 "../src/page-view.vala"
	new_y = _tmp18_;
#line 695 "../src/page-view.vala"
	_tmp19_ = self->priv->selected_crop_w;
#line 695 "../src/page-view.vala"
	new_w = _tmp19_;
#line 696 "../src/page-view.vala"
	_tmp20_ = self->priv->selected_crop_h;
#line 696 "../src/page-view.vala"
	new_h = _tmp20_;
#line 699 "../src/page-view.vala"
	min_size = page_view_screen_to_page_x (self, 15);
#line 700 "../src/page-view.vala"
	_tmp23_ = self->priv->crop_location;
#line 700 "../src/page-view.vala"
	if (_tmp23_ == CROP_LOCATION_TOP_LEFT) {
#line 700 "../src/page-view.vala"
		_tmp22_ = TRUE;
#line 3709 "page-view.c"
	} else {
		CropLocation _tmp24_;
#line 701 "../src/page-view.vala"
		_tmp24_ = self->priv->crop_location;
#line 701 "../src/page-view.vala"
		_tmp22_ = _tmp24_ == CROP_LOCATION_LEFT;
#line 3716 "page-view.c"
	}
#line 700 "../src/page-view.vala"
	if (_tmp22_) {
#line 700 "../src/page-view.vala"
		_tmp21_ = TRUE;
#line 3722 "page-view.c"
	} else {
		CropLocation _tmp25_;
#line 702 "../src/page-view.vala"
		_tmp25_ = self->priv->crop_location;
#line 702 "../src/page-view.vala"
		_tmp21_ = _tmp25_ == CROP_LOCATION_BOTTOM_LEFT;
#line 3729 "page-view.c"
	}
#line 700 "../src/page-view.vala"
	if (_tmp21_) {
#line 3733 "page-view.c"
		gint _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		gint _tmp31_;
		gint _tmp32_;
#line 704 "../src/page-view.vala"
		_tmp26_ = dx;
#line 704 "../src/page-view.vala"
		_tmp27_ = new_w;
#line 704 "../src/page-view.vala"
		_tmp28_ = min_size;
#line 704 "../src/page-view.vala"
		if (_tmp26_ > (_tmp27_ - _tmp28_)) {
#line 3747 "page-view.c"
			gint _tmp29_;
			gint _tmp30_;
#line 705 "../src/page-view.vala"
			_tmp29_ = new_w;
#line 705 "../src/page-view.vala"
			_tmp30_ = min_size;
#line 705 "../src/page-view.vala"
			dx = _tmp29_ - _tmp30_;
#line 3756 "page-view.c"
		}
#line 706 "../src/page-view.vala"
		_tmp31_ = new_x;
#line 706 "../src/page-view.vala"
		_tmp32_ = dx;
#line 706 "../src/page-view.vala"
		if ((_tmp31_ + _tmp32_) < 0) {
#line 3764 "page-view.c"
			gint _tmp33_;
#line 707 "../src/page-view.vala"
			_tmp33_ = new_x;
#line 707 "../src/page-view.vala"
			dx = -_tmp33_;
#line 3770 "page-view.c"
		}
	}
#line 709 "../src/page-view.vala"
	_tmp36_ = self->priv->crop_location;
#line 709 "../src/page-view.vala"
	if (_tmp36_ == CROP_LOCATION_TOP_LEFT) {
#line 709 "../src/page-view.vala"
		_tmp35_ = TRUE;
#line 3779 "page-view.c"
	} else {
		CropLocation _tmp37_;
#line 710 "../src/page-view.vala"
		_tmp37_ = self->priv->crop_location;
#line 710 "../src/page-view.vala"
		_tmp35_ = _tmp37_ == CROP_LOCATION_TOP;
#line 3786 "page-view.c"
	}
#line 709 "../src/page-view.vala"
	if (_tmp35_) {
#line 709 "../src/page-view.vala"
		_tmp34_ = TRUE;
#line 3792 "page-view.c"
	} else {
		CropLocation _tmp38_;
#line 711 "../src/page-view.vala"
		_tmp38_ = self->priv->crop_location;
#line 711 "../src/page-view.vala"
		_tmp34_ = _tmp38_ == CROP_LOCATION_TOP_RIGHT;
#line 3799 "page-view.c"
	}
#line 709 "../src/page-view.vala"
	if (_tmp34_) {
#line 3803 "page-view.c"
		gint _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
		gint _tmp44_;
		gint _tmp45_;
#line 713 "../src/page-view.vala"
		_tmp39_ = dy;
#line 713 "../src/page-view.vala"
		_tmp40_ = new_h;
#line 713 "../src/page-view.vala"
		_tmp41_ = min_size;
#line 713 "../src/page-view.vala"
		if (_tmp39_ > (_tmp40_ - _tmp41_)) {
#line 3817 "page-view.c"
			gint _tmp42_;
			gint _tmp43_;
#line 714 "../src/page-view.vala"
			_tmp42_ = new_h;
#line 714 "../src/page-view.vala"
			_tmp43_ = min_size;
#line 714 "../src/page-view.vala"
			dy = _tmp42_ - _tmp43_;
#line 3826 "page-view.c"
		}
#line 715 "../src/page-view.vala"
		_tmp44_ = new_y;
#line 715 "../src/page-view.vala"
		_tmp45_ = dy;
#line 715 "../src/page-view.vala"
		if ((_tmp44_ + _tmp45_) < 0) {
#line 3834 "page-view.c"
			gint _tmp46_;
#line 716 "../src/page-view.vala"
			_tmp46_ = new_y;
#line 716 "../src/page-view.vala"
			dy = -_tmp46_;
#line 3840 "page-view.c"
		}
	}
#line 719 "../src/page-view.vala"
	_tmp49_ = self->priv->crop_location;
#line 719 "../src/page-view.vala"
	if (_tmp49_ == CROP_LOCATION_TOP_RIGHT) {
#line 719 "../src/page-view.vala"
		_tmp48_ = TRUE;
#line 3849 "page-view.c"
	} else {
		CropLocation _tmp50_;
#line 720 "../src/page-view.vala"
		_tmp50_ = self->priv->crop_location;
#line 720 "../src/page-view.vala"
		_tmp48_ = _tmp50_ == CROP_LOCATION_RIGHT;
#line 3856 "page-view.c"
	}
#line 719 "../src/page-view.vala"
	if (_tmp48_) {
#line 719 "../src/page-view.vala"
		_tmp47_ = TRUE;
#line 3862 "page-view.c"
	} else {
		CropLocation _tmp51_;
#line 721 "../src/page-view.vala"
		_tmp51_ = self->priv->crop_location;
#line 721 "../src/page-view.vala"
		_tmp47_ = _tmp51_ == CROP_LOCATION_BOTTOM_RIGHT;
#line 3869 "page-view.c"
	}
#line 719 "../src/page-view.vala"
	if (_tmp47_) {
#line 3873 "page-view.c"
		gint _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		gint _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
#line 723 "../src/page-view.vala"
		_tmp52_ = dx;
#line 723 "../src/page-view.vala"
		_tmp53_ = min_size;
#line 723 "../src/page-view.vala"
		_tmp54_ = new_w;
#line 723 "../src/page-view.vala"
		if (_tmp52_ < (_tmp53_ - _tmp54_)) {
#line 3889 "page-view.c"
			gint _tmp55_;
			gint _tmp56_;
#line 724 "../src/page-view.vala"
			_tmp55_ = min_size;
#line 724 "../src/page-view.vala"
			_tmp56_ = new_w;
#line 724 "../src/page-view.vala"
			dx = _tmp55_ - _tmp56_;
#line 3898 "page-view.c"
		}
#line 725 "../src/page-view.vala"
		_tmp57_ = new_x;
#line 725 "../src/page-view.vala"
		_tmp58_ = new_w;
#line 725 "../src/page-view.vala"
		_tmp59_ = dx;
#line 725 "../src/page-view.vala"
		_tmp60_ = pw;
#line 725 "../src/page-view.vala"
		if (((_tmp57_ + _tmp58_) + _tmp59_) > _tmp60_) {
#line 3910 "page-view.c"
			gint _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
#line 726 "../src/page-view.vala"
			_tmp61_ = pw;
#line 726 "../src/page-view.vala"
			_tmp62_ = new_x;
#line 726 "../src/page-view.vala"
			_tmp63_ = new_w;
#line 726 "../src/page-view.vala"
			dx = (_tmp61_ - _tmp62_) - _tmp63_;
#line 3922 "page-view.c"
		}
	}
#line 728 "../src/page-view.vala"
	_tmp66_ = self->priv->crop_location;
#line 728 "../src/page-view.vala"
	if (_tmp66_ == CROP_LOCATION_BOTTOM_LEFT) {
#line 728 "../src/page-view.vala"
		_tmp65_ = TRUE;
#line 3931 "page-view.c"
	} else {
		CropLocation _tmp67_;
#line 729 "../src/page-view.vala"
		_tmp67_ = self->priv->crop_location;
#line 729 "../src/page-view.vala"
		_tmp65_ = _tmp67_ == CROP_LOCATION_BOTTOM;
#line 3938 "page-view.c"
	}
#line 728 "../src/page-view.vala"
	if (_tmp65_) {
#line 728 "../src/page-view.vala"
		_tmp64_ = TRUE;
#line 3944 "page-view.c"
	} else {
		CropLocation _tmp68_;
#line 730 "../src/page-view.vala"
		_tmp68_ = self->priv->crop_location;
#line 730 "../src/page-view.vala"
		_tmp64_ = _tmp68_ == CROP_LOCATION_BOTTOM_RIGHT;
#line 3951 "page-view.c"
	}
#line 728 "../src/page-view.vala"
	if (_tmp64_) {
#line 3955 "page-view.c"
		gint _tmp69_;
		gint _tmp70_;
		gint _tmp71_;
		gint _tmp74_;
		gint _tmp75_;
		gint _tmp76_;
		gint _tmp77_;
#line 732 "../src/page-view.vala"
		_tmp69_ = dy;
#line 732 "../src/page-view.vala"
		_tmp70_ = min_size;
#line 732 "../src/page-view.vala"
		_tmp71_ = new_h;
#line 732 "../src/page-view.vala"
		if (_tmp69_ < (_tmp70_ - _tmp71_)) {
#line 3971 "page-view.c"
			gint _tmp72_;
			gint _tmp73_;
#line 733 "../src/page-view.vala"
			_tmp72_ = min_size;
#line 733 "../src/page-view.vala"
			_tmp73_ = new_h;
#line 733 "../src/page-view.vala"
			dy = _tmp72_ - _tmp73_;
#line 3980 "page-view.c"
		}
#line 734 "../src/page-view.vala"
		_tmp74_ = new_y;
#line 734 "../src/page-view.vala"
		_tmp75_ = new_h;
#line 734 "../src/page-view.vala"
		_tmp76_ = dy;
#line 734 "../src/page-view.vala"
		_tmp77_ = ph;
#line 734 "../src/page-view.vala"
		if (((_tmp74_ + _tmp75_) + _tmp76_) > _tmp77_) {
#line 3992 "page-view.c"
			gint _tmp78_;
			gint _tmp79_;
			gint _tmp80_;
#line 735 "../src/page-view.vala"
			_tmp78_ = ph;
#line 735 "../src/page-view.vala"
			_tmp79_ = new_y;
#line 735 "../src/page-view.vala"
			_tmp80_ = new_h;
#line 735 "../src/page-view.vala"
			dy = (_tmp78_ - _tmp79_) - _tmp80_;
#line 4004 "page-view.c"
		}
	}
#line 737 "../src/page-view.vala"
	_tmp81_ = self->priv->crop_location;
#line 737 "../src/page-view.vala"
	if (_tmp81_ == CROP_LOCATION_MIDDLE) {
#line 4011 "page-view.c"
		gint _tmp82_;
		gint _tmp83_;
		gint _tmp84_;
		gint _tmp85_;
		gint _tmp89_;
		gint _tmp90_;
		gint _tmp92_;
		gint _tmp93_;
		gint _tmp94_;
		gint _tmp95_;
		gint _tmp99_;
		gint _tmp100_;
#line 739 "../src/page-view.vala"
		_tmp82_ = new_x;
#line 739 "../src/page-view.vala"
		_tmp83_ = dx;
#line 739 "../src/page-view.vala"
		_tmp84_ = new_w;
#line 739 "../src/page-view.vala"
		_tmp85_ = pw;
#line 739 "../src/page-view.vala"
		if (((_tmp82_ + _tmp83_) + _tmp84_) > _tmp85_) {
#line 4034 "page-view.c"
			gint _tmp86_;
			gint _tmp87_;
			gint _tmp88_;
#line 740 "../src/page-view.vala"
			_tmp86_ = pw;
#line 740 "../src/page-view.vala"
			_tmp87_ = new_x;
#line 740 "../src/page-view.vala"
			_tmp88_ = new_w;
#line 740 "../src/page-view.vala"
			dx = (_tmp86_ - _tmp87_) - _tmp88_;
#line 4046 "page-view.c"
		}
#line 741 "../src/page-view.vala"
		_tmp89_ = new_x;
#line 741 "../src/page-view.vala"
		_tmp90_ = dx;
#line 741 "../src/page-view.vala"
		if ((_tmp89_ + _tmp90_) < 0) {
#line 4054 "page-view.c"
			gint _tmp91_;
#line 742 "../src/page-view.vala"
			_tmp91_ = new_x;
#line 742 "../src/page-view.vala"
			dx = -_tmp91_;
#line 4060 "page-view.c"
		}
#line 743 "../src/page-view.vala"
		_tmp92_ = new_y;
#line 743 "../src/page-view.vala"
		_tmp93_ = dy;
#line 743 "../src/page-view.vala"
		_tmp94_ = new_h;
#line 743 "../src/page-view.vala"
		_tmp95_ = ph;
#line 743 "../src/page-view.vala"
		if (((_tmp92_ + _tmp93_) + _tmp94_) > _tmp95_) {
#line 4072 "page-view.c"
			gint _tmp96_;
			gint _tmp97_;
			gint _tmp98_;
#line 744 "../src/page-view.vala"
			_tmp96_ = ph;
#line 744 "../src/page-view.vala"
			_tmp97_ = new_y;
#line 744 "../src/page-view.vala"
			_tmp98_ = new_h;
#line 744 "../src/page-view.vala"
			dy = (_tmp96_ - _tmp97_) - _tmp98_;
#line 4084 "page-view.c"
		}
#line 745 "../src/page-view.vala"
		_tmp99_ = new_y;
#line 745 "../src/page-view.vala"
		_tmp100_ = dy;
#line 745 "../src/page-view.vala"
		if ((_tmp99_ + _tmp100_) < 0) {
#line 4092 "page-view.c"
			gint _tmp101_;
#line 746 "../src/page-view.vala"
			_tmp101_ = new_y;
#line 746 "../src/page-view.vala"
			dy = -_tmp101_;
#line 4098 "page-view.c"
		}
	}
#line 750 "../src/page-view.vala"
	_tmp102_ = self->priv->crop_location;
#line 750 "../src/page-view.vala"
	if (_tmp102_ == CROP_LOCATION_MIDDLE) {
#line 4105 "page-view.c"
		gint _tmp103_;
		gint _tmp104_;
		gint _tmp105_;
		gint _tmp106_;
#line 752 "../src/page-view.vala"
		_tmp103_ = new_x;
#line 752 "../src/page-view.vala"
		_tmp104_ = dx;
#line 752 "../src/page-view.vala"
		new_x = _tmp103_ + _tmp104_;
#line 753 "../src/page-view.vala"
		_tmp105_ = new_y;
#line 753 "../src/page-view.vala"
		_tmp106_ = dy;
#line 753 "../src/page-view.vala"
		new_y = _tmp105_ + _tmp106_;
#line 4122 "page-view.c"
	}
#line 755 "../src/page-view.vala"
	_tmp109_ = self->priv->crop_location;
#line 755 "../src/page-view.vala"
	if (_tmp109_ == CROP_LOCATION_TOP_LEFT) {
#line 755 "../src/page-view.vala"
		_tmp108_ = TRUE;
#line 4130 "page-view.c"
	} else {
		CropLocation _tmp110_;
#line 756 "../src/page-view.vala"
		_tmp110_ = self->priv->crop_location;
#line 756 "../src/page-view.vala"
		_tmp108_ = _tmp110_ == CROP_LOCATION_LEFT;
#line 4137 "page-view.c"
	}
#line 755 "../src/page-view.vala"
	if (_tmp108_) {
#line 755 "../src/page-view.vala"
		_tmp107_ = TRUE;
#line 4143 "page-view.c"
	} else {
		CropLocation _tmp111_;
#line 757 "../src/page-view.vala"
		_tmp111_ = self->priv->crop_location;
#line 757 "../src/page-view.vala"
		_tmp107_ = _tmp111_ == CROP_LOCATION_BOTTOM_LEFT;
#line 4150 "page-view.c"
	}
#line 755 "../src/page-view.vala"
	if (_tmp107_) {
#line 4154 "page-view.c"
		gint _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		gint _tmp115_;
#line 759 "../src/page-view.vala"
		_tmp112_ = new_x;
#line 759 "../src/page-view.vala"
		_tmp113_ = dx;
#line 759 "../src/page-view.vala"
		new_x = _tmp112_ + _tmp113_;
#line 760 "../src/page-view.vala"
		_tmp114_ = new_w;
#line 760 "../src/page-view.vala"
		_tmp115_ = dx;
#line 760 "../src/page-view.vala"
		new_w = _tmp114_ - _tmp115_;
#line 4171 "page-view.c"
	}
#line 762 "../src/page-view.vala"
	_tmp118_ = self->priv->crop_location;
#line 762 "../src/page-view.vala"
	if (_tmp118_ == CROP_LOCATION_TOP_LEFT) {
#line 762 "../src/page-view.vala"
		_tmp117_ = TRUE;
#line 4179 "page-view.c"
	} else {
		CropLocation _tmp119_;
#line 763 "../src/page-view.vala"
		_tmp119_ = self->priv->crop_location;
#line 763 "../src/page-view.vala"
		_tmp117_ = _tmp119_ == CROP_LOCATION_TOP;
#line 4186 "page-view.c"
	}
#line 762 "../src/page-view.vala"
	if (_tmp117_) {
#line 762 "../src/page-view.vala"
		_tmp116_ = TRUE;
#line 4192 "page-view.c"
	} else {
		CropLocation _tmp120_;
#line 764 "../src/page-view.vala"
		_tmp120_ = self->priv->crop_location;
#line 764 "../src/page-view.vala"
		_tmp116_ = _tmp120_ == CROP_LOCATION_TOP_RIGHT;
#line 4199 "page-view.c"
	}
#line 762 "../src/page-view.vala"
	if (_tmp116_) {
#line 4203 "page-view.c"
		gint _tmp121_;
		gint _tmp122_;
		gint _tmp123_;
		gint _tmp124_;
#line 766 "../src/page-view.vala"
		_tmp121_ = new_y;
#line 766 "../src/page-view.vala"
		_tmp122_ = dy;
#line 766 "../src/page-view.vala"
		new_y = _tmp121_ + _tmp122_;
#line 767 "../src/page-view.vala"
		_tmp123_ = new_h;
#line 767 "../src/page-view.vala"
		_tmp124_ = dy;
#line 767 "../src/page-view.vala"
		new_h = _tmp123_ - _tmp124_;
#line 4220 "page-view.c"
	}
#line 770 "../src/page-view.vala"
	_tmp127_ = self->priv->crop_location;
#line 770 "../src/page-view.vala"
	if (_tmp127_ == CROP_LOCATION_TOP_RIGHT) {
#line 770 "../src/page-view.vala"
		_tmp126_ = TRUE;
#line 4228 "page-view.c"
	} else {
		CropLocation _tmp128_;
#line 771 "../src/page-view.vala"
		_tmp128_ = self->priv->crop_location;
#line 771 "../src/page-view.vala"
		_tmp126_ = _tmp128_ == CROP_LOCATION_RIGHT;
#line 4235 "page-view.c"
	}
#line 770 "../src/page-view.vala"
	if (_tmp126_) {
#line 770 "../src/page-view.vala"
		_tmp125_ = TRUE;
#line 4241 "page-view.c"
	} else {
		CropLocation _tmp129_;
#line 772 "../src/page-view.vala"
		_tmp129_ = self->priv->crop_location;
#line 772 "../src/page-view.vala"
		_tmp125_ = _tmp129_ == CROP_LOCATION_BOTTOM_RIGHT;
#line 4248 "page-view.c"
	}
#line 770 "../src/page-view.vala"
	if (_tmp125_) {
#line 4252 "page-view.c"
		gint _tmp130_;
		gint _tmp131_;
#line 773 "../src/page-view.vala"
		_tmp130_ = new_w;
#line 773 "../src/page-view.vala"
		_tmp131_ = dx;
#line 773 "../src/page-view.vala"
		new_w = _tmp130_ + _tmp131_;
#line 4261 "page-view.c"
	}
#line 774 "../src/page-view.vala"
	_tmp134_ = self->priv->crop_location;
#line 774 "../src/page-view.vala"
	if (_tmp134_ == CROP_LOCATION_BOTTOM_LEFT) {
#line 774 "../src/page-view.vala"
		_tmp133_ = TRUE;
#line 4269 "page-view.c"
	} else {
		CropLocation _tmp135_;
#line 775 "../src/page-view.vala"
		_tmp135_ = self->priv->crop_location;
#line 775 "../src/page-view.vala"
		_tmp133_ = _tmp135_ == CROP_LOCATION_BOTTOM;
#line 4276 "page-view.c"
	}
#line 774 "../src/page-view.vala"
	if (_tmp133_) {
#line 774 "../src/page-view.vala"
		_tmp132_ = TRUE;
#line 4282 "page-view.c"
	} else {
		CropLocation _tmp136_;
#line 776 "../src/page-view.vala"
		_tmp136_ = self->priv->crop_location;
#line 776 "../src/page-view.vala"
		_tmp132_ = _tmp136_ == CROP_LOCATION_BOTTOM_RIGHT;
#line 4289 "page-view.c"
	}
#line 774 "../src/page-view.vala"
	if (_tmp132_) {
#line 4293 "page-view.c"
		gint _tmp137_;
		gint _tmp138_;
#line 777 "../src/page-view.vala"
		_tmp137_ = new_h;
#line 777 "../src/page-view.vala"
		_tmp138_ = dy;
#line 777 "../src/page-view.vala"
		new_h = _tmp137_ + _tmp138_;
#line 4302 "page-view.c"
	}
#line 779 "../src/page-view.vala"
	_tmp139_ = self->priv->_page;
#line 779 "../src/page-view.vala"
	_tmp140_ = new_x;
#line 779 "../src/page-view.vala"
	_tmp141_ = new_y;
#line 779 "../src/page-view.vala"
	page_move_crop (_tmp139_, _tmp140_, _tmp141_);
#line 782 "../src/page-view.vala"
	_tmp143_ = new_w;
#line 782 "../src/page-view.vala"
	_tmp144_ = cw;
#line 782 "../src/page-view.vala"
	if (_tmp143_ != _tmp144_) {
#line 782 "../src/page-view.vala"
		_tmp142_ = TRUE;
#line 4320 "page-view.c"
	} else {
		gint _tmp145_;
		gint _tmp146_;
#line 782 "../src/page-view.vala"
		_tmp145_ = new_h;
#line 782 "../src/page-view.vala"
		_tmp146_ = ch;
#line 782 "../src/page-view.vala"
		_tmp142_ = _tmp145_ != _tmp146_;
#line 4330 "page-view.c"
	}
#line 782 "../src/page-view.vala"
	if (_tmp142_) {
#line 4334 "page-view.c"
		Page* _tmp147_;
		gint _tmp148_;
		gint _tmp149_;
#line 783 "../src/page-view.vala"
		_tmp147_ = self->priv->_page;
#line 783 "../src/page-view.vala"
		_tmp148_ = new_w;
#line 783 "../src/page-view.vala"
		_tmp149_ = new_h;
#line 783 "../src/page-view.vala"
		page_set_custom_crop (_tmp147_, _tmp148_, _tmp149_);
#line 4346 "page-view.c"
	}
}


void
page_view_button_release (PageView* self,
                          gint x,
                          gint y)
{
#line 786 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 789 "../src/page-view.vala"
	self->priv->crop_location = CROP_LOCATION_NONE;
#line 790 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 4362 "page-view.c"
}


static gboolean
page_view_animation_cb (PageView* self)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
#line 793 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 795 "../src/page-view.vala"
	_tmp0_ = self->priv->animate_segment;
#line 795 "../src/page-view.vala"
	_tmp1_ = self->priv->animate_n_segments;
#line 795 "../src/page-view.vala"
	self->priv->animate_segment = (_tmp0_ + 1) % _tmp1_;
#line 796 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 797 "../src/page-view.vala"
	result = TRUE;
#line 797 "../src/page-view.vala"
	return result;
#line 4386 "page-view.c"
}


static gboolean
_page_view_animation_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = page_view_animation_cb ((PageView*) self);
#line 813 "../src/page-view.vala"
	return result;
#line 4397 "page-view.c"
}


static void
page_view_update_animation (PageView* self)
{
	gboolean animate = FALSE;
	gboolean is_animating = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	guint _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 800 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 804 "../src/page-view.vala"
	_tmp1_ = self->priv->_page;
#line 804 "../src/page-view.vala"
	_tmp2_ = page_get_is_scanning (_tmp1_);
#line 804 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 804 "../src/page-view.vala"
	if (_tmp3_) {
#line 4424 "page-view.c"
		Page* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 804 "../src/page-view.vala"
		_tmp4_ = self->priv->_page;
#line 804 "../src/page-view.vala"
		_tmp5_ = page_get_has_data (_tmp4_);
#line 804 "../src/page-view.vala"
		_tmp6_ = _tmp5_;
#line 804 "../src/page-view.vala"
		_tmp0_ = !_tmp6_;
#line 4436 "page-view.c"
	} else {
#line 804 "../src/page-view.vala"
		_tmp0_ = FALSE;
#line 4440 "page-view.c"
	}
#line 804 "../src/page-view.vala"
	animate = _tmp0_;
#line 805 "../src/page-view.vala"
	_tmp7_ = self->priv->animate_timeout;
#line 805 "../src/page-view.vala"
	is_animating = _tmp7_ != ((guint) 0);
#line 806 "../src/page-view.vala"
	_tmp8_ = animate;
#line 806 "../src/page-view.vala"
	_tmp9_ = is_animating;
#line 806 "../src/page-view.vala"
	if (_tmp8_ == _tmp9_) {
#line 807 "../src/page-view.vala"
		return;
#line 4456 "page-view.c"
	}
#line 809 "../src/page-view.vala"
	_tmp10_ = animate;
#line 809 "../src/page-view.vala"
	if (_tmp10_) {
#line 4462 "page-view.c"
		guint _tmp11_;
#line 811 "../src/page-view.vala"
		self->priv->animate_segment = 0;
#line 812 "../src/page-view.vala"
		_tmp11_ = self->priv->animate_timeout;
#line 812 "../src/page-view.vala"
		if (_tmp11_ == ((guint) 0)) {
#line 813 "../src/page-view.vala"
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, _page_view_animation_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 4472 "page-view.c"
		}
	} else {
		guint _tmp12_;
#line 817 "../src/page-view.vala"
		_tmp12_ = self->priv->animate_timeout;
#line 817 "../src/page-view.vala"
		if (_tmp12_ != ((guint) 0)) {
#line 4480 "page-view.c"
			guint _tmp13_;
#line 818 "../src/page-view.vala"
			_tmp13_ = self->priv->animate_timeout;
#line 818 "../src/page-view.vala"
			g_source_remove (_tmp13_);
#line 4486 "page-view.c"
		}
#line 819 "../src/page-view.vala"
		self->priv->animate_timeout = (guint) 0;
#line 4490 "page-view.c"
	}
}


void
page_view_render (PageView* self,
                  cairo_t* context)
{
	gint w = 0;
	gint h = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GdkPixbuf* _tmp11_;
	gboolean _tmp12_ = FALSE;
	Page* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp49_ = FALSE;
	Page* _tmp50_;
	gboolean _tmp51_;
	gboolean _tmp52_;
	Page* _tmp89_;
	gboolean _tmp90_;
	gboolean _tmp91_;
#line 823 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 823 "../src/page-view.vala"
	g_return_if_fail (context != NULL);
#line 825 "../src/page-view.vala"
	page_view_update_animation (self);
#line 826 "../src/page-view.vala"
	page_view_update_page_view (self);
#line 828 "../src/page-view.vala"
	w = page_view_get_preview_width (self);
#line 829 "../src/page-view.vala"
	h = page_view_get_preview_height (self);
#line 831 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) 1);
#line 832 "../src/page-view.vala"
	_tmp0_ = self->priv->_x_offset;
#line 832 "../src/page-view.vala"
	_tmp1_ = self->priv->_y_offset;
#line 832 "../src/page-view.vala"
	cairo_translate (context, (gdouble) _tmp0_, (gdouble) _tmp1_);
#line 835 "../src/page-view.vala"
	cairo_set_source_rgb (context, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 836 "../src/page-view.vala"
	_tmp2_ = self->priv->border_width;
#line 836 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) _tmp2_);
#line 837 "../src/page-view.vala"
	_tmp3_ = self->priv->border_width;
#line 837 "../src/page-view.vala"
	_tmp4_ = self->priv->border_width;
#line 837 "../src/page-view.vala"
	_tmp5_ = self->priv->width_;
#line 837 "../src/page-view.vala"
	_tmp6_ = self->priv->border_width;
#line 837 "../src/page-view.vala"
	_tmp7_ = self->priv->height_;
#line 837 "../src/page-view.vala"
	_tmp8_ = self->priv->border_width;
#line 837 "../src/page-view.vala"
	cairo_rectangle (context, ((gdouble) _tmp3_) / 2, ((gdouble) _tmp4_) / 2, (gdouble) (_tmp5_ - _tmp6_), (gdouble) (_tmp7_ - _tmp8_));
#line 841 "../src/page-view.vala"
	cairo_stroke (context);
#line 844 "../src/page-view.vala"
	_tmp9_ = self->priv->border_width;
#line 844 "../src/page-view.vala"
	_tmp10_ = self->priv->border_width;
#line 844 "../src/page-view.vala"
	cairo_translate (context, (gdouble) _tmp9_, (gdouble) _tmp10_);
#line 845 "../src/page-view.vala"
	_tmp11_ = self->priv->image;
#line 845 "../src/page-view.vala"
	gdk_cairo_set_source_pixbuf (context, _tmp11_, (gdouble) 0, (gdouble) 0);
#line 846 "../src/page-view.vala"
	cairo_paint (context);
#line 849 "../src/page-view.vala"
	_tmp13_ = self->priv->_page;
#line 849 "../src/page-view.vala"
	_tmp14_ = page_get_is_scanning (_tmp13_);
#line 849 "../src/page-view.vala"
	_tmp15_ = _tmp14_;
#line 849 "../src/page-view.vala"
	if (_tmp15_) {
#line 4586 "page-view.c"
		Page* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 849 "../src/page-view.vala"
		_tmp16_ = self->priv->_page;
#line 849 "../src/page-view.vala"
		_tmp17_ = page_get_has_data (_tmp16_);
#line 849 "../src/page-view.vala"
		_tmp18_ = _tmp17_;
#line 849 "../src/page-view.vala"
		_tmp12_ = !_tmp18_;
#line 4598 "page-view.c"
	} else {
#line 849 "../src/page-view.vala"
		_tmp12_ = FALSE;
#line 4602 "page-view.c"
	}
#line 849 "../src/page-view.vala"
	if (_tmp12_) {
#line 4606 "page-view.c"
		gdouble outer_radius = 0.0;
		gint _tmp19_;
		gint _tmp20_;
		gdouble arc = 0.0;
		gint _tmp23_;
		gdouble x = 0.0;
		gdouble _tmp24_;
		gdouble _tmp25_;
		gdouble y = 0.0;
		gdouble _tmp26_;
		gdouble _tmp27_;
		gdouble inner_radius = 0.0;
		gdouble _tmp28_;
		gdouble _tmp29_;
		gdouble _tmp30_;
		gdouble _tmp31_;
		gdouble offset = 0.0;
#line 852 "../src/page-view.vala"
		_tmp19_ = w;
#line 852 "../src/page-view.vala"
		_tmp20_ = h;
#line 852 "../src/page-view.vala"
		if (_tmp19_ > _tmp20_) {
#line 4630 "page-view.c"
			gint _tmp21_;
#line 853 "../src/page-view.vala"
			_tmp21_ = w;
#line 853 "../src/page-view.vala"
			outer_radius = 0.15 * _tmp21_;
#line 4636 "page-view.c"
		} else {
			gint _tmp22_;
#line 855 "../src/page-view.vala"
			_tmp22_ = h;
#line 855 "../src/page-view.vala"
			outer_radius = 0.15 * _tmp22_;
#line 4643 "page-view.c"
		}
#line 856 "../src/page-view.vala"
		_tmp23_ = self->priv->animate_n_segments;
#line 856 "../src/page-view.vala"
		arc = G_PI / _tmp23_;
#line 859 "../src/page-view.vala"
		_tmp24_ = outer_radius;
#line 859 "../src/page-view.vala"
		_tmp25_ = arc;
#line 859 "../src/page-view.vala"
		x = _tmp24_ * sin (_tmp25_);
#line 860 "../src/page-view.vala"
		_tmp26_ = outer_radius;
#line 860 "../src/page-view.vala"
		_tmp27_ = arc;
#line 860 "../src/page-view.vala"
		y = _tmp26_ * (cos (_tmp27_) - 1.0);
#line 861 "../src/page-view.vala"
		_tmp28_ = x;
#line 861 "../src/page-view.vala"
		_tmp29_ = x;
#line 861 "../src/page-view.vala"
		_tmp30_ = y;
#line 861 "../src/page-view.vala"
		_tmp31_ = y;
#line 861 "../src/page-view.vala"
		inner_radius = 0.6 * sqrt ((_tmp28_ * _tmp29_) + (_tmp30_ * _tmp31_));
#line 863 "../src/page-view.vala"
		offset = 0.0;
#line 4673 "page-view.c"
		{
			gint i = 0;
#line 864 "../src/page-view.vala"
			i = 0;
#line 4678 "page-view.c"
			{
				gboolean _tmp32_ = FALSE;
#line 864 "../src/page-view.vala"
				_tmp32_ = TRUE;
#line 864 "../src/page-view.vala"
				while (TRUE) {
#line 4685 "page-view.c"
					gint _tmp36_;
					gint _tmp37_;
					gint _tmp38_;
					gdouble _tmp39_;
					gdouble _tmp40_;
					gint _tmp41_;
					gdouble _tmp42_;
					gdouble _tmp43_;
					gdouble _tmp44_;
					gdouble _tmp45_;
					gdouble _tmp46_;
					gint _tmp47_;
					gint _tmp48_;
#line 864 "../src/page-view.vala"
					if (!_tmp32_) {
#line 4701 "page-view.c"
						gint _tmp33_;
						gdouble _tmp34_;
						gdouble _tmp35_;
#line 864 "../src/page-view.vala"
						_tmp33_ = i;
#line 864 "../src/page-view.vala"
						i = _tmp33_ + 1;
#line 864 "../src/page-view.vala"
						_tmp34_ = offset;
#line 864 "../src/page-view.vala"
						_tmp35_ = arc;
#line 864 "../src/page-view.vala"
						offset = _tmp34_ + (_tmp35_ * 2);
#line 4715 "page-view.c"
					}
#line 864 "../src/page-view.vala"
					_tmp32_ = FALSE;
#line 864 "../src/page-view.vala"
					_tmp36_ = i;
#line 864 "../src/page-view.vala"
					_tmp37_ = self->priv->animate_n_segments;
#line 864 "../src/page-view.vala"
					if (!(_tmp36_ < _tmp37_)) {
#line 864 "../src/page-view.vala"
						break;
#line 4727 "page-view.c"
					}
#line 866 "../src/page-view.vala"
					_tmp38_ = w;
#line 866 "../src/page-view.vala"
					_tmp39_ = outer_radius;
#line 866 "../src/page-view.vala"
					_tmp40_ = offset;
#line 866 "../src/page-view.vala"
					x = (_tmp38_ / 2) + (_tmp39_ * sin (_tmp40_));
#line 867 "../src/page-view.vala"
					_tmp41_ = h;
#line 867 "../src/page-view.vala"
					_tmp42_ = outer_radius;
#line 867 "../src/page-view.vala"
					_tmp43_ = offset;
#line 867 "../src/page-view.vala"
					y = (_tmp41_ / 2) - (_tmp42_ * cos (_tmp43_));
#line 868 "../src/page-view.vala"
					_tmp44_ = x;
#line 868 "../src/page-view.vala"
					_tmp45_ = y;
#line 868 "../src/page-view.vala"
					_tmp46_ = inner_radius;
#line 868 "../src/page-view.vala"
					cairo_arc (context, _tmp44_, _tmp45_, _tmp46_, (gdouble) 0, 2 * G_PI);
#line 870 "../src/page-view.vala"
					_tmp47_ = i;
#line 870 "../src/page-view.vala"
					_tmp48_ = self->priv->animate_segment;
#line 870 "../src/page-view.vala"
					if (_tmp47_ == _tmp48_) {
#line 872 "../src/page-view.vala"
						cairo_set_source_rgb (context, 0.75, 0.75, 0.75);
#line 873 "../src/page-view.vala"
						cairo_fill_preserve (context);
#line 4763 "page-view.c"
					}
#line 876 "../src/page-view.vala"
					cairo_set_source_rgb (context, 0.5, 0.5, 0.5);
#line 877 "../src/page-view.vala"
					cairo_stroke (context);
#line 4769 "page-view.c"
				}
			}
		}
	}
#line 882 "../src/page-view.vala"
	_tmp50_ = self->priv->_page;
#line 882 "../src/page-view.vala"
	_tmp51_ = page_get_is_scanning (_tmp50_);
#line 882 "../src/page-view.vala"
	_tmp52_ = _tmp51_;
#line 882 "../src/page-view.vala"
	if (_tmp52_) {
#line 4782 "page-view.c"
		Page* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
#line 882 "../src/page-view.vala"
		_tmp53_ = self->priv->_page;
#line 882 "../src/page-view.vala"
		_tmp54_ = page_get_scan_line (_tmp53_);
#line 882 "../src/page-view.vala"
		_tmp55_ = _tmp54_;
#line 882 "../src/page-view.vala"
		_tmp49_ = _tmp55_ > 0;
#line 4794 "page-view.c"
	} else {
#line 882 "../src/page-view.vala"
		_tmp49_ = FALSE;
#line 4798 "page-view.c"
	}
#line 882 "../src/page-view.vala"
	if (_tmp49_) {
#line 4802 "page-view.c"
		gint scan_line = 0;
		Page* _tmp56_;
		gint _tmp57_;
		gint _tmp58_;
		gdouble s = 0.0;
		gdouble x1 = 0.0;
		gdouble y1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y2 = 0.0;
		Page* _tmp59_;
		ScanDirection _tmp60_;
		ScanDirection _tmp61_;
		gdouble _tmp85_;
		gdouble _tmp86_;
		gdouble _tmp87_;
		gdouble _tmp88_;
#line 884 "../src/page-view.vala"
		_tmp56_ = self->priv->_page;
#line 884 "../src/page-view.vala"
		_tmp57_ = page_get_scan_line (_tmp56_);
#line 884 "../src/page-view.vala"
		_tmp58_ = _tmp57_;
#line 884 "../src/page-view.vala"
		scan_line = _tmp58_;
#line 888 "../src/page-view.vala"
		_tmp59_ = self->priv->_page;
#line 888 "../src/page-view.vala"
		_tmp60_ = page_get_scan_direction (_tmp59_);
#line 888 "../src/page-view.vala"
		_tmp61_ = _tmp60_;
#line 888 "../src/page-view.vala"
		switch (_tmp61_) {
#line 888 "../src/page-view.vala"
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 4837 "page-view.c"
			{
				gint _tmp62_;
				gdouble _tmp63_;
				gint _tmp64_;
				gdouble _tmp65_;
#line 891 "../src/page-view.vala"
				_tmp62_ = scan_line;
#line 891 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_y (self, _tmp62_);
#line 892 "../src/page-view.vala"
				x1 = (gdouble) 0;
#line 892 "../src/page-view.vala"
				_tmp63_ = s;
#line 892 "../src/page-view.vala"
				y1 = _tmp63_ + 0.5;
#line 893 "../src/page-view.vala"
				_tmp64_ = w;
#line 893 "../src/page-view.vala"
				x2 = (gdouble) _tmp64_;
#line 893 "../src/page-view.vala"
				_tmp65_ = s;
#line 893 "../src/page-view.vala"
				y2 = _tmp65_ + 0.5;
#line 894 "../src/page-view.vala"
				break;
#line 4863 "page-view.c"
			}
#line 888 "../src/page-view.vala"
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 4867 "page-view.c"
			{
				gint _tmp66_;
				gint _tmp67_;
				gdouble _tmp68_;
				gint _tmp69_;
				gint _tmp70_;
				gdouble _tmp71_;
#line 896 "../src/page-view.vala"
				_tmp66_ = scan_line;
#line 896 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_y (self, _tmp66_);
#line 897 "../src/page-view.vala"
				x1 = (gdouble) 0;
#line 897 "../src/page-view.vala"
				_tmp67_ = h;
#line 897 "../src/page-view.vala"
				_tmp68_ = s;
#line 897 "../src/page-view.vala"
				y1 = (_tmp67_ - _tmp68_) + 0.5;
#line 898 "../src/page-view.vala"
				_tmp69_ = w;
#line 898 "../src/page-view.vala"
				x2 = (gdouble) _tmp69_;
#line 898 "../src/page-view.vala"
				_tmp70_ = h;
#line 898 "../src/page-view.vala"
				_tmp71_ = s;
#line 898 "../src/page-view.vala"
				y2 = (_tmp70_ - _tmp71_) + 0.5;
#line 899 "../src/page-view.vala"
				break;
#line 4899 "page-view.c"
			}
#line 888 "../src/page-view.vala"
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 4903 "page-view.c"
			{
				gint _tmp72_;
				gdouble _tmp73_;
				gdouble _tmp74_;
				gint _tmp75_;
#line 901 "../src/page-view.vala"
				_tmp72_ = scan_line;
#line 901 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_x (self, _tmp72_);
#line 902 "../src/page-view.vala"
				_tmp73_ = s;
#line 902 "../src/page-view.vala"
				x1 = _tmp73_ + 0.5;
#line 902 "../src/page-view.vala"
				y1 = (gdouble) 0;
#line 903 "../src/page-view.vala"
				_tmp74_ = s;
#line 903 "../src/page-view.vala"
				x2 = _tmp74_ + 0.5;
#line 903 "../src/page-view.vala"
				_tmp75_ = h;
#line 903 "../src/page-view.vala"
				y2 = (gdouble) _tmp75_;
#line 904 "../src/page-view.vala"
				break;
#line 4929 "page-view.c"
			}
#line 888 "../src/page-view.vala"
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 4933 "page-view.c"
			{
				gint _tmp76_;
				gint _tmp77_;
				gdouble _tmp78_;
				gint _tmp79_;
				gdouble _tmp80_;
				gint _tmp81_;
#line 906 "../src/page-view.vala"
				_tmp76_ = scan_line;
#line 906 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_x (self, _tmp76_);
#line 907 "../src/page-view.vala"
				_tmp77_ = w;
#line 907 "../src/page-view.vala"
				_tmp78_ = s;
#line 907 "../src/page-view.vala"
				x1 = (_tmp77_ - _tmp78_) + 0.5;
#line 907 "../src/page-view.vala"
				y1 = (gdouble) 0;
#line 908 "../src/page-view.vala"
				_tmp79_ = w;
#line 908 "../src/page-view.vala"
				_tmp80_ = s;
#line 908 "../src/page-view.vala"
				x2 = (_tmp79_ - _tmp80_) + 0.5;
#line 908 "../src/page-view.vala"
				_tmp81_ = h;
#line 908 "../src/page-view.vala"
				y2 = (gdouble) _tmp81_;
#line 909 "../src/page-view.vala"
				break;
#line 4965 "page-view.c"
			}
			default:
			{
				gdouble _tmp82_;
				gdouble _tmp83_;
				gdouble _tmp84_;
#line 911 "../src/page-view.vala"
				y2 = (gdouble) 0;
#line 911 "../src/page-view.vala"
				_tmp82_ = y2;
#line 911 "../src/page-view.vala"
				x2 = _tmp82_;
#line 911 "../src/page-view.vala"
				_tmp83_ = x2;
#line 911 "../src/page-view.vala"
				y1 = _tmp83_;
#line 911 "../src/page-view.vala"
				_tmp84_ = y1;
#line 911 "../src/page-view.vala"
				x1 = _tmp84_;
#line 912 "../src/page-view.vala"
				break;
#line 4988 "page-view.c"
			}
		}
#line 915 "../src/page-view.vala"
		_tmp85_ = x1;
#line 915 "../src/page-view.vala"
		_tmp86_ = y1;
#line 915 "../src/page-view.vala"
		cairo_move_to (context, _tmp85_, _tmp86_);
#line 916 "../src/page-view.vala"
		_tmp87_ = x2;
#line 916 "../src/page-view.vala"
		_tmp88_ = y2;
#line 916 "../src/page-view.vala"
		cairo_line_to (context, _tmp87_, _tmp88_);
#line 917 "../src/page-view.vala"
		cairo_set_source_rgb (context, 1.0, 0.0, 0.0);
#line 918 "../src/page-view.vala"
		cairo_stroke (context);
#line 5007 "page-view.c"
	}
#line 922 "../src/page-view.vala"
	_tmp89_ = self->priv->_page;
#line 922 "../src/page-view.vala"
	_tmp90_ = page_get_has_crop (_tmp89_);
#line 922 "../src/page-view.vala"
	_tmp91_ = _tmp90_;
#line 922 "../src/page-view.vala"
	if (_tmp91_) {
#line 5017 "page-view.c"
		gint x = 0;
		Page* _tmp92_;
		gint _tmp93_;
		gint _tmp94_;
		gint y = 0;
		Page* _tmp95_;
		gint _tmp96_;
		gint _tmp97_;
		gint crop_width = 0;
		Page* _tmp98_;
		gint _tmp99_;
		gint _tmp100_;
		gint crop_height = 0;
		Page* _tmp101_;
		gint _tmp102_;
		gint _tmp103_;
		gint dx = 0;
		gint _tmp104_;
		gint dy = 0;
		gint _tmp105_;
		gint dw = 0;
		gint _tmp106_;
		gint dh = 0;
		gint _tmp107_;
		gint _tmp108_;
		gint _tmp109_;
		gint _tmp110_;
		gint _tmp111_;
		gint _tmp112_;
		gint _tmp113_;
		gint _tmp114_;
		gint _tmp115_;
		gint _tmp116_;
		gint _tmp117_;
		gint _tmp118_;
		gint _tmp119_;
		gint _tmp120_;
		gint _tmp121_;
#line 924 "../src/page-view.vala"
		_tmp92_ = self->priv->_page;
#line 924 "../src/page-view.vala"
		_tmp93_ = page_get_crop_x (_tmp92_);
#line 924 "../src/page-view.vala"
		_tmp94_ = _tmp93_;
#line 924 "../src/page-view.vala"
		x = _tmp94_;
#line 925 "../src/page-view.vala"
		_tmp95_ = self->priv->_page;
#line 925 "../src/page-view.vala"
		_tmp96_ = page_get_crop_y (_tmp95_);
#line 925 "../src/page-view.vala"
		_tmp97_ = _tmp96_;
#line 925 "../src/page-view.vala"
		y = _tmp97_;
#line 926 "../src/page-view.vala"
		_tmp98_ = self->priv->_page;
#line 926 "../src/page-view.vala"
		_tmp99_ = page_get_crop_width (_tmp98_);
#line 926 "../src/page-view.vala"
		_tmp100_ = _tmp99_;
#line 926 "../src/page-view.vala"
		crop_width = _tmp100_;
#line 927 "../src/page-view.vala"
		_tmp101_ = self->priv->_page;
#line 927 "../src/page-view.vala"
		_tmp102_ = page_get_crop_height (_tmp101_);
#line 927 "../src/page-view.vala"
		_tmp103_ = _tmp102_;
#line 927 "../src/page-view.vala"
		crop_height = _tmp103_;
#line 929 "../src/page-view.vala"
		_tmp104_ = x;
#line 929 "../src/page-view.vala"
		dx = page_view_page_to_screen_x (self, _tmp104_);
#line 930 "../src/page-view.vala"
		_tmp105_ = y;
#line 930 "../src/page-view.vala"
		dy = page_view_page_to_screen_y (self, _tmp105_);
#line 931 "../src/page-view.vala"
		_tmp106_ = crop_width;
#line 931 "../src/page-view.vala"
		dw = page_view_page_to_screen_x (self, _tmp106_);
#line 932 "../src/page-view.vala"
		_tmp107_ = crop_height;
#line 932 "../src/page-view.vala"
		dh = page_view_page_to_screen_y (self, _tmp107_);
#line 935 "../src/page-view.vala"
		_tmp108_ = w;
#line 935 "../src/page-view.vala"
		_tmp109_ = h;
#line 935 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) 0, (gdouble) 0, (gdouble) _tmp108_, (gdouble) _tmp109_);
#line 936 "../src/page-view.vala"
		cairo_new_sub_path (context);
#line 937 "../src/page-view.vala"
		_tmp110_ = dx;
#line 937 "../src/page-view.vala"
		_tmp111_ = dy;
#line 937 "../src/page-view.vala"
		_tmp112_ = dw;
#line 937 "../src/page-view.vala"
		_tmp113_ = dh;
#line 937 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) _tmp110_, (gdouble) _tmp111_, (gdouble) _tmp112_, (gdouble) _tmp113_);
#line 938 "../src/page-view.vala"
		cairo_set_fill_rule (context, CAIRO_FILL_RULE_EVEN_ODD);
#line 939 "../src/page-view.vala"
		cairo_set_source_rgba (context, 0.25, 0.25, 0.25, 0.2);
#line 940 "../src/page-view.vala"
		cairo_fill (context);
#line 943 "../src/page-view.vala"
		_tmp114_ = dx;
#line 943 "../src/page-view.vala"
		_tmp115_ = dy;
#line 943 "../src/page-view.vala"
		_tmp116_ = dw;
#line 943 "../src/page-view.vala"
		_tmp117_ = dh;
#line 943 "../src/page-view.vala"
		cairo_rectangle (context, _tmp114_ - 1.5, _tmp115_ - 1.5, (gdouble) (_tmp116_ + 3), (gdouble) (_tmp117_ + 3));
#line 944 "../src/page-view.vala"
		cairo_set_source_rgb (context, 1.0, 1.0, 1.0);
#line 945 "../src/page-view.vala"
		cairo_stroke (context);
#line 946 "../src/page-view.vala"
		_tmp118_ = dx;
#line 946 "../src/page-view.vala"
		_tmp119_ = dy;
#line 946 "../src/page-view.vala"
		_tmp120_ = dw;
#line 946 "../src/page-view.vala"
		_tmp121_ = dh;
#line 946 "../src/page-view.vala"
		cairo_rectangle (context, _tmp118_ - 0.5, _tmp119_ - 0.5, (gdouble) (_tmp120_ + 1), (gdouble) (_tmp121_ + 1));
#line 947 "../src/page-view.vala"
		cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
#line 948 "../src/page-view.vala"
		cairo_stroke (context);
#line 5156 "page-view.c"
	}
}


static void
page_view_page_pixels_changed_cb (PageView* self,
                                  Page* p)
{
#line 994 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 994 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 997 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 998 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 5173 "page-view.c"
}


static void
page_view_page_size_changed_cb (PageView* self,
                                Page* p)
{
#line 1001 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1001 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1004 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1005 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 1006 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 5191 "page-view.c"
}


static void
page_view_page_overlay_changed_cb (PageView* self,
                                   Page* p)
{
#line 1009 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1009 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1011 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 5205 "page-view.c"
}


static void
page_view_scan_direction_changed_cb (PageView* self,
                                     Page* p)
{
#line 1014 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1014 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1017 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1018 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 1019 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 5223 "page-view.c"
}


Page*
page_view_get_page (PageView* self)
{
	Page* result;
	Page* _tmp0_;
#line 29 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 29 "../src/page-view.vala"
	result = _tmp0_;
#line 29 "../src/page-view.vala"
	return result;
#line 5240 "page-view.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/page-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 5249 "page-view.c"
}


static void
page_view_set_page (PageView* self,
                    Page* value)
{
#line 29 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/page-view.vala"
	if (page_view_get_page (self) != value) {
#line 5261 "page-view.c"
		Page* _tmp0_;
#line 29 "../src/page-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/page-view.vala"
		_g_object_unref0 (self->priv->_page);
#line 29 "../src/page-view.vala"
		self->priv->_page = _tmp0_;
#line 29 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_PAGE_PROPERTY]);
#line 5271 "page-view.c"
	}
}


gboolean
page_view_get_selected (PageView* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 38 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/page-view.vala"
	_tmp0_ = self->priv->selected_;
#line 38 "../src/page-view.vala"
	result = _tmp0_;
#line 38 "../src/page-view.vala"
	return result;
#line 5289 "page-view.c"
}


void
page_view_set_selected (PageView* self,
                        gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 39 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/page-view.vala"
	_tmp2_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/page-view.vala"
	if (_tmp3_) {
#line 5311 "page-view.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 41 "../src/page-view.vala"
		_tmp4_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
		_tmp5_ = _tmp4_;
#line 41 "../src/page-view.vala"
		_tmp1_ = _tmp5_;
#line 5320 "page-view.c"
	} else {
#line 41 "../src/page-view.vala"
		_tmp1_ = FALSE;
#line 5324 "page-view.c"
	}
#line 41 "../src/page-view.vala"
	if (_tmp1_) {
#line 41 "../src/page-view.vala"
		_tmp0_ = TRUE;
#line 5330 "page-view.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 41 "../src/page-view.vala"
		_tmp7_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
		_tmp8_ = _tmp7_;
#line 41 "../src/page-view.vala"
		if (!_tmp8_) {
#line 5341 "page-view.c"
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 41 "../src/page-view.vala"
			_tmp9_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
			_tmp10_ = _tmp9_;
#line 41 "../src/page-view.vala"
			_tmp6_ = !_tmp10_;
#line 5350 "page-view.c"
		} else {
#line 41 "../src/page-view.vala"
			_tmp6_ = FALSE;
#line 5354 "page-view.c"
		}
#line 41 "../src/page-view.vala"
		_tmp0_ = _tmp6_;
#line 5358 "page-view.c"
	}
#line 41 "../src/page-view.vala"
	if (_tmp0_) {
#line 42 "../src/page-view.vala"
		return;
#line 5364 "page-view.c"
	}
#line 43 "../src/page-view.vala"
	_tmp11_ = page_view_get_selected (self);
#line 43 "../src/page-view.vala"
	_tmp12_ = _tmp11_;
#line 43 "../src/page-view.vala"
	page_view_set_selected (self, _tmp12_);
#line 44 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 39 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY]);
#line 5376 "page-view.c"
}


gint
page_view_get_x_offset (PageView* self)
{
	gint result;
	gint _tmp0_;
#line 64 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 64 "../src/page-view.vala"
	_tmp0_ = self->priv->_x_offset;
#line 64 "../src/page-view.vala"
	result = _tmp0_;
#line 64 "../src/page-view.vala"
	return result;
#line 5393 "page-view.c"
}


void
page_view_set_x_offset (PageView* self,
                        gint value)
{
#line 64 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/page-view.vala"
	if (page_view_get_x_offset (self) != value) {
#line 64 "../src/page-view.vala"
		self->priv->_x_offset = value;
#line 64 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY]);
#line 5409 "page-view.c"
	}
}


gint
page_view_get_y_offset (PageView* self)
{
	gint result;
	gint _tmp0_;
#line 65 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 65 "../src/page-view.vala"
	_tmp0_ = self->priv->_y_offset;
#line 65 "../src/page-view.vala"
	result = _tmp0_;
#line 65 "../src/page-view.vala"
	return result;
#line 5427 "page-view.c"
}


void
page_view_set_y_offset (PageView* self,
                        gint value)
{
#line 65 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/page-view.vala"
	if (page_view_get_y_offset (self) != value) {
#line 65 "../src/page-view.vala"
		self->priv->_y_offset = value;
#line 65 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY]);
#line 5443 "page-view.c"
	}
}


GdkCursorType
page_view_get_cursor (PageView* self)
{
	GdkCursorType result;
	GdkCursorType _tmp0_;
#line 76 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 76 "../src/page-view.vala"
	_tmp0_ = self->priv->_cursor;
#line 76 "../src/page-view.vala"
	result = _tmp0_;
#line 76 "../src/page-view.vala"
	return result;
#line 5461 "page-view.c"
}


static void
page_view_set_cursor (PageView* self,
                      GdkCursorType value)
{
#line 76 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/page-view.vala"
	if (page_view_get_cursor (self) != value) {
#line 76 "../src/page-view.vala"
		self->priv->_cursor = value;
#line 76 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY]);
#line 5477 "page-view.c"
	}
}


gint
page_view_get_width (PageView* self)
{
	gint result;
	gint _tmp0_;
#line 954 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 954 "../src/page-view.vala"
	_tmp0_ = self->priv->width_;
#line 954 "../src/page-view.vala"
	result = _tmp0_;
#line 954 "../src/page-view.vala"
	return result;
#line 5495 "page-view.c"
}


void
page_view_set_width (PageView* self,
                     gint value)
{
	gint h = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
	gint _tmp10_;
#line 955 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 958 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 958 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 958 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 958 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 958 "../src/page-view.vala"
	_tmp4_ = page_get_width (_tmp3_);
#line 958 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 958 "../src/page-view.vala"
	h = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
#line 959 "../src/page-view.vala"
	_tmp7_ = self->priv->width_;
#line 959 "../src/page-view.vala"
	if (_tmp7_ == value) {
#line 5533 "page-view.c"
		gint _tmp8_;
		gint _tmp9_;
#line 959 "../src/page-view.vala"
		_tmp8_ = self->priv->height_;
#line 959 "../src/page-view.vala"
		_tmp9_ = h;
#line 959 "../src/page-view.vala"
		_tmp6_ = _tmp8_ == _tmp9_;
#line 5542 "page-view.c"
	} else {
#line 959 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 5546 "page-view.c"
	}
#line 959 "../src/page-view.vala"
	if (_tmp6_) {
#line 960 "../src/page-view.vala"
		return;
#line 5552 "page-view.c"
	}
#line 962 "../src/page-view.vala"
	self->priv->width_ = value;
#line 963 "../src/page-view.vala"
	_tmp10_ = h;
#line 963 "../src/page-view.vala"
	self->priv->height_ = _tmp10_;
#line 966 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 968 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 969 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 955 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY]);
#line 5568 "page-view.c"
}


gint
page_view_get_height (PageView* self)
{
	gint result;
	gint _tmp0_;
#line 975 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 975 "../src/page-view.vala"
	_tmp0_ = self->priv->height_;
#line 975 "../src/page-view.vala"
	result = _tmp0_;
#line 975 "../src/page-view.vala"
	return result;
#line 5585 "page-view.c"
}


void
page_view_set_height (PageView* self,
                      gint value)
{
	gint w = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp10_;
#line 976 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 979 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 979 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 979 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 979 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 979 "../src/page-view.vala"
	_tmp4_ = page_get_height (_tmp3_);
#line 979 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 979 "../src/page-view.vala"
	w = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
#line 980 "../src/page-view.vala"
	_tmp7_ = self->priv->width_;
#line 980 "../src/page-view.vala"
	_tmp8_ = w;
#line 980 "../src/page-view.vala"
	if (_tmp7_ == _tmp8_) {
#line 5626 "page-view.c"
		gint _tmp9_;
#line 980 "../src/page-view.vala"
		_tmp9_ = self->priv->height_;
#line 980 "../src/page-view.vala"
		_tmp6_ = _tmp9_ == value;
#line 5632 "page-view.c"
	} else {
#line 980 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 5636 "page-view.c"
	}
#line 980 "../src/page-view.vala"
	if (_tmp6_) {
#line 981 "../src/page-view.vala"
		return;
#line 5642 "page-view.c"
	}
#line 983 "../src/page-view.vala"
	_tmp10_ = w;
#line 983 "../src/page-view.vala"
	self->priv->width_ = _tmp10_;
#line 984 "../src/page-view.vala"
	self->priv->height_ = value;
#line 987 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 989 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 990 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 976 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY]);
#line 5658 "page-view.c"
}


static void
page_view_class_init (PageViewClass * klass)
{
#line 26 "../src/page-view.vala"
	page_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/page-view.vala"
	g_type_class_adjust_private_offset (klass, &PageView_private_offset);
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_page_view_get_property;
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_page_view_set_property;
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->finalize = page_view_finalize;
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_PAGE_PROPERTY, page_view_properties[PAGE_VIEW_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_SELECTED_PROPERTY, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_X_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_Y_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY] = g_param_spec_int ("y-offset", "y-offset", "y-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_CURSOR_PROPERTY, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY] = g_param_spec_enum ("cursor", "cursor", "cursor", gdk_cursor_type_get_type (), GDK_ARROW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_WIDTH_PROPERTY, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_HEIGHT_PROPERTY, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 26 "../src/page-view.vala"
	page_view_signals[PAGE_VIEW_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5693 "page-view.c"
}


static void
page_view_instance_init (PageView * self)
{
#line 26 "../src/page-view.vala"
	self->priv = page_view_get_instance_private (self);
#line 32 "../src/page-view.vala"
	self->priv->image = NULL;
#line 35 "../src/page-view.vala"
	self->priv->selected_ = FALSE;
#line 48 "../src/page-view.vala"
	self->priv->border_width = 1;
#line 51 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 76 "../src/page-view.vala"
	self->priv->_cursor = GDK_ARROW;
#line 78 "../src/page-view.vala"
	self->priv->animate_n_segments = 7;
#line 5714 "page-view.c"
}


static void
page_view_finalize (GObject * obj)
{
	PageView * self;
	Page* _tmp0_;
	guint _tmp1_;
	Page* _tmp2_;
	guint _tmp3_;
	Page* _tmp4_;
	guint _tmp5_;
	Page* _tmp6_;
	guint _tmp7_;
	Page* _tmp8_;
	guint _tmp9_;
#line 26 "../src/page-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_VIEW, PageView);
#line 97 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 97 "../src/page-view.vala"
	g_signal_parse_name ("pixels-changed", TYPE_PAGE, &_tmp1_, NULL, FALSE);
#line 97 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
#line 98 "../src/page-view.vala"
	_tmp2_ = self->priv->_page;
#line 98 "../src/page-view.vala"
	g_signal_parse_name ("size-changed", TYPE_PAGE, &_tmp3_, NULL, FALSE);
#line 98 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
#line 99 "../src/page-view.vala"
	_tmp4_ = self->priv->_page;
#line 99 "../src/page-view.vala"
	g_signal_parse_name ("crop-changed", TYPE_PAGE, &_tmp5_, NULL, FALSE);
#line 99 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
#line 100 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 100 "../src/page-view.vala"
	g_signal_parse_name ("scan-line-changed", TYPE_PAGE, &_tmp7_, NULL, FALSE);
#line 100 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
#line 101 "../src/page-view.vala"
	_tmp8_ = self->priv->_page;
#line 101 "../src/page-view.vala"
	g_signal_parse_name ("scan-direction-changed", TYPE_PAGE, &_tmp9_, NULL, FALSE);
#line 101 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
#line 29 "../src/page-view.vala"
	_g_object_unref0 (self->priv->_page);
#line 32 "../src/page-view.vala"
	_g_object_unref0 (self->priv->image);
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (page_view_parent_class)->finalize (obj);
#line 5770 "page-view.c"
}


GType
page_view_get_type (void)
{
	static volatile gsize page_view_type_id__volatile = 0;
	if (g_once_init_enter (&page_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageView), 0, (GInstanceInitFunc) page_view_instance_init, NULL };
		GType page_view_type_id;
		page_view_type_id = g_type_register_static (G_TYPE_OBJECT, "PageView", &g_define_type_info, 0);
		PageView_private_offset = g_type_add_instance_private (page_view_type_id, sizeof (PageViewPrivate));
		g_once_init_leave (&page_view_type_id__volatile, page_view_type_id);
	}
	return page_view_type_id__volatile;
}


static void
_vala_page_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
#line 26 "../src/page-view.vala"
	switch (property_id) {
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_PAGE_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_object (value, page_view_get_page (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_SELECTED_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_boolean (value, page_view_get_selected (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_X_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_x_offset (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_y_offset (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_CURSOR_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_enum (value, page_view_get_cursor (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_WIDTH_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_width (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_HEIGHT_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_height (self));
#line 26 "../src/page-view.vala"
		break;
#line 5841 "page-view.c"
		default:
#line 26 "../src/page-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/page-view.vala"
		break;
#line 5847 "page-view.c"
	}
}


static void
_vala_page_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
#line 26 "../src/page-view.vala"
	switch (property_id) {
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_PAGE_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_page (self, g_value_get_object (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_SELECTED_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_selected (self, g_value_get_boolean (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_X_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_x_offset (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_y_offset (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_CURSOR_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_cursor (self, g_value_get_enum (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_WIDTH_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_width (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_HEIGHT_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_height (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 5904 "page-view.c"
		default:
#line 26 "../src/page-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/page-view.vala"
		break;
#line 5910 "page-view.c"
	}
}



